﻿/// <reference name="MicrosoftAjax.js"/>

//Depends on jqueryUI ( JavaScript Files: jquery.js, ui.core.js, ui.datepicker.js )

Type.registerNamespace("JData");


JData.DateTimeCell = function(element) {
    JData.DateTimeCell.initializeBase(this, new Array(element));
}

JData.DateTimeCell.prototype = {
    createControl: function() {
        var control = JData.DateTimeCell.callBaseMethod(this, 'createControl', null);
        Sys.Debug.assert(control != null);
        $(control).datepicker({ showButtonPanel: true, duration: '', dateFormat: 'yy-mm-dd',
            beforeShow: function(i, e) {
                var z = jQuery(i).closest(".ui-dialog").css("z-index") + 4;
                e.dpDiv.css('z-index', z);
            }
        });
        return control;
    }
}

JData.DateTimeCell.registerClass('JData.DateTimeCell', JData.TextBoxCell);



JData.DateTimeField = function(field, headerText, itemWidth, controlWidth, readOnly) {
    /// <param name="field" type="String" mayBeNull="true">
    /// The name of the data field to bind to the BoundField object.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    /// <param name="controlWidth" type="String" mayBeNull="true">
    /// The with of any control generated by a cell that generated by a data control field.
    /// </param>
    /// <param name="readOnly" type="Boolean" mayBeNull="true"/>
    JData.DateTimeField.initializeBase(this, [field, headerText, itemWidth, controlWidth, readOnly]);
    this.set_formatString('yy-mm-dd');
}

JData.DateTimeField.prototype = {
    get_cellType: function() {
        return JData.DateTimeCell
    },
    formatValue: function(value) {
        return $.datepicker.formatDate(this.get_formatString(), value);
    },
    parseValue: function(value) {
        var result = $.datepicker.parseDate(this.get_formatString(), value);
        return result;
    },
    get_formatString: function() {
        return this._formatString;
    },
    set_formatString: function(value) {
        this._formatString = value;
    }

};

JData.DateTimeField.registerClass('JData.DateTimeField', JData.BoundField);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
