﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace("JData");

(function() {

    JData.ExpandButtonCell = function(element) {
        JData.ExpandButtonCell.initializeBase(this, [element]);

        this._expanded = false;
    }

    JData.ExpandButtonCell.prototype = {
        get_button: function() {
            return this._button;
        },

        get_expanded: function() {
            return this._expanded;
        },

        get_label: function() {
            return this._label;
        },

        expand: function() {
            var col = this.get_containingField();
            var h = this._expanded ? col.get_events().getHandler('collapsing') : h = col.get_events().getHandler('expanding');
            if (h) h(col, { cell: this });

            this._expanded = !this._expanded;
            this._setButtonStyle();

            h = this._expanded ? h = col.get_events().getHandler('expanded') : h = col.get_events().getHandler('collapsed');
            if (h) h(col, { cell: this });
        },

        _createExpandButton: function() {
            var cell = this;
            var col = this.get_containingField();
            this._expandButton = document.createElement('span');
            this._setButtonStyle();
            var url = document.createElement('a');
            url.href = 'javascript:';
            url.appendChild(this._expandButton);
            this.get_element().appendChild(url);

            $addHandler(url, 'click', function(args) {
                cell.expand();
            });
        },

        _setButtonStyle: function() {
            this._expandButton.style.cssText = this._expandButton.style.cssText + ';float:left';
            if (this.get_expanded() == false) {
                this._expandButton.className = 'ui-icon ui-icon-plus';
            }
            else {
                this._expandButton.className = 'ui-icon ui-icon-minus';
            }
        },

        initialize: function() {
            this._createExpandButton();
            JData.ExpandButtonCell.callBaseMethod(this, 'initialize');
        },
        dispose: function() {
            //Add custom dispose actions here
            JData.ExpandButtonCell.callBaseMethod(this, 'dispose');
        }
    };

    JData.ExpandButtonCell.registerClass('JData.ExpandButtonCell', JData.DataControlFieldCell);

    if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
})();

JData.ExpandButtonColumn = function() {
    JData.ExpandButtonColumn.initializeBase(this, null);
}

JData.ExpandButtonColumn.prototype = {
    get_cellType: function(gridRow) {
        return JData.ExpandButtonCell;
    },

    get_events: function() {
        if (this._events == null)
            this._events = new Sys.EventHandlerList();

        return this._events;
    },

    add_collapsed: function(handler) {
        this.get_events().addHandler('collapsed', handler);
    },
    remove_collapsed: function(handler) {
        this.get_events().removeHandler('collapsed', handler);
    },

    add_collapsing: function(handler) {
        this.get_events().addHandler('collapsing', handler);
    },
    remove_collapsing: function(handler) {
        this.get_events().removeHandler('collapsing', handler);
    },

    add_expanding: function(handler) {
        this.get_events().addHandler('expanding', handler);
    },
    remove_expanding: function(handler) {
        this.get_events().removeHandler('expanding', handler);
    },

    add_expanded: function(handler) {
        this.get_events().addHandler('expanded', handler);
    },
    remove_expanded: function(handler) {
        this.get_events().removeHandler('expanded', handler);
    },

    initialize: function() {
        JData.ExpandButtonColumn.callBaseMethod(this, 'initialize');
    },
    dispose: function() {
        //Add custom dispose actions here
        JData.ExpandButtonColumn.callBaseMethod(this, 'dispose');
    }
}
JData.ExpandButtonColumn.registerClass('JData.ExpandButtonColumn', JData.DataControlField);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
