﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace("JData");

JData.ExpressionCell = function(element) {
    JData.ExpressionCell.initializeBase(this, new Array(element));
}

JData.ExpressionCell.prototype = {
    get_contentContainer: function() {
        return this._contentContainer;
    },
    initialize: function() {
        JData.ExpressionCell.callBaseMethod(this, 'initialize');
        this._contentContainer = document.createElement('span');
        this.get_element().appendChild(this._contentContainer);
        var d = data = this.get_row().get_dataItem();
        var expression = this.get_containingField().get_expression();
        var value = eval(expression);
        this.set_value(value);
    }
}
JData.ExpressionCell.registerClass('JData.ExpressionCell', JData.DataControlFieldCell);


JData.ExpressionField = function(expression, headerText, itemWidth) {
    /// <param name="expression" type="String" mayBeNull="true">
    /// Sets the expression used to calculate the values in a column.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    JData.ExpressionField.initializeBase(this);

    if (expression != null)
        this.set_expression(expression)
    if (headerText != null)
        this.set_headerText(headerText);
    if (itemWidth != null)
        this.get_itemStyle().set_width(itemWidth);

}

JData.ExpressionField.prototype = {
    get_cellType: function() {
        return JData.ExpressionCell;
    },
    _set_owner: function(value) {
        var col = this;
        value.add_cellValueChanged(function(sender, args) {
            var row = args.cell.get_parent();
            var grid = row.get_parent();
            var index = Array.indexOf(grid._fields(), col);
            var cell = row.get_cells()[index];
            if (cell != null) {
                var d = data = row.get_dataItem();
                var expression = col.get_expression();
                var value = eval(expression);
                cell.set_value(value);
            }
        });
    },
    get_expression: function() {
        /// <summary>
        /// Gets the expression used to calculate the values in a column.
        /// </summary>
        /// <returns type="String"/>
        return this._expression;
    },
    set_expression: function(value) {
        /// <summary>
        /// Sets the expression used to calculate the values in a column.
        /// </summary>
        /// <param name="value" type="String"/>
        this._expression = value;
    },
    get_dataFormatString: function() {
        /// <summary>
        /// Gets the string that specifies the display format for the value of the field.
        /// </summary>
        /// <return type="String"/>
        return this._dataFormatString;
    },
    set_dataFormatString: function(value) {
        /// <summary>
        /// Sets the string that specifies the display format for the value of the field.
        /// </summary>
        /// <param name="value" type="String"/>
        this._dataFormatString = value;
    }
};

JData.ExpressionField.registerClass('JData.ExpressionField', JData.DataControlField);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();
