﻿

Type.registerNamespace("JData");

JData.GroupColumn = function(field, headerText, itemWidth, controlWidth, readOnly) {
    /// <param name="field" type="String" mayBeNull="true">
    /// The name of the data field to bind to the BoundField object.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    /// <param name="controlWidth" type="String" mayBeNull="true">
    /// The with of any control generated by a cell that generated by a data control field.
    /// </param>
    /// <param name="readOnly" type="Boolean" mayBeNull="true"/>

    JData.GroupColumn.initializeBase(this, [field, headerText, itemWidth, controlWidth, readOnly]);
    //this.set_readOnly(true);
};

JData.GroupColumn.prototype = {
    _CreateCell: function(gridRow) {
        //throw Error.notImplemented();
        var dataItem = gridRow.get_dataItem();
        var dataField = this.get_dataField();
        Sys.Debug.assert(dataItem != null);
        Sys.Debug.assert(dataField != null);

        if (this.cell != null && this.cell.get_value() == dataItem[dataField]) {
            this.cell.get_element().rowSpan = this.cell.get_element().rowSpan + 1;
            return null;
        }
        this.cell = JData.GroupColumn.callBaseMethod(this, '_CreateCell', new Array(gridRow));
        return this.cell;
    },
    get_readOnly: function() {
        return true;
    }
};

JData.GroupColumn.registerClass('JData.GroupColumn', JData.BoundField);