﻿/// <reference name="MicrosoftAjax.js"/>

Type.registerNamespace("JData");

//=========================== GroupHeaderTop ===========================

JData.GroupHeaderTop = function(element) {
    if (element == null)
        throw Error.argumentNull('element');

    JData.GroupHeaderTop.initializeBase(this, [element]);

}

JData.GroupHeaderTop.prototype = {

    get_groupItems: function() {
        /// <returns type="Array"/>
        return this._groupItems;
    },
    set_groupItems: function(groupItems) {
        /// <param name="items" type="Array"/>
        this._groupItems = groupItems;
    },

    _createCells: function() {
        var gridView = this.get_parent();
        var row = this;
        var columns = gridView.getVisibleColumns();
        var groupItems = new Array();
        Array.addRange(groupItems, this.get_groupItems());
        Array.add(groupItems, new JData.GroupHeaderItem(Number.MAX_VALUE - 1, Number.MAX_VALUE, 'NULL'));

        var groupItem = groupItems.shift();
        for (var j = 0; j < columns.length; j++) {
            var column = columns[j];
            if (j < groupItem.get_start()) {
                var htmlCell = this.get_element().insertCell(this.get_element().cells.length)
                cell = column._CreateHeaderCell(htmlCell);
                cell.get_element().rowSpan = 2;
                Array.add(this.get_cells(), cell);
            }
            else if (j >= groupItem.get_start() && j < groupItem.get_end()) {
                continue;
            }
            else if (j = groupItem.get_end()) {
                var rowElement = this.get_element();
                var cellElement = rowElement.insertCell(rowElement.cells.length);
                var cell = $create(JData.TableCell, null, null, null, cellElement);
                cell.get_element().colSpan = groupItem.get_end() - groupItem.get_start() + 1;
                cell.set_text(groupItem.get_text());
                groupItem = groupItems.shift();
            }
            else
                throw Error.argumentOutOfRange(j);
        }
    },

    initialize: function() {
        JData.GroupHeaderTop.callBaseMethod(this, 'initialize');

        // Add custom initialization here
    },
    dispose: function() {
        //Add custom dispose actions here
        JData.GroupHeaderTop.callBaseMethod(this, 'dispose');
    }
}
JData.GroupHeaderTop.registerClass('JData.GroupHeaderTop', JData.GridViewHeaderRow);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();

//=========================== GroupHeaderBottom ===========================

JData.GroupHeaderBottom = function(element) {
    if (element == null)
        throw Error.argumentNull('element');

    JData.GroupHeaderBottom.initializeBase(this, [element]);

}

JData.GroupHeaderBottom.prototype = {

    get_groupItems: function() {
        /// <returns type="Array"/>
        return this._groupItems;
    },
    set_groupItems: function(groupItems) {
        /// <param name="items" type="Array"/>
        this._groupItems = groupItems;
    },

    _createCells: function() {
        var gridView = this.get_parent();
        var row = this;
        var columns = gridView.getVisibleColumns();
        var groupItems = new Array();
        Array.addRange(groupItems, this.get_groupItems());
        Array.add(groupItems, new JData.GroupHeaderItem(Number.MAX_VALUE - 1, Number.MAX_VALUE, 'NULL'));

        var groupItem = groupItems.shift();
        for (var j = 0; j < columns.length; j++) {
            var column = columns[j];
            if (j < groupItem.get_start()) {
                continue;
            }
            else if (j >= groupItem.get_start() && j <= groupItem.get_end()) {
                var htmlCell = this.get_element().insertCell(this.get_element().cells.length)
                cell = column._CreateHeaderCell(htmlCell);
                //cell.get_element().colSpan = groupItem.get_end() - groupItem.get_start() + 1;
                Array.add(this.get_cells(), cell);
                if (j == groupItem.get_end())
                    groupItem = groupItems.shift();
            }
            else
                throw Error.argumentOutOfRange(j);
        }
    },

    initialize: function() {
        JData.GroupHeaderBottom.callBaseMethod(this, 'initialize');

        // Add custom initialization here
    },
    dispose: function() {
        //Add custom dispose actions here
        JData.GroupHeaderBottom.callBaseMethod(this, 'dispose');
    }
}
JData.GroupHeaderBottom.registerClass('JData.GroupHeaderBottom', JData.GridViewHeaderRow);

if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();

//=========================== GroupHeaderItem ===========================

JData.GroupHeaderItem = function(start, end, text) {
    /// <param name="start" type="Number">
    /// </param>
    /// <param name="end" type="Number">
    /// </param>
    /// <param name="name" type="String">
    /// </param>
    this._start = start;
    this._end = end;
    this._text = text;
};

JData.GroupHeaderItem.prototype = {
    get_start: function() {
        return this._start;
    },
    set_start: function(value) {
        this._start = value;
    },

    get_end: function() {
        return this._end;
    },
    set_end: function(value) {
        this._end = value;
    },

    get_text: function() {
        return this._text;
    },
    set_text: function(value) {
        this._text = value;
    }
};

JData.GroupHeaderItem.registerClass('JData.GroupHeaderItem');

//=======================================================================
JData.GroupHeader = {};

JData.GroupHeader.applyTo = function(gridView, groupItems) {
    /// <param name="gridView" type="JData.GridView"/>
    /// <param name="groupItems" type="Array"/>

    if (gridView == null) throw Error.argumentNull('gridView');

    var orgMethod = gridView._CreateHeader;
    var newMethod = function() {
        if (gridView.get_showHeader()) {
            //Disable display the header.
            gridView.set_showHeader(false);
            orgMethod.apply(gridView, new Array());

            var properties = { rowType: JData.DataControlRowType.Header, groupItems: groupItems };
            var index = gridView.get_headerRows().length;
            var row = gridView._CreateRow(index, properties, JData.GroupHeaderTop);
            var style = gridView._GetRowStyle(row);
            row.applyStyle(style);

            index = gridView.get_headerRows().length;
            row = gridView._CreateRow(index, properties, JData.GroupHeaderBottom);
            var style = gridView._GetRowStyle(row);
            row.applyStyle(style);
            gridView.set_showHeader(true);
        }
        else {
            orgMethod.apply(gridView, new Array());
        }
    }
    gridView._CreateHeader = newMethod;
}
