﻿/// <reference name="MicrosoftAjax.js"/>
Type.registerNamespace("JData");

JData.NumberColumn = function(headerText, itemWidth) {
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>

    JData.NumberColumn.initializeBase(this);

    if (headerText != null)
        this.set_headerText(headerText);
    if (itemWidth != null)
        this.get_itemStyle().set_width(itemWidth);

    //===================== Inner Class =============================

    JData.NumberCell = function(element) {
        JData.NumberCell.initializeBase(this, new Array(element));
    };

    JData.NumberCell.prototype = {
        initialize: function() {
            var index = this.get_parent().get_rowIndex() + 1;
            this.get_element().innerHTML = index;
        }
    };

    JData.NumberCell.registerClass('JData.NumberCell', JData.DataControlFieldCell);

    //===============================================================
};

JData.NumberColumn.prototype = {
    get_cellType: function() {
        return JData.NumberCell;
    }
};

JData.NumberColumn.registerClass('JData.NumberColumn', JData.DataControlField);

