﻿/*
 * JData v0.9.0
 * This software license is under GPL and Ms-PL.
 * Copyright (c) 2010 Shu Mai
 *
 */

Type.registerNamespace("JData");

//======================= DataControlRowState =======================
JData.DataControlRowState = function() {
    /// <field name="Normal" type="Number" integer="true" static="true"/>
    /// <field name="Alternate" type="Number" integer="true" static="true"/>
    /// <field name="Selected" type="Number" integer="true" static="true"/>
    /// <field name="Edit" type="Number" integer="true" static="true"/>
    /// <field name="Insert" type="Number" integer="true" static="true"/>
};

JData.DataControlRowState.prototype = {
    Normal: 1,
    Alternate: 2,
    Selected: 4,
    Edit: 8,
    Insert: 16
};
JData.DataControlRowState.registerEnum('JData.DataControlRowState', true);

//======================= DataControlRowType =======================

JData.DataControlRowType = function() {
    /// <field name="Header" type="Number" integer="true" static="true"/>
    /// <field name="Footer" type="Number" integer="true" static="true"/>
    /// <field name="DataRow" type="Number" integer="true" static="true"/>
    /// <field name="Separator" type="Number" integer="true" static="true"/>
    /// <field name="Pager" type="Number" integer="true" static="true"/>
    /// <field name="EmptyDataRow" type="Number" integer="true" static="true"/>
    /// <field name="Caption" type="Number" integer="true" static="true"/>
};

JData.DataControlRowType.prototype = {
    Header: 0,
    Footer: 1,
    DataRow: 2//,
    //    Separator: 3,
    //    Pager: 4,
    //    EmptyDataRow: 5
};
JData.DataControlRowType.registerEnum('JData.DataControlRowType', true);

//======================= DataControlCellType =======================

JData.DataControlCellType = function() { };

JData.DataControlCellType.prototype = {
    Header: 0,
    Footer: 1,
    DataCell: 1
};
JData.DataControlCellType.registerEnum('JData.DataControlCellType', true);

//======================= GridLines ===========================

JData.GridLines = function() {
    /// <field name="None" type="Number" static="true"/>
    /// <field name="Horizontal" type="Number" static="true"/>
    /// <field name="Vertical" type="Number" static="true"/>
    /// <field name="Both" type="Number" static="true"/>
};

JData.GridLines.prototype = {
    None: 0,
    Horizontal: 1,
    Vertical: 2,
    Both: 3
};

JData.GridLines.registerEnum('JData.GridLines', true);

//======================= HorizontalAlign ===========================

JData.HorizontalAlign = function() {
    /// <field name="NotSet" type="Number" static="true"/>
    /// <field name="Left" type="Number" static="true"/>
    /// <field name="Center" type="Number" static="true"/>
    /// <field name="Right" type="Number" static="true"/>
    /// <field name="Justify" type="Number" static="true"/>
};

JData.HorizontalAlign.prototype = {
    NotSet: 0,
    Left: 1,
    Center: 2,
    Right: 3,
    Justify: 4

};

JData.HorizontalAlign.registerEnum('JData.HorizontalAlign', true);

//======================= PagerButtons ===========================

JData.PagerButtons = function() {
    /// <field name="NextPrevious" type="Number" integer="true" static="true"/>
    /// <field name="Numeric" type="Number" integer="true" static="true"/>
    /// <field name="NextPreviousFirstLast" type="Number" integer="true" static="true"/>
    /// <field name="NumericFirstLast" type="Number" integer="true" static="true"/>
};

JData.PagerButtons.prototype = {
    NextPrevious: 0,
    Numeric: 1,
    NextPreviousFirstLast: 2,
    NumericFirstLast: 3
};

JData.PagerButtons.registerEnum('JData.PagerButtons', true);

//======================= PagerPosition ===========================

JData.PagerPosition = function() {
    /// <field name="Bottom" type="Number" integer="true" static="true"/>
    /// <field name="Top" type="Number" integer="true" static="true"/>
    /// <field name="TopAndBottom" type="Number" integer="true" static="true"/>
};

JData.PagerPosition.prototype = {
    Bottom: 1,
    Top: 2,
    TopAndBottom: 3
};

JData.PagerPosition.registerEnum('JData.PagerPosition', true);

//======================= PagerPosition ===========================

JData.CommandPosition = function() {
    /// <field name="Bottom" type="Number" integer="true" static="true"/>
    /// <field name="Top" type="Number" integer="true" static="true"/>
    /// <field name="TopAndBottom" type="Number" integer="true" static="true"/>
};

JData.CommandPosition.prototype = {
    Bottom: 1,
    Top: 2,
    TopAndBottom: 3
};

JData.CommandPosition.registerEnum('JData.CommandPosition', true);

//======================= DetailsViewMode ===========================

JData.DetailsViewMode = function() {
    /// <field name="ReadOnly" type="Number" integer="true" static="true"/>
    /// <field name="Edit" type="Number" integer="true" static="true"/>
    /// <field name="Insert" type="Number" integer="true" static="true"/>
};

JData.DetailsViewMode.prototype = {
    ReadOnly: 0,
    Edit: 1,
    Insert: 2
};

JData.DetailsViewMode.registerEnum('JData.DetailsViewMode', true);

//======================= DataMode ===========================

JData.DataMode = function() {
    /// <field name="ReadOnly" type="Number" integer="true" static="true"/>
    /// <field name="Edit" type="Number" integer="true" static="true"/>
    /// <field name="Insert" type="Number" integer="true" static="true"/>
};

JData.DataMode.prototype = {
    ReadOnly: 0,
    Edit: 1,
    Insert: 2
};

JData.DataMode.registerEnum('JData.DataMode', true);




Type.registerNamespace("JData");

JData.Error = function() {
}

JData.Error.prototype = {
}

//========================================================================

JData.Error.DataSourceView = function() {

}
JData.Error.DataSourceView.prototype = {
}

JData.Error.DataSourceView.NoPaging = function() {
    return Error.create('The data source does not support server-side data paging.');
}
JData.Error.DataSourceView.NoRowCount = function() {
    return Error.create('The data source does not support retrieving the number of rows of data.');
}
JData.Error.DataSourceView.NoSorting = function() {
    return Error.create('The data source does not support sorting.');
}



Type.registerNamespace("JData");

JData.FontInfo = function() {
}

JData.FontInfo.prototype = {
    get_bold: function() {
        /// <returns type="Boolean">
        /// Gets a value that indicates whether the font is bold.
        /// </returns>
        return this._bold;
    },
    set_bold: function(value) {
        /// <param name="value" type="Boolean">
        /// Sets a value that indicates whether the font is bold.
        /// </param>
        this._bold = value;
    },

    get_italic: function() {
        /// <returns type="Boolean">
        /// Gets a value that indicates whether the font is italic.
        /// </returns>
        return this._italic;
    },
    set_italic: function(value) {
        /// <param name="value" type="Boolean">
        /// Sets a value that indicates whether the font is italic.
        /// </param>
        this._italic = value;
    },

    get_name: function() {
        /// <returns type="String">
        /// Gets the primary font name.
        /// </returns>
        return this._name;
    },
    set_name: function(value) {
        /// <param name="value" type="String">
        /// Sets the primary font name.
        /// </param>
        this._name = value;
    },

    get_names: function() {
        /// <returns type="Array">
        /// Gets an ordered array of font names.
        /// </returns>
        return this._names;
    },
    set_names: function(value) {
        /// <param name="value" type="Array">
        /// Sets an ordered array of font names.
        /// </param>
        this._names = value;
    },

    get_overline: function() {
        /// <returns type="Boolean">
        /// Gets a value that indicates whether the font is overlined.
        /// </returns>
        return this._overline;
    },
    set_overline: function(value) {
        /// <param name="value">
        /// Sets a value that indicates whether the font is overlined.
        /// </param>
        this._overline = value;
    },

    get_size: function() {
        /// <returns type="String">
        /// Gets the font size.
        /// </returns>
        return this._size;
    },
    set_size: function(value) {
        /// <param name="value" type="String">
        ///  Sets the font size.
        /// </param>
        this._size = value;
    },

    get_strikeout: function() {
        /// <returns type="Boolean">
        /// Gets a value that indicates whether the font is strikethrough.
        /// </returns>
        return this._strikeout;
    },
    set_strikeout: function(value) {
        /// <param name="value" type="boolean">
        /// Sets a value that indicates whether the font is strikethrough.
        /// </param>
        this._strikeout = value;
    },

    get_underline: function() {
        /// <returns type="Boolean">
        /// Gets a value that indicates whether the font is underlined.
        /// </returns>
        return this._underline;
    },
    set_underline: function(value) {
        /// <param name="value" type="Boolean">
        /// Sets a value that indicates whether the font is underlined.
        /// </param>
        this._underline = value;
    }

}

JData.FontInfo.registerClass('JData.FontInfo');

//================================================

JData.Style = function() {
    JData.Style.initializeBase(this);

    this._font = new JData.FontInfo();
    this._css = {};
};

JData.Style.prototype = {

    _cssProperty: function(name, value) {
        if (value == null)
            return this._css[name];

        this._css[name] = value;
    },

    get_backColor: function() {
        //return this._backColor;
        return this._cssProperty('backgroundColor');
    },
    set_backColor: function(value) {
        //this.css['backgroundColor'] = value;
        this._cssProperty('backgroundColor', value);
    },

    get_cssClass: function() {
        return this._cssClass;
    },
    set_cssClass: function(value) {
        this._cssClass = value;
    },

    get_foreColor: function() {
        /// <returns type="String">
        /// Gets the foreground color (typically the color of the text) of the Web server control.
        /// </returns>
        //return this._foreColor;
        return this._cssProperty('color');
    },
    set_foreColor: function(value) {
        /// <param name="value" type="String">
        /// Sets the foreground color (typically the color of the text) of the Web server control.
        /// </param>
        //this._foreColor = value;
        this._cssProperty('color', value);
    },

    get_height: function() {
        /// <returns type="String"/>
        //return this._height;
        return this._cssProperty('height');
    },
    set_height: function(value) {
        /// <param name="value" type="string"/>
        //this._height = value;
        this._cssProperty('height', value);
    },

    get_padding: function() {
        /// <returns type="string"/>
        //return this._padding;
        return this._cssProperty('padding');
    },
    set_padding: function(value) {
        /// <param name="value" type="string"/>
        //this._padding = value;
        this._cssProperty('padding', value);
    },

    get_textAlign: function() {
        /// <returns type="String"/>
        //return this._horizontalAlign;
        return this._cssProperty('textAlign');
    },
    set_textAlign: function(value) {
        /// <param name="value" type="String"/>
        //this._horizontalAlign = value;
        this._cssProperty('textAlign', value);
    },

    get_width: function() {
        /// <returns type="String"/>
        //return this._width;
        return this._cssProperty('width');
    },
    set_width: function(value) {
        /// <param name="value" type="String"/>
        //this._width = value;
        this._cssProperty('width', value);
    },

    mergeWith: function(style) {
        var newStyle = new JData.Style();

        if (this.get_cssClass() != undefined && this.get_cssClass() != '') {
            newStyle.set_cssClass(this.get_cssClass());
        }
        if (style.get_cssClass() != undefined && style.get_cssClass() != '') {
            if (newStyle.get_cssClass() != undefined) {
                newStyle.set_cssClass(newStyle.get_cssClass() + ' ' + style.get_cssClass());
            }
            else {
                newStyle.set_cssClass(style.get_cssClass());
            }
        }

        for (var key in this._css) {
            if (this._css[key] != undefined) {
                newStyle._css[key] = this._css[key];
            }
        }

        for (var key in style._css) {
            if (style._css[key] != undefined) {
                newStyle._css[key] = style._css[key];
            }
        }
        return newStyle;
    },

    applyTo: function(element) {

        if (this.get_cssClass() != null) {
            element.className = this.get_cssClass();
        }
        else {
            element.className = '';
        }

        for (var key in this._css) {
            element.style[key] = this._css[key];
        }
        if (this.get_backColor() != null) {
            element.style.backgroundColor = this.get_backColor();
        }
        else {
            element.style.backgroundColor = '';
        }

        //        if (this.get_font().get_bold() == true)
        //            element.style.fontWeight = 'bold';
        //        else
        //            element.style.fontWeight = '';

        //        if (this.get_font().get_size() != null)
        //            element.style.fontSize = this.get_font().get_size();
        //        else
        //            element.style.fontSize = '';

        if (this.get_foreColor() != null)
            element.style.color = this.get_foreColor();
        else
            element.style.color = '';

        if (this.get_height() != null) {
            element.style['height'] = this.get_height();
        }
        else {
            element.style['height'] = '';
        }

        if (this.get_padding() != null) {
            element.style.padding = this.get_padding();
        }
        else {
            element.style.padding = '';
        }

        if (this.get_textAlign() != null) {
            element.style['textAlign'] = this.get_textAlign();
        }
        else {
            element.style['textAlign'] = '';
        }

        if (this.get_width() != null) {
            element.style['width'] = this.get_width();
        }
        else {
            element.style['width'] = '';
        }
    }
};

JData.Style.registerClass('JData.Style', Sys.Component);

//============================= TableItemStyle =============================

JData.TableItemStyle = function() {
    JData.TableItemStyle.initializeBase(this);
};

JData.TableItemStyle.prototype = {
    get_horizontalAlign: function() {
        return this._horizontalAlign;
    },
    set_horizontalAlign: function(value) {
        this._horizontalAlign = value;
    },

    get_verticalAlign: function() {
        return this._verticalAlign;
    },
    set_verticalAlign: function(value) {
        this._verticalAlign = value;
    },

    get_wrap: function() {
        return this._wrap;
    },
    set_wrap: function(value) {
        this._wrap = value;
    },

    applyTo: function(element) {

        JData.TableItemStyle.callBaseMethod(this, 'applyTo', new Array(element));

        if (this.get_horizontalAlign() != null)
            element.align = this.get_horizontalAlign();
        else
            element.align = '';

        if (this.get_verticalAlign() != null)
            element.vAlign = this.get_verticalAlign();
        else
            element.vAlign = '';
    }
};

JData.TableItemStyle.registerClass('JData.TableItemStyle', JData.Style);


/// <reference path="../Script/jquery-1.4.1-vsdoc.js"/>

Type.registerNamespace("JData");

JData.DataSource = function() {
};

JData.DataSource.prototype = {
    get_events: function() {
        if (this._events == null) {
            this._events = new Sys.EventHandlerList();
        }
        return this._events;
    },

    executeInsert: function(item, successedCallback, failedCallback) {
        /// <param name="item" type = "Object"/>
        /// <param name="successedCallback" type="Function"/>
        /// <param name="failedCallback" type="Function"/>
        throw Error.notImplemented();
    },
    executeDelete: function(item, successedCallback, failedCallback) {
        /// <param name="item" type = "Object"/>
        /// <param name="successedCallback" type="Function"/>
        /// <param name="failedCallback" type="Function"/>
        throw Error.notImplemented();
    },
    executeUpdate: function(item, success, fail) {
        throw Error.notImplemented();
    },
    executeSelect: function(args, successedCallback, failedCallback) {
        /// <param name="args" type = "JData.DataSourceSelectArguments"/>
        /// <param name="successedCallback" type="Function"/>
        /// <param name="failedCallback" type="Function"/>
        throw Error.notImplemented();
    },

    //=================== METHODS ===================

    insert: function(item, successedCallback, failedCallback) {

        var h = this.get_events().getHandler('inserting');
        if (h) h(this, { item: item });

        var dataSource = this;
        this.executeInsert(item, function() {
            if (successedCallback != null)
                successedCallback();

            h = dataSource.get_events().getHandler('inserted');
            if (h) h(dataSource, { item: item });
        }, failedCallback);
    },

    remove: function(item, successedCallback, failedCallback) {

        var h = this.get_events().getHandler('deleting');
        if (h) h(this, { item: item });

        var dataSource = this;
        this.executeDelete(item, function() {
            if (successedCallback != null)
                successedCallback();

            h = dataSource.get_events().getHandler('deleted');
            if (h) h(dataSource, { item: item });
        }, failedCallback);
    },

    update: function(item, success, fail) {

        var h = this.get_events().getHandler('updating');
        //var item = newItem;
        if (h) h(this, { item: item });

        var dataSource = this;
        var result = this.executeUpdate(item, function() {
            if (success != null)
                success();

            h = dataSource.get_events().getHandler('updated');
            if (h) h(dataSource, { item: item });
        }, fail);
    },

    select: function(args, successedCallback, failedCallback) {
        if (successedCallback == null)
            throw Error.argumentNull('successedCallback');

        var h = this.get_events().getHandler('selecting');

        if (h) h(this, { args: args });

        var dataSource = this;
        this.executeSelect(args, function(items) {
            successedCallback(items);
            h = dataSource.get_events().getHandler('selected');
            if (h) h(dataSource, { items: items, args: args });
        }, failedCallback);
    },

    //=================== EVENTS ===================

    add_deleting: function(handler) {
        this.get_events().addHandler('deleting', handler);
    },
    remove_deleting: function(handler) {
        this.get_events().removeHandler('deleting', handler);
    },

    add_deleted: function(handler) {
        this.get_events().addHandler('deleted', handler);
    },
    remove_deleted: function(handler) {
        this.get_events().removeHandler('deleted', handler);
    },

    add_inserting: function(handler) {
        this.get_events().addHandler('inserting', handler);
    },
    remove_inserting: function(handler) {
        this.get_events().removeHandler('inserting', handler);
    },

    add_inserted: function(handler) {
        this.get_events().addHandler('inserted', handler);
    },
    remove_inserted: function(handler) {
        this.get_events().removeHandler('inserted', handler);
    },

    add_updating: function(handler) {
        this.get_events().addHandler('updating', handler);
    },
    remove_updating: function(halder) {
        this.get_events().removeHandler('updating', halder);
    },

    add_updated: function(handler) {
        this.get_events().addHandler('updated', handler);
    },
    remove_updated: function(halder) {
        this.get_events().removeHandler('updated', halder);
    },

    add_selected: function(handler) {
        this.get_events().addHandler('selected', handler);
    },
    remove_selected: function(handler) {
        this.get_events().removeHandler('selected', handler);
    },

    //===============================================

    //Virtual Properties
    canDelete: function(item) {
        return false;
    },
    canInsert: function(item) {
        return false;
    },
    canPage: function() {
        return false;
    },
    canRetrieveTotalRowCount: function() {
        return false;
    },
    canSort: function() {
        return false;
    },
    canUpdate: function(item) {
        return false;
    },
    //public properties
    get_name: function() {
        return this._name;
    }
};

JData.DataSource.registerClass("JData.DataSource");

//==========================================================================

JData.DataSourceSelectArguments = function(source) {
    /// <param name="source" type="JData.DataSourceSelectArguments" mayBeNull="true"/>
    if (source != null)
        this._source(source);
    else {
        this._startRowIndex = -1;
        this._totalRowCount = -1;
        this._maximumRows = -1;
        this._retrieveTotalRowCount = false;
        this._sortExpression = null;
    }
};

JData.DataSourceSelectArguments.prototype = {

    _source: function(value) {
        /// <returns type="JData.DataSourceSelectArguments"/>
        if (value != null)
            this.__source = value;
        else
            return this.__source;
    },

    get_startRowIndex: function() {
        /// <returns type="Number"/>
        if (this._source() != null)
            return this._source().get_startRowIndex();
        else
            return this._startRowIndex;
    },
    set_startRowIndex: function(value) {
        /// <param name="value" type="Number"/>
        if (this._source() != null)
            this._source().set_startRowIndex(value);
        else
            this._startRowIndex = value;
    },

    get_totalRowCount: function() {
        /// <returns type="Number"/>
        if (this._source() != null)
            return this._source().get_totalRowCount();
        else
            return this._totalRowCount;
    },
    set_totalRowCount: function(value) {
        /// <param name="value" type="Number"/>
        if (this._source() != null)
            this._source().set_totalRowCount(value);
        else
            this._totalRowCount = value;
    },

    get_maximumRows: function() {
        /// <returns type="Number"/>
        if (this._source() != null)
            return this._source().get_maximumRows();
        else
            return this._maximumRows
    },
    set_maximumRows: function(value) {
        /// <param name="value" type="Number"/>
        if (this._source() != null)
            this._source().set_maximumRows(value);
        else
            this._maximumRows = value;
    },

    get_retrieveTotalRowCount: function() {
        /// <returns type="Boolean"/>
        if (this._source() != null)
            return this._source().get_retrieveTotalRowCount();
        else
            return this._retrieveTotalRowCount;
    },
    set_retrieveTotalRowCount: function(value) {
        /// <param name="value" type="Boolean">
        /// Gets or sets a value indicating whether a data source control should retrieve a count of all the data rows during a data retrieval operation.
        /// </param>
        if (this._source() != null)
            this._source().set_retrieveTotalRowCount(value);
        else
            this._retrieveTotalRowCount = value;
    },

    get_sortExpression: function() {
        /// <returns type="String"/>
        if (this._source() != null)
            return this._source().get_sortExpression();
        else
            return this._sortExpression;
    },
    set_sortExpression: function(value) {
        /// <param name="value" type="Number"/>
        if (this._source() != null)
            this._source().set_sortExpression(value);
        else
            this._sortExpression = value;
    }
};

JData.DataSourceSelectArguments.Empty = new JData.DataSourceSelectArguments();

JData.DataSourceSelectArguments.registerClass("JData.DataSourceSelectArguments");

//============================= ArrayDataSource =================================


JData.ArrayDataSource = function(items) {
    JData.ArrayDataSource.initializeBase(this);

    Sys.Debug.assert(Array.isInstanceOfType(items));
    this._items = items;
};
JData.ArrayDataSource.prototype = {
    executeInsert: function(item, successedCallback, failedCallback) {
        Array.add(this._items, item);
        successedCallback();
    },

    executeDelete: function(item, successedCallback, failedCallback) {
        Array.remove(this._items, item);
        successedCallback();
    },

    executeUpdate: function(item, success, fail) {
        successedCallback();
    },

    executeSelect: function(args, successedCallback, failedCallback) {
        var items = new Array();
        if (args == null || (args.get_startRowIndex() < 0 || args.get_maximumRows() <= 0)) {
            for (var i = 0; i < this._items.length; i++)
                Array.add(items, this._items[i]);
        }
        else {
            args.set_totalRowCount(this._items.length);
            var maxRows = args.get_maximumRows();
            var start = args.get_startRowIndex();

            Sys.Debug.assert(maxRows > 0);
            Sys.Debug.assert(start >= 0);

            for (var i = start; i < start + maxRows && i < this._items.length; i++)
                Array.add(items, this._items[i]);
        }
        successedCallback(items);
    },
    canDelete: function() {
        return true;
    },
    canInsert: function() {
        return true;
    },
    canUpdate: function() {
        return true;
    },
    canRetrieveTotalRowCount: function() {
        return true;
    }
};

JData.ArrayDataSource.registerClass('JData.ArrayDataSource', JData.DataSource);


//========================= PagingDataSource =============================


JData.PagingDataSource = function(source) {
    JData.PagingDataSource.initializeBase(this, new Array());
    this._source = source;

};

JData.PagingDataSource.prototype = {

    //====================== Methods ======================

    executeInsert: function(item, successedCallback, failedCallback) {
        return this._source.executeInsert(item, successedCallback, failedCallback);
    },

    executeDelete: function(item, successedCallback, failedCallback) {
        return this._source.executeDelete(item, successedCallback, failedCallback);
    },

    executeUpdate: function(item, success, fail) {
        return this._source.executeUpdate(item, successedCallback, failedCallback);
    },

    executeSelect: function(args, success, fail) {

        this._source.executeSelect(args, function(allItems) {
            args.set_totalRowCount(allItems.length);
            var maxRows = args.get_maximumRows();
            var start = args.get_startRowIndex();
            var items = new Array();
            for (var i = start; i < start + maxRows && i < allItems.length; i++) {
                Array.add(items, allItems[i]);
            }
            success(items);
        }, fail);
    },

    //====================== Properties ======================

    canRetrieveTotalRowCount: function() {
        return true;
    }
};

JData.PagingDataSource.registerClass('JData.PagingDataSource', JData.DataSource);

//========================= WebServiceDataSource =============================

JData.WebServiceDataSource = function(url, serviceSelectMethodName, serviceInsertMethodName,
                                      serviceUpdateMethodName, serviceDeleteMethodName, selector, sorting, filter) {

    JData.WebServiceDataSource.initializeBase(this);
    this.set_url(url);
    this.set_selectMethodName(serviceSelectMethodName);
    this.set_updateMethodName(serviceUpdateMethodName);
    this.set_deleteMethodName(serviceDeleteMethodName);
    this.set_insertMethodName(serviceInsertMethodName);
    this.set_selector(selector == undefined ? null : selector);
    this.set_sorting(sorting == undefined ? null : sorting);
    this.set_filter(filter == undefined ? null : filter);
    this.set_enableCache(false);
    this._cacheData = null;

};

JData.WebServiceDataSource.prototype = {
    get_url: function() {
        return this._url;
    },
    set_url: function(value) {
        this._url = value;
    },

    get_selectMethodName: function() {
        return this._selectMethodName;
    },
    set_selectMethodName: function(value) {
        this._selectMethodName = value;
    },

    _rowsCountChanged: function(value) {
        /// <param name="value" type="Boolean"/>
        if (value == null) {
            return this.$rowsCountChanged;
        }
        this.$rowsCountChanged = value;
    },

    get_selector: function() {
        return this._selector;
    },
    set_selector: function(value) {
        if (Array.isInstanceOfType(value))
            this._selector = value.join(',');
        else if (arguments.length > 1) {
            this._selector = arguments[0];
            for (var i = 1; i < arguments.length; i++)
                this._selector = this._selector + ',' + arguments[i]
        }
        else
            this._selector = value;
    },

    get_sorting: function() {
        return this._sorting;
    },
    set_sorting: function(value) {
        if (arguments.length > 1) {
            this._sorting = arguments[0];
            for (var i = 1; i < arguments.length; i++)
                this._sorting = this._selector + ',' + arguments[i]
        }
        else
            this._sorting = value;
    },

    get_filter: function() {
        return this._filter;
    },
    set_filter: function(value) {
        if (this._filter != value) {
            this._rowsCountChanged(true);
        }
        this._filter = value;
    },

    get_insertMethodName: function() {
        return this._insertMethodName;
    },
    set_insertMethodName: function(value) {
        this._insertMethodName = value;
    },

    get_updateMethodName: function() {
        return this._updateMethodName;
    },
    set_updateMethodName: function(value) {
        this._updateMethodName = value;
    },

    get_deleteMethodName: function() {
        return this._deleteMethodName;
    },
    set_deleteMethodName: function(value) {
        this._deleteMethodName = value;
    },

    canRetrieveTotalRowCount: function() {
        return true;
    },
    canPage: function() {
        return true;
    },

    get_enableCache: function() {
        /// <returns type="Boolean"/>
        return this._enableCache;
    },
    set_enableCache: function(value) {
        /// <param name="value" type="Boolean"/>
        this._enableCache = value;
    },

    _showError: function(message) {
        alert(message);
    },
    _successCallBack: function() {
        /// <returns type="Array"/>
        if (this.$successCallBack == null)
            this.$successCallBack = new Array();

        return this.$successCallBack;
    },
    _failCallBack: function() {
        /// <returns type="Array"/>
        if (this.$failCallBack == null)
            this.$failCallBack = new Array();

        return this.$failCallBack;
    },
    _loading: function(value) {
        if (value == null)
            return this.$loading;

        this.$loading = value;
    },
    _cache: function(star, count, value) {
        /// <return type="Array"/>
        if (this._cacheData == null)
            this._cacheData = new Array();

        if (star == null)
            return this._cacheData;

        if (value == null) {
            Sys.Debug.assert(count != null && count > 0);
            var result = new Array();
            for (var i = star; i < star + count && i < this._cacheData.length; i++) {
                if (this._cacheData[i] == null)
                    return result;

                Array.add(result, this._cacheData[i]);
            }
            return result;
        }

        if (star < 0) star = 0;
        for (var i = 0; i < value.length; i++) {
            this._cacheData[star + i] = value[i];
        }
    },
    executeSelect: function(args, success, fail) {

        //Sys.Debug.assert(args != null);
        if (args == null)
            args = new JData.DataSourceSelectArguments();

        //Retrive Rows Count 
        if (this._rowsCountChanged()) {
            args.set_totalRowCount(-1);
            this._rowsCountChanged(false);
        }

        var postData = {};
        postData.skip = args.get_startRowIndex();
        postData.take = args.get_maximumRows();
        postData.totalRowCount = args.get_totalRowCount();
        postData.sorting = args.get_sortExpression();

        var selector = this.get_selector();
        if (Array.isInstanceOfType(this.get_selector()))
            selector = this.get_selector().join(',');

        var filter = this.get_filter();
        if (Array.isInstanceOfType(this.get_filter()))
            filter = this.get_filter().join(',');

        var sorting = this.get_sorting();
        if (Array.isInstanceOfType(this.get_sorting()))
            sorting = this.get_sorting().join(',');

        if (sorting != null) {
            if (postData.sorting != null)
                postData.sorting = postData.sorting + ',' + sorting;
            else
                postData.sorting = sorting;
        }

        postData.selector = selector;
        postData.retrieveTotalRowCount = this.canRetrieveTotalRowCount();
        postData.filter = filter;

        var dataSource = this;
        if (dataSource.get_enableCache()) {
            var cache_items;
            if (args.get_startRowIndex() < 0) {
                cache_items = dataSource._cache();
                if (cache_items != null && cache_items.length > 0) {
                    success(cache_items);
                    return;
                }
            }
            else {
                var rowsCount = args.get_maximumRows();
                if (args.get_totalRowCount() > 0 && args.get_startRowIndex() + rowsCount > args.get_totalRowCount()) {
                    rowsCount = args.get_totalRowCount() - args.get_startRowIndex();
                    Sys.Debug.assert(rowsCount > 0 && rowsCount < args.get_maximumRows());
                }
                cache_items = dataSource._cache(args.get_startRowIndex(), rowsCount);
                if (cache_items != null && cache_items.length == rowsCount) {
                    success(cache_items);
                    return;
                }
            }
        }

        if (this._loading() == true && this.get_enableCache() == true) {
            if (success != null)
                this._successCallBack()[this._successCallBack().length] = success;
            if (fail != null)
                this._failCallBack()[this._successCallBack().length] = fail;

            return;
        }
        var dataSource = this;
        Sys.Net.WebServiceProxy.invoke(this.get_url(), this.get_selectMethodName(), false, postData,
            function(result, eventArgs) {
                Sys.Debug.assert(result != null);
                if (dataSource.get_enableCache() == true)
                    dataSource._cache(args.get_startRowIndex(), args.get_maximumRows(), result.Items); //dataSource._cacheData = result;

                if (postData.retrieveTotalRowCount) {
                    args.set_totalRowCount(result.Total);
                }
                dataSource._loading(false);
                success(result.Items);
                while (dataSource._successCallBack().length > 0) {
                    dataSource._successCallBack().pop()(result.Items);
                }
            },
            function(XMLHttpRequest, textStatus, errorThrown) {
                dataSource._loading(false);
                if (fail != null)
                    fail(XMLHttpRequest.get_message());
                else
                    dataSource._showError(XMLHttpRequest.get_message());
                while (dataSource._failCallBack().length > 0) {
                    dataSource._failCallBack().pop()(XMLHttpRequest.get_message());
                }
            });
        this._loading(true);
    },
    executeUpdate: function(item, success, fail) {
        var dataSource = this;
        Sys.Net.WebServiceProxy.invoke(this.get_url(), this.get_updateMethodName(), false, { item: item },
        function(result, eventArgs) {
            if (result.AffectedRowCount > 0)
                success(result);
            else {
                if (fail != null)
                    fail(result.Message);
                else
                    alert(result.Message);
            }
        },
        function(error) {
            if (fail != null)
                fail(error.get_message());
            else
                dataSource._showError(error.get_message());
        });
    },
    executeDelete: function(item, success, fail) {
        var dataSource = this;
        Sys.Net.WebServiceProxy.invoke(this.get_url(), this.get_deleteMethodName(), false, { item: item },
        function(result, eventArgs) {
            var cache_items = dataSource._cache();
            for (var i = 0; i < cache_items.length; i++) {
                if (cache_items[i] == item) {
                    Array.removeAt(cache_items, i);
                }
            }
            if (result.AffectedRowCount > 0)
                success();
            else {
                if (fail != null)
                    fail(result.Message);
                else
                    alert(result.Message);
            }
        },
        function(error) {
            if (fail != null)
                fail(error.get_message());
            else
                dataSource._showError(error.get_message());
        });
    },
    executeInsert: function(item, success, fail) {
        var dataSource = this;
        Sys.Net.WebServiceProxy.invoke(this.get_url(), this.get_insertMethodName(), false, { item: item },
        function(result, eventArgs) {
            if (result.AffectedRowCount > 0) {
                Sys.Debug.assert(result != null);
                for (var key in result.Members) {
                    item[key] = result.Members[key];
                }
                if (dataSource._cache() != null)
                    Array.add(dataSource._cache(), item);

                success();
            }
            else {
                if (fail != null)
                    fail(result.Message);
                else
                    alert(result.Message);
            }
        },
        function(error) {
            if (fail != null)
                fail(error.get_message());
            else
                dataSource._showError(error.get_message());
        });
    }
};

JData.WebServiceDataSource.registerClass('JData.WebServiceDataSource', JData.DataSource);

JData.MetaType = function() {

};

JData.MetaType.prototype = {
    name: function(value) {
        if (value == null)
            return this._name;

        this._name = value;
    },
    parent: function(value) {
        /// <returns type="JData.MetaType"/>
        if (value == null)
            return this._parent;

        this._parent = value;
    },
    type: function(value) {
        if (value == null)
            return this._type;

        this._type = value;
    },
    toString: function() {
        var arr = new Array();
        var p = this.parent();
        while (p != null) {
            if (p.name() != null)
                arr[arr.length] = p.name();
            p = p.parent();
        }
        arr[arr.length] = this.name();
        return arr.join('.');
    }
};

JData.MetaType.registerClass("JData.MetaType");

JData.MetaMember = function() {
    JData.MetaMember.initializeBase(this);
};

JData.MetaMember.prototype = {
    asc: function() {
        return this.toString() + ' asc';
    },
    desc: function() {
        return this.toString() + ' desc';
    },
    toString: function() {
        return JData.MetaMember.callBaseMethod(this, 'toString');
    }
};

JData.MetaMember.registerClass("JData.MetaMember", JData.MetaType);







Number.prototype.toFormattedString = function(format) {
    var reg = new RegExp('^C[0-9]+');
    if (reg.test(format)) {
        var num = format.substr(1);
        return this.toFixed(num);
    }
    return this;
}

Date.prototype.toFormattedString = function(format) {
    switch (format) {
        case 'd':
            return String.format("{0}-{1}-{2}", this.getFullYear(), this.getMonth(), this.getDate());
        case 'g':
            return String.format("{0}-{1}-{2} {3}:{4}", this.getFullYear(), this.getMonth(), this.getDate(), this.getHours(), this.getMinutes());
        case 'G':
            return String.format("{0}-{1}-{2} {3}:{4}:{5}", this.getFullYear(), this.getMonth(), this.getDate(), this.getHours(), this.getMinutes(), this.getSeconds());
        case 't':
            return String.format("{1}:{2}", this.getHours(), this.getMinutes());
        case 'T':
            return String.format("{1}:{2}:{3}", this.getHours(), this.getMinutes(), this.getSeconds());
    }
    return this.toString();
}

Type.registerNamespace("JData");

//========================== WebControl ==========================

JData.WebControl = function(element) {
    if (element == null)
        throw Error.argumentNull(element);

    JData.WebControl.initializeBase(this, new Array(element));

    this._controls = new Array();
};

JData.WebControl.prototype = {

    get_heigth: function() {
        /// <returns type="String"/>
        return this._heigth;
    },
    set_heigth: function(value) {
        /// <param name="value" type="String"/>
        this._heigth = value;
    },

    get_text: function() {
        return this.get_element().innerHTML;
    },
    set_text: function(value) {
        this.get_element().innerHTML = value;
    },

    get_visible: function() {
        return Sys.UI.DomElement.getVisible(this.get_element());
    },
    set_visible: function(value) {
        Sys.UI.DomElement.setVisible(this.get_element(), value);
    },

    get_width: function() {
        /// <returns type="String"/>
        return this._width;
    },
    set_width: function(value) {
        /// <param name="value" type="String"/>
        this._width = value;
    },

    //================ Methods =================

    clear: function() {
        this.get_element().innerHTML = '';
    },

    initialize: function() {
        this.set_visible(true);
    },

    applyStyle: function(style) {
        style.applyTo(this.get_element());
    },

    get_id: function() {
        return this._id;
    },
    set_id: function(value) {
        this._id = value;
    }

};

JData.WebControl.registerClass('JData.WebControl', Sys.UI.Control);

//========================== TableCell ==========================

JData.TableCell = function(element) {
    if (element == null)
        throw Error.argumentNull(element);

    JData.TableCell.initializeBase(this, new Array(element));
};

JData.TableCell.prototype = {

    get_row: function() {
        /// <returns type="JData.TableRow">
        return this.get_parent();
    },
    set_row: function(value) {
        this.set_parent(value);
    },
    initialize: function() {

        var row = this.get_parent();
        var table = row.get_parent();
        var cell = this;
        Sys.Debug.assert(table != null);
        this.get_element().onclick = function() {
            var h = table.get_events().getHandler('cellClick');
            if (h) h(table, { cell: cell });
        };
        this.get_element().ondblclick = function() {
            var h = table.get_events().getHandler('cellDoubleClick');
            if (h) h(table, { cell: cell });
        };
    }
};

JData.TableCell.registerClass("JData.TableCell", JData.WebControl); //JData.WebControl


//========================== DataControlFieldCell ==========================

JData.DataControlFieldCell = function(element) {
    JData.DataControlFieldCell.initializeBase(this, new Array(element));

};

JData.DataControlFieldCell.prototype = {
    get_containingField: function() {
        return this._dataControlField;
    },
    set_containingField: function(value) {
        this._dataControlField = value;
    },
    get_value: function() {
        return this._value;
    },
    set_value: function(value) {
        var row = this.get_row();
        var col = this.get_containingField();
        if (value == null)
            value = row.get_dataItem()[col.get_dataField()];

        var oldValue = this._value;
        if (value == oldValue) {
            return;
        }
        this._value = value;
        this._displayValue();
        var grid = row.get_parent();
        var h = grid.get_events().getHandler('cellValueChanged');
        if (h) h(grid, { cell: this });
    },
    get_contentContainer: function() {
        return this._contentContainer;
    },

    _displayValue: function() {
        var text;
        var value = this.get_value();

        if (this._isEdit != null && this._isEdit()) {
            this.set_controlValue(value);
            return;
        }

        if (value == null) {
            text = this.get_containingField().get_nullText();
        }
        else {
            var col = this.get_containingField();
            if (col.get_dataFormatString != null && col.get_dataFormatString() != null) {
                text = this._formattedString(true, [this.get_containingField().get_dataFormatString(), value]);
            }
            else if (col.formatValue != null)
                text = this.get_containingField().formatValue(value);
            else
                text = value;
        }
        this.get_contentContainer().innerHTML = text;

    },

    _formattedString: function(useLocale, args) {
        var result = '';
        var format = args[0];

        for (var i = 0; ; ) {
            var open = format.indexOf('{', i);
            var close = format.indexOf('}', i);
            if ((open < 0) && (close < 0)) {
                result += format.slice(i);
                break;
            }
            if ((close > 0) && ((close < open) || (open < 0))) {
                if (format.charAt(close + 1) !== '}') {
                    throw Error.argument('format', Sys.Res.stringFormatBraceMismatch);
                }
                result += format.slice(i, close + 1);
                i = close + 2;
                continue;
            }

            result += format.slice(i, open);
            i = open + 1;

            if (format.charAt(i) === '{') {
                result += '{';
                i++;
                continue;
            }

            if (close < 0) throw Error.argument('format', Sys.Res.stringFormatBraceMismatch);


            var brace = format.substring(i, close);
            var colonIndex = brace.indexOf(':');
            var argNumber = parseInt((colonIndex < 0) ? brace : brace.substring(0, colonIndex), 10) + 1;
            if (isNaN(argNumber)) throw Error.argument('format', Sys.Res.stringFormatInvalid);
            var argFormat = (colonIndex < 0) ? '' : brace.substring(colonIndex + 1);

            var arg = args[argNumber];
            if (typeof (arg) === "undefined" || arg === null) {
                arg = '';
            }

            if (arg.toFormattedString) {
                result += arg.toFormattedString(argFormat);
            }
            else if (useLocale && arg.localeFormat) {
                result += arg.localeFormat(argFormat);
            }
            else if (arg.format) {
                result += arg.format(argFormat);
            }
            else
                result += arg.toString();

            i = close + 1;
        }

        return result;
    },

    initialize: function() {
        JData.DataControlFieldCell.callBaseMethod(this, 'initialize');
        this._contentContainer = document.createElement('span');
        this.get_element().appendChild(this._contentContainer);
    }
};

JData.DataControlFieldCell.registerClass('JData.DataControlFieldCell', JData.TableCell);


//========================== EditableCell ==========================

JData.EditableCell = function(element) {
    JData.EditableCell.initializeBase(this, [element]);
    this._isEdit(false);
}

JData.EditableCell.prototype = {

    get_text: function() {
        return this.get_contentContainer().innerHTML;
    },
    set_text: function(value) {
        this.get_contentContainer().innerHTML = value;
    },

    _isEdit: function(value) {
        if (value != null) {
            this.$isEdit = value;
        }
        return this.$isEdit;
    },

    get_value: function() {
        if (this._isEdit())
            return this.get_controlValue();
        else
            return this._value;
    },

    get_control: function() {
        return this._createControl;
    },

    _controlMargin: function() {
        return 10;
    },

    _validators: function(value) {
        if (value == null) {
            return this.__validators;
        }
        else {
            for (var i = 0; i < value.length; i++) {
                var validator = value[i];
                validator.set_cellToValidate(this);
            }
            this.__validators = value;
        }
    },

    //======================== EVENTS ========================

    add_cellBeginEdit: function(handler) {
        this.get_events().addHandler('beginEdit', handler);
    },
    remove_cellBeginEdit: function(handler) {
        this.get_events().removeHandler('beginEdit', handler);
    },

    add_cellEndEdit: function(handler) {
        this.get_events().addHandler('endEdit', handler);
    },
    remove_cellEndEdit: function(handler) {
        this.get_events().removeHandler('endEdit', handler);
    },


    //========================================================
    _iconWidth: function() {
        return 16;
    },
    _iconHeight: function() {
        return 16;
    },

    _showError: function(message) {
        var cell = this;
        if (cell._errorIcon == null) {
            var cellBound = Sys.UI.DomElement.getBounds(cell.get_element());
            var cellWidth = cellBound.width;
            this._oldControlWidth = Sys.UI.DomElement.getBounds(cell.get_control()).width;

            var controlWidth = cellWidth - cell._controlMargin() - this._iconWidth();
            if (controlWidth < Sys.UI.DomElement.getBounds(cell.get_control()).width) {
                cell.get_control().style.width = controlWidth + 'px';
            }
            var cellHeight = cellBound.height;
            var marginTop = (cellHeight - this._iconHeight()) / 2 - 2;
            var icon = document.createElement('SPAN');
            icon.style.cssText = icon.style.cssText + ';float:right';
            icon.style.marginTop = marginTop + 'px';
            icon.className = 'ui-icon ui-icon-circle-close';
            cell.get_element().appendChild(icon);
            cell._errorIcon = icon;
        }
        cell._errorIcon.title = message;
    },
    _clearError: function() {
        var cell = this;
        if (cell._errorIcon == null)
            return;

        cell.get_element().removeChild(cell._errorIcon);
        cell._errorIcon = null;

        if (cell.get_control() != null)
            cell.get_control().style.width = (Sys.UI.DomElement.getBounds(this.get_control()).width + cell._controlMargin()) + 'px';
    },

    beginEdit: function() {
        if (this.get_containingField().get_readOnly() == true)
            return;
        var grid = this.get_parent().get_parent();
        var h = grid.get_events().getHandler('cellBeginEdit');
        if (h) h(grid, { cell: this });

        this.get_contentContainer().innerHTML = "";
        this._createControl = this.createControl();
        this.get_contentContainer().appendChild(this._createControl);
        var controlStyle = this.get_containingField().get_controlStyle();
        controlStyle.applyTo(this._createControl);
        if (controlStyle.get_width() == null) {
            var width = Sys.UI.DomElement.getBounds(this.get_element()).width;
            if (width > this._controlMargin()) {
                width = width - this._controlMargin();
                this._createControl.style.width = width + 'px';
            }
        }
        this.set_controlValue(this.get_value());
        this._isEdit(true);
    },

    validate: function(dataItem) {
        var grid = this.get_parent().get_parent();
        var h = grid.get_events().getHandler('cellValidated');
        if (h) h(grid, { cell: this });

        var cell = this;
        var flag = true;
        var validators = this.get_containingField().get_validators();
        if (validators != null) {
            for (var i = 0; i < validators.length; i++) {
                var validator = validators[i]
                if (validator.validate(cell.get_controlValue()) == false) {
                    this._showError(validator.get_errorMessage());
                    return false;
                }
            };
        }
        var grid = this.get_parent().get_parent();
        var h = grid.get_events().getHandler('cellValidating');
        if (h) h(grid, { cell: this });

        return true;
    },

    pushValue: function() {
        var row = this.get_parent();
        var col = this.get_containingField();

        var dataItem = row.get_dataItem();
        dataItem[col.get_dataField()] = this.get_controlValue();
        //this.set_value(this.get_controlValue());
        var grid = this.get_parent().get_parent();
        var h = grid.get_events().getHandler('cellValuePushed');
        if (h) h(grid, { cell: this });

        return true;
    },

    endEdit: function() {
        if (this._isEdit() == false)
            return;

        this._clearError();
        this.removeControl();
        this._isEdit(false);
        this._displayValue();

        var grid = this.get_parent().get_parent();
        var h = grid.get_events().getHandler('cellEndEdit');
        if (h) h(grid, { cell: this });
    },


    //============ Virtual Methods ===============================

    createControl: function(container) {

        var control = document.createElement('input');
        return control;
    },

    removeControl: function() {
        if (this._createControl != null) {
            this.get_contentContainer().removeChild(this._createControl);
            this._createControl = null;
        }
    },

    get_controlValue: function() {
        if (this._createControl == null)
            return null;

        return this.get_containingField().parseValue(this._createControl.value);
    },

    set_controlValue: function(value) {
        if (this._createControl == null)
            return;

        this._createControl.value = this.get_containingField().formatValue(value);
    },

    //===================================

    initialize: function() {
        JData.EditableCell.callBaseMethod(this, 'initialize');
        var row = this.get_row();
        var col = this.get_containingField();
        var cell = this;
        var grid = row.get_parent();

        Sys.Debug.assert(this._isEdit() == false);
        Sys.Debug.assert(row.get_rowType() == JData.DataControlRowType.DataRow ||
                         row.get_rowType() == JData.DataControlRowType.EmptyDataRow);

        var dataItem = row.get_dataItem();
        this.set_value();
    },

    dispose: function() {
        //Add custom dispose actions here
        JData.EditableCell.callBaseMethod(this, 'dispose');
    }
}
JData.EditableCell.registerClass('JData.EditableCell', JData.DataControlFieldCell);

Type.registerNamespace("JData");

//============================ DataControlField ============================

JData.DataControlField = function() {
    this._dataPropertyName = null;
    this._displayIndex = 0;
    this._readOnly = false;
    this._valueType = null;
    this._visible = true;
    this._width = '120px';
    this._height = '24px';
    this._cell = null;
    this._dataSource = null;
    this._Index = -1;

    this.set_controlStyle(new JData.Style());
    this.set_itemStyle(new JData.TableItemStyle());
    //this.set_footerText('&nbsp;');
    //this.set_headerText('&nbsp;');
};

JData.DataControlField.prototype = {

    get_controlStyle: function() {
        /// <returns type="JData.Style"/>
        return this._controlStyle;
    },
    set_controlStyle: function(value) {
        /// <param name="value" type="JData.Style"/>
        this._controlStyle = value;
    },

    get_defaultValue: function() {
        /// <returns type="Object"/>
        return this._defaultValue;
    },
    set_defaultValue: function(value) {
        /// <summary>
        /// Set the default value on the field of the object when it created by the control. 
        /// </summary>
        /// <param name="value" type="Object"/>
        this._defaultValue = value;
    },

    get_footerText: function() {
        /// <summary>
        /// Gets the text that is displayed in the footer item of a data control field.
        /// </summary>
        /// <returns type="String"/>
        if (this._footerText == null)
            return '&nbsp;';
        return this._footerText;
    },
    set_footerText: function(value) {
        /// <summary>
        /// Sets the text that is displayed in the footer item of a data control field.
        /// </summary>
        /// <param name="value" type="String"/>
        this._footerText = value;
    },

    get_headerText: function() {
        /// <summary>
        /// Gets the text that is displayed in the header item of a data control field
        /// </summary>
        /// <returns type="String"/>
        if (this._headerText == null)
            return '&nbsp;';
        return this._headerText;
    },
    set_headerText: function(value) {
        /// <summary>
        /// Sets the text that is displayed in the header item of a data control field
        /// </summary>
        /// <param name="value" type="String"/>

        this._headerText = value;
    },

    get_index: function() {
        /// <summary>
        /// Gets the order of the column relative to the currently columns.
        /// </summary>
        /// <returns type="Number"/>
        Sys.Debug.assert(this._Index > -1);
        return this._Index;
    },
    _owner: function(value) {
        if (value == null)
            return this.$owner;
        this.$owner = value;
    },
    get_owner: function() {
        /// <summary>
        /// Gets the GridView or DetailsView or FormView control that the column is a member of.
        /// </summary>
        return this._owner();
    },

    _set_owner: function(value) {
        this._owner(value);
    },

    get_sortExpression: function() {
        /// <returns type="String">
        /// Gets a sort expression that is used by a data source control to sort data.
        /// </returns>
        return this._sortExpression;
    },
    set_sortExpression: function(value) {
        /// <param name="value" type="String">
        /// Sets a sort expression that is used by a data source control to sort data.
        /// </param>
        this._sortExpression = value;
    },

    get_visible: function() {
        /// <summary>
        /// Gets a value indicating whether the column is visible.
        /// </summary>
        /// <returns type="Boolean"/>
        return this._visible;
    },
    set_visible: function(value) {
        /// <summary>
        /// Sets a value indicating whether the column is visible.
        /// </summary>
        /// <param name ="value" type="Boolean"/>
        this._visible = value;
    },

    //============== Style ==============

    get_controlStyle: function() {
        return this._controlStyle;
    },
    set_controlStyle: function(value) {
        this._controlStyle = value;
    },

    get_itemStyle: function() {
        /// <summary>
        /// Gets the style of any text-based content displayed by a data control field.
        /// </summary>
        /// <returns type="JData.TableItemStyle"/>
        return this._itemStyle;
    },
    set_itemStyle: function(value) {
        /// <summary>
        /// Sets the style of any text-based content displayed by a data control field.
        /// </summary>
        /// <param name="value" type="JData.TableItemStyle"/>
        this._itemStyle = value;
    },

    //============== Methods ==============

    get_cellType: function() {
        /// <summary>
        /// Gets the run-time type of the cell template.
        /// </summary>
        /// <returns type="Type"/>
        return JData.DataControlFieldCell;
    },

    get_cellEvents: function() {
        return null;
    },

    get_properties: function() {
        return null;
    },

    _CreateCell: function(obj) {

        var properties = this.get_properties();
        Sys.Debug.assert(properties == null);
        if (properties == null)
            properties = {};

        var cellElement;
        if (Object.getTypeName(obj) == "JData.GridViewRow") {
            var gridViewRow = obj;
            cellElement = gridViewRow.get_element().insertCell(gridViewRow.get_element().cells.length)
            properties.parent = obj;
        }
        else {
            cellElement = obj;
        }
        Sys.Debug.assert(cellElement != null);

        properties.containingField = this;
        var cell = $create(this.get_cellType(), properties, this.get_cellEvents(), null, cellElement);
        var style = this.get_itemStyle(cell);
        cell.applyStyle(style);

        return cell;
    },

    _CreateHeaderCell: function(cellElement) {
        var column = this;

        var width = column.get_itemStyle().get_width();
        var cell = $create(JData.TableCell, null, null, null, cellElement);
        if (width != null)
            cell.get_element().style.width = width; //$(cell.get_element()).attr('width', width);

        cell.get_containingField = function() { return column };
        cell.set_text(column.get_headerText());
        return cell;
    }
};

JData.DataControlField.registerClass('JData.DataControlField');

//============================ TextBoxCell ============================

JData.TextBoxCell = function(element) {
    JData.TextBoxCell.initializeBase(this, new Array(element));
};

JData.TextBoxCell.prototype = {

    //========================= Override Methods =========================

    createControl: function() {
        return this.get_control();
    },

    get_control: function() {
        if (this._createControl == null) {
            this._createControl = document.createElement('input');
        }
        return this._createControl;
    }
};

JData.TextBoxCell.registerClass('JData.TextBoxCell', JData.EditableCell); //JData.EditableCell

//============================ BoundField ============================

JData.BoundField = function(field, headerText, itemWidth, controlWidth, readOnly) {
    /// <param name="field" type="String" mayBeNull="true">
    /// The name of the data field to bind to the BoundField object.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    /// <param name="controlWidth" type="String" mayBeNull="true">
    /// The with of any control generated by a cell that generated by a data control field.
    /// </param>
    /// <param name="readOnly" type="Boolean" mayBeNull="true"/>

    JData.BoundField.initializeBase(this);


    this._readOnly = false;
    this._validators = new Array();
    this.set_nullText('');

    if (field != null)
        this.set_dataField(field);
    if (headerText != null)
        this.set_headerText(headerText);
    if (itemWidth != null)
        this.get_itemStyle().set_width(itemWidth);
    if (controlWidth != null)
        this.get_controlStyle().set_width(controlWidth);
    if (readOnly != null)
        this.set_readOnly(readOnly);
};

JData.BoundField.prototype = {

    get_dataField: function() {
        /// <returns type="String"/>
        if (this._dataField == null)
            throw Error.argumentNull('dataField');
        return this._dataField;
    },

    set_dataField: function(value) {
        /// <param name="value" type="String"/>
        //String.isInstanceOfType(value);
        if (value.name != null)
            this._dataField = value.name();
        else
            this._dataField = value;
    },

    get_dataFormatString: function() {
        /// <summary>
        /// Gets the string that specifies the display format for the value of the field.
        /// </summary>
        /// <return type="String"/>
        return this._dataFormatString;
    },
    set_dataFormatString: function(value) {
        /// <summary>
        /// Sets the string that specifies the display format for the value of the field.
        /// </summary>
        /// <param name="value" type="String"/>
        this._dataFormatString = value;
    },

    get_headerText: function() {
        if (this._headerText == null)
            return this.get_dataField();
        return this._headerText;
    },
    set_headerText: function(value) {
        this._headerText = value;
    },

    set_readOnly: function(value) {
        /// <summary>
        /// Sets a value indicating whether the value of the field can be modified in edit mode.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._readOnly = value;
    },
    get_readOnly: function() {
        /// <summary>
        /// Sets a value indicating whether the value of the field can be modified in edit mode.
        /// </summary>
        /// <returns type="Boolean"/>
        return this._readOnly;
    },

    get_nullText: function() {
        /// <summary>
        /// Gets the caption displayed for a field when the field's value is null.
        /// </summary>
        /// <returns type="String"/>
        return this._nullText;
    },
    set_nullText: function(text) {
        /// <summary>
        /// Sets the caption displayed for a field when the field's value is null.
        /// </summary>
        /// <param name="text" type="String"/>
        this._nullText = text;
    },

    get_validators: function() {
        /// <returns type="Array"/>
        return this._validators;
    },
    set_validators: function(value) {
        /// <param name="value" type="Array"/>
        this._validators = value;
    },

    get_valueType: function() {
        /// <summary>
        /// Gets the data type of the values in the column's cells.
        /// </summary>
        /// <returns type="Type"/>
        return this._valueType;
    },
    set_valueType: function(value) {
        /// <summary>
        /// Sets the data type of the values in the column's cells.
        /// </summary>
        /// <param name="value" type="Type"/>
        this._valueType = value;
    },

    get_cellType: function() {
        return JData.TextBoxCell;
    },

    get_cellEvents: function() {
        return null;
    },

    //Virtual Method
    parseValue: function(value) {
        if (value == this.get_nullText())
            return null;
        var type = this.get_valueType();
        if (type == Number)
            return new Number(value);

        return value;
    },

    formatValue: function(value) {
        if (value == null)
            return this.get_nullText();
        return value;
    },

    //===============================================

    _CreateCell: function(cellElement) {
        var cell = JData.BoundField.callBaseMethod(this, '_CreateCell', [cellElement]);
        if (this.get_valueType() == null) {
            var value = cell.get_value();
            if (value != null) {
                var type = Object.getType(value);
                this.set_valueType(type);
            }
        }
        return cell;
    },

    _CreateHeaderCell: function(cellElement) {
        var column = this;
        //        var gridView = gridRow.get_parent();
        //        var rowElement = gridRow.get_element();
        //var cellElement = rowElement.insertCell(rowElement.cells.length);
        var cell = $create(JData.TableCell, null, null, null, cellElement);
        var width = column.get_itemStyle(cell).get_width();
        if (width != null)
            cellElement.style.width = width;

        cell.get_containingField = function() { return column };
        if (JData.BoundField.isInstanceOfType(column) &&
                column.get_sortExpression() != null) {

            var url = document.createElement('a');
            var col = column;
            url.innerHTML = col.get_headerText();
            url.href = 'javascript:';
            url.style.textDecoration = 'underline';
            url.sort = column.get_sortExpression();
            url.direct = 'asc';

            $addHandler(url, 'click', function(args) {
                col.get_owner()._HandleSort(this.sort, this.direct);
                if (this.direct == 'asc') {
                    this.direct = 'desc';
                    this.title = 'Order Descending';
                }
                else {
                    this.direct = 'asc';
                    this.title = 'Order Ascending';
                }
            });

            $addHandler(url, 'mouseover', function() {
                var sort = this.sort = column.get_sortExpression();
                if (this.direct == 'asc') {
                    this.title = 'Order Ascending';
                }
                else {
                    this.title = 'Order Descending';
                }
            });

            cell.get_element().appendChild(url);
        }
        else {
            cell.set_text(column.get_headerText());
        }
        return cell;
    }
};

JData.BoundField.registerClass('JData.BoundField', JData.DataControlField);

//============================ CheckBoxCell ============================

JData.CheckBoxCell = function(element) {
    JData.CheckBoxCell.initializeBase(this, new Array(element));
};

JData.CheckBoxCell.prototype = {
    createControl: function() {
        if (this.control == null) {
            this.control = document.createElement('input');
            this.control.setAttribute('type', 'checkbox');
            this.get_containingField().get_controlStyle().applyTo(this.control);
        }
        return this.control;
    },

    set_controlValue: function(value) {
        Sys.Debug.assert(this.control != null);
        this.control.checked = value;
    },
    get_controlValue: function() {
        Sys.Debug.assert(this.control != null);
        return this.control.checked;
    },

    _displayValue: function() {
        var text;
        var col = this.get_containingField();
        if (this.get_value() == null)
            text = col.get_nullText();
        else if (this.get_value() == true)
            text = col.get_trueValue();
        else if (this.get_value() == false)
            text = col.get_falseValue();

        this.set_text(text);
    }
};

JData.CheckBoxCell.registerClass('JData.CheckBoxCell', JData.EditableCell);

//================================= CheckBoxField ===================================

JData.CheckBoxField = function(field, headerText, itemWidth, controlWidth, trueValue, falseValue, readOnly) {
    /// <param name="field" type="String" mayBeNull="true">
    /// The name of the data field to bind to the BoundField object.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    /// <param name="controlWidth" type="String" mayBeNull="true">
    /// The with of any control generated by a cell that generated by a data control field.
    /// </param>
    /// <param name="trueValue" type="Object" mayBeNull="true">
    /// The underlying value corresponding to a cell value of true, which appears as an checked box.
    /// </param>
    /// <param name="falseValue" type="Object" mayBeNull="true">
    /// The underlying value corresponding to a cell value of false, which appears as an unchecked box.
    /// </param>

    JData.CheckBoxField.initializeBase(this, [field, headerText, itemWidth, controlWidth, readOnly]);
    if (trueValue == null)
        trueValue = 'Yes';
    if (falseValue == null)
        falseValue = 'No';

    this.set_trueValue(trueValue);
    this.set_falseValue(falseValue);
};

JData.CheckBoxField.prototype = {
    get_cellType: function() {
        return JData.CheckBoxCell;
    },
    get_falseValue: function() {
        /// <summary>
        /// Gets the underlying value corresponding to a cell value of false, which appears as an unchecked box.
        /// </summary>
        /// <return type="Object"/>
        return this._falseValue;
    },
    set_falseValue: function(value) {
        /// <summary>
        /// Sets the underlying value corresponding to a cell value of false, which appears as an unchecked box.
        /// </summary>    
        /// <param type="Object" name="value"/>
        this._falseValue = value;
    },

    get_trueValue: function() {
        /// <summary>
        /// Gets the underlying value corresponding to a cell value of true, which appears as an checked box.
        /// </summary>
        /// <return type="Object"/>
        return this._trueValue;
    },
    set_trueValue: function(value) {
        /// <summary>
        /// Sets the underlying value corresponding to a cell value of true, which appears as an checked box.
        /// </summary>    
        /// <param type="Object" name="value"/>
        this._trueValue = value;
    }
};

JData.CheckBoxField.registerClass('JData.CheckBoxField', JData.BoundField);


//================================= CommandCell ===================================

JData.CommandCell = function(element) {
    JData.CommandCell.initializeBase(this, new Array(element));
    this._buttons = new Array(5);
};

JData.CommandCell.prototype = {
    get_buttons: function() {
        return this._buttons;
    },
    get_deleteButton: function() {
        return this._buttons[2];
    },

    initialize: function() {
        var row = this.get_row();
        var col = this.get_containingField();
        var grid = row.get_parent();
        var state = row.get_rowState();
        var rowType = row.get_rowType();
        var dataSource = grid.get_dataSource();
        var cell = this;

        var editButton;
        var buttons = this.get_buttons();

        var createButton = function() {
            var button = document.createElement('a');
            button.href = 'JavaScript:';
            return button;
        };
        if (col.get_showEditButton() == true) {
            buttons[0] = createButton();
            switch (row.get_currentMode()) {
                case 'readOnly':
                case JData.DetailsViewMode.ReadOnly:
                    buttons[0].innerHTML = col.get_editText();
                    break;
                case 'insert':
                case JData.DetailsViewMode.Insert:
                    buttons[0].innerHTML = col.get_insertText();
            }
            var gridView = row.get_parent();

            buttons[0].onclick = function() {
                switch (row.get_currentMode()) {
                    case 'readOnly':
                    case JData.DetailsViewMode.ReadOnly:
                        gridView._HandleEdit(row);
                        return;
                    case 'edit':
                    case JData.DetailsViewMode.Edit:
                        gridView._HandleUpdate(row);
                        return;
                    case 'insert':
                    case JData.DetailsViewMode.Insert:
                        gridView._HandleInsert(row);
                        return;
                }
            };
            if (col.get_showCancleButton()) {
                buttons[1] = createButton();
                buttons[1].innerHTML = col.get_cancleText();
                buttons[1].onclick = function() {
                    gridView._HandleCancle(row);
                };
            }
        }
        if (col.get_showDeleteButton()) {
            buttons[2] = createButton();
            buttons[2].innerHTML = col.get_deleteText();
            if (buttons[2].onclick == null)
                buttons[2].onclick = function() {
                    grid._HandleDelete(row);
                };
        }

        if (col.get_showInsertButton()) {
            //New Button
            buttons[3] = createButton();
            buttons[3].innerHTML = col.get_newText();
            buttons[3].onclick = function(args) {
                switch (row.get_currentMode()) {
                    case 'readOnly':
                    case JData.DetailsViewMode.ReadOnly:
                        grid._HandleNew(row);
                        break;
                    case 'insert':
                    case JData.DetailsViewMode.Insert:
                        grid._HandleInsert(row);
                        break;
                }
            };

            //Insert Cancle Button
            if (col.get_showCancleButton()) {
                buttons[4] = createButton();
                buttons[4].innerHTML = col.get_cancleText();
                buttons[4].onclick = function() {
                    grid._HandleCancle(row);
                };
            }
        }

        if (Object.getTypeName(grid) == 'JData.GridView') {
            if (col.get_showSelectButton()) {
                buttons[5] = createButton();
                buttons[5].innerHTML = col.get_selectText();
                buttons[5].onclick = function() {
                    grid._HandleSelect(row);
                    /*
                    if (Array.contains(grid.get_selectedRows(), row)) {
                    buttons[5].innerHTML = col.get_unselectText();
                    }
                    else {
                    buttons[5].innerHTML = col.get_selectText();
                    }
                    */
                }
            }
        }

        var count = 0;
        for (var i = 0; i < buttons.length; i++) {
            if (buttons[i] == null)
                continue;

            if (count > 0) {
                var element = buttons[i];
                buttons[i].style.paddingLeft = '4px';
            }
            this.get_element().appendChild(buttons[i]);
            count = count + 1;
        }

        if (buttons[1] != null)
            Sys.UI.DomElement.setVisible(buttons[1], false);
        if (buttons[4] != null)
            Sys.UI.DomElement.setVisible(buttons[4], false);
        if (buttons[2] != null && row.get_rowType() == JData.DataControlRowType.EmptyDataRow)
            Sys.UI.DomElement.setVisible(buttons[2], false)

        row.add_modeChanged(function(sender, args) {
            Sys.Debug.assert(args.mode != null);
            if (args.mode == 'insert' || args.mode == JData.DetailsViewMode.Insert) {
                if (buttons[0] != null)
                    Sys.UI.DomElement.setVisible(buttons[0], false);
                if (buttons[1] != null)
                    Sys.UI.DomElement.setVisible(buttons[1], false);
                if (buttons[2] != null)
                    Sys.UI.DomElement.setVisible(buttons[2], false);
                if (buttons[3] != null) {
                    buttons[3].innerHTML = col.get_insertText();
                    Sys.UI.DomElement.setVisible(buttons[3], true);
                    if (buttons[4] != null)
                        Sys.UI.DomElement.setVisible(buttons[4], true);
                    //cell._showCancleButton();
                }
                if (buttons[5] != null)
                    Sys.UI.DomElement.setVisible(buttons[5], false);
            }
            else if (args.mode == 'readOnly' || args.mode == JData.DetailsViewMode.ReadOnly) {
                if (buttons[0] != null) {
                    buttons[0].innerHTML = col.get_editText();
                    Sys.UI.DomElement.setVisible(buttons[0], true);
                }
                if (buttons[1] != null) {
                    Sys.UI.DomElement.setVisible(buttons[1], false);
                }
                if (buttons[2] != null) {
                    Sys.UI.DomElement.setVisible(buttons[2], true);
                }
                if (buttons[3] != null) {
                    buttons[3].innerHTML = col.get_newText();
                    Sys.UI.DomElement.setVisible(buttons[3], true);
                }
                if (buttons[4] != null)
                    Sys.UI.DomElement.setVisible(buttons[4], false);

                if (buttons[5] != null)
                    Sys.UI.DomElement.setVisible(buttons[5], true);

            }
            else if (args.mode == 'edit' || args.mode == JData.DetailsViewMode.Edit) {
                if (buttons[0] != null) {
                    buttons[0].innerHTML = col.get_updateText();
                    Sys.UI.DomElement.setVisible(buttons[0], true);
                }

                if (buttons[1] != null)
                    Sys.UI.DomElement.setVisible(buttons[1], true);

                if (buttons[2] != null)
                    Sys.UI.DomElement.setVisible(buttons[2], false);

                if (buttons[3] != null)
                    Sys.UI.DomElement.setVisible(buttons[3], false);

                if (buttons[4] != null)
                    Sys.UI.DomElement.setVisible(buttons[4], false);

                if (buttons[5] != null)
                    Sys.UI.DomElement.setVisible(buttons[5], false);
            }
        });
    }
};

JData.CommandCell.registerClass('JData.CommandCell', JData.DataControlFieldCell);

//================================= CommandField ===================================

JData.CommandField = function(headerText, itemWidth, showCancleButton, showDeleteButton, showEditButton, showInsertButton, showSelectButton) {
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>

    JData.CommandField.initializeBase(this);

    this.set_editText('Edit');
    this.set_deleteText('Delete');
    this.set_updateText('Update');
    this.set_cancleText('Cancle');
    this.set_newText('New');
    this.set_insertText('Insert');
    this.set_selectText('Select');
    this.set_unselectText('Unselect');

    if (showCancleButton == null) showCancleButton = false;
    if (showDeleteButton == null) showDeleteButton = false;
    if (showEditButton == null) showEditButton = false;
    if (showInsertButton == null) showInsertButton = false;
    if (showSelectButton == null) showSelectButton = false;

    this.set_showCancleButton(showCancleButton);
    this.set_showDeleteButton(showDeleteButton);
    this.set_showEditButton(showEditButton);
    this.set_showInsertButton(showInsertButton);
    this.set_showSelectButton(showSelectButton);

    if (headerText != null) this.set_headerText(headerText);
    if (itemWidth != null) this.get_itemStyle().set_width(itemWidth);
};

JData.CommandField.prototype = {

    get_showCancleButton: function() {
        /// <summary>
        /// Gets a value indicating whether a Cancel button is displayed in a CommandField field.
        /// </summary>
        /// <return type="Boolean"/>
        return this._showCancleButton;
    },
    set_showCancleButton: function(value) {
        /// <summary>
        /// Sets a value indicating whether a Cancel button is displayed in a CommandField field.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._showCancleButton = value;
    },

    get_showDeleteButton: function() {
        /// <summary>
        /// Gets a value indicating whether a Delete button is displayed in a CommandField field.
        /// </summary>
        /// <return type="Boolean"/>
        return this._showDeleteButton;
    },
    set_showDeleteButton: function(value) {
        /// <summary>
        /// Sets a value indicating whether a Delete button is displayed in a CommandField field.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._showDeleteButton = value;
    },

    get_showEditButton: function() {
        /// <summary>
        /// Gets a value indicating whether a Edit button is displayed in a CommandField field.
        /// </summary>
        /// <return type="Boolean"/>
        return this._showEditButton;
    },
    set_showEditButton: function(value) {
        /// <summary>
        /// Sets a value indicating whether a Edit button is displayed in a CommandField field.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._showEditButton = value;
    },

    get_showInsertButton: function() {
        /// <summary>
        /// Gets a value indicating whether a New button is displayed in a CommandField field.
        /// </summary>
        /// <returns type="Boolean"/>
        return this._showInsertButton;
    },
    set_showInsertButton: function(value) {
        /// <summary>
        /// Sets a value indicating whether a New button is displayed in a CommandField field.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._showInsertButton = value;
    },

    get_showSelectButton: function() {
        /// <summary>
        /// Gets a value indicating whether a Select button is displayed in a CommandField field.
        /// </summary>
        /// <returns type="Boolean"/>
        return this._showSelectButton;
    },
    set_showSelectButton: function(value) {
        /// <summary>
        /// Sets a value indicating whether a Select button is displayed in a CommandField field.
        /// </summary>
        /// <param name="value" type="Boolean"/>
        this._showSelectButton = value;
    },

    get_cancleText: function() {
        return this._cancleText;
    },
    set_cancleText: function(value) {
        this._cancleText = value;
    },

    get_deleteText: function() {
        return this._deleteText;
    },
    set_deleteText: function(value) {
        this._deleteText = value;
    },

    get_editText: function() {
        return this._editText;
    },
    set_editText: function(value) {
        this._editText = value;
    },

    get_updateText: function() {
        return this._updateText;
    },
    set_updateText: function(value) {
        this._updateText = value;
    },
    get_insertText: function() {
        return this._insertText;
    },
    set_insertText: function(value) {
        this._insertText = value;
    },

    get_newText: function() {
        return this._newText;
    },
    set_newText: function(value) {
        this._newText = value;
    },

    get_selectText: function() {
        return this._selectText;
    },
    set_selectText: function(value) {
        this._selectText = value;
    },

    get_unselectText: function() {
        return this._unselectText;
    },
    set_unselectText: function(value) {
        this._unselectText = value;
    },

    get_cellType: function() {
        return JData.CommandCell;
    },

    get_cellEvents: function() {
        return null;
    },

    _set_owner: function(owner) {
        var col = this;
        if (Object.getType(owner) == JData.GridView) {
            owner.add_rowSelected(function(sender, args) {
                var index = Array.indexOf(sender.get_columns(), col);
                var cell = args.row.get_cells()[index];
                var selectButton = cell.get_buttons()[5];
                if (selectButton != null) {
                    selectButton.innerHTML = col.get_unselectText();
                }
            });
            owner.add_rowUnselected(function(sender, args) {
                var index = Array.indexOf(sender.get_columns(), col);
                var cell = args.row.get_cells()[index];
                var selectButton = cell.get_buttons()[5];
                if (selectButton != null) {
                    selectButton.innerHTML = col.get_selectText();
                }
            });
        }
    }

};

JData.CommandField.registerClass('JData.CommandField', JData.DataControlField);

//================================= DropDownListCell ===================================

JData.DropDownListCell = function(element) {
    JData.DropDownListCell.initializeBase(this, new Array(element));

}

JData.DropDownListCell.prototype = {

    _getValue: function(item) {
        var valueMember = this.get_containingField().get_valueMember();
        if (valueMember == null)
            return this._getDisplay(item);

        return item[valueMember];
    },
    _getDisplay: function(item) {
        var displayMember = this.get_containingField().get_displayMember();
        Sys.Debug.assert(displayMember != null);
        return item[displayMember];
    },


    createControl: function() {
        /// <param name="container" Type="DomElement">
        /// Option. The parent element of the control to be created. If null, the parnet element is this cell DOM element.
        /// </param>
        if (this.control != null)
            return this.control;

        this.control = document.createElement('select');
        var cell = this;
        this.get_containingField()._GetDataItems(this, function(items) {
            for (var i = 0; i < items.length; i++) {
                var option = document.createElement('option');
                option.value = items[i] == null ? 'null' : cell._getValue(items[i]);
                var cellValue = cell.get_value() == null ? 'null' : cell.get_value();

                if (option.value == cellValue)
                    option.selected = true;

                option.innerHTML = cell._getDisplay(items[i]);
                cell.control.appendChild(option);
            }
        });

        return this.control;
    },

    get_controlValue: function() {
        if (this.control == null)
            return null;
        if (this.control.options == null || this.control.selectedIndex < 0)
            return null;

        var option = this.control.options[this.control.selectedIndex];
        if (option.value == 'null')
            return null;

        var type = this.get_containingField().get_valueType();
        if (type == Number)
            return new Number(option.value);

        return option.value;
    },

    _displayValue: function() {
        var value = this.get_value();
        var cell = this;
        this.get_containingField()._GetDataItems(cell, function(items) {
            for (var i = 0; i < items.length; i++) {
                var item = items[i];
                if (item != null) {
                    if (value == item[cell.get_containingField().get_valueMember()]) {
                        value = item[cell.get_containingField().get_displayMember()];
                        cell.current = item;
                        break;
                    }
                }
            }
            if (value == null)
                value = cell.get_containingField().get_nullText();

            //If the control is exists, do not show the text.
            if (cell.get_contentContainer().childNodes.length == 0)
                cell.get_contentContainer().innerHTML = value;
        });
    },

    initialize: function() {
        JData.DropDownListCell.callBaseMethod(this, 'initialize');
        var dataSource = this.get_containingField().get_dataSource();
        var cell = this;
        dataSource.add_updated(function(sender, args) {
            if (cell.current == args.item) {
                cell.set_text(cell.current[cell.get_containingField().get_displayMember()]);
            }
        });
    }

};

JData.DropDownListCell.registerClass('JData.DropDownListCell', JData.TextBoxCell);

//================================= DropDownListField =================================

JData.DropDownListField = function(field, headerText, itemWidth, controlWidth, readOnly, dataSource, displayMember, valueMember) {
    /// <param name="field" type="String" mayBeNull="true">
    /// The name of the data field to bind to the BoundField object.
    /// </param>
    /// <param name="headerText" type="String" mayBeNull="true">
    /// The text that is displayed in the header item of a data control field
    /// </param>
    /// <param name="itemWidth" type="String" mayBeNull="true">
    /// The with of any cell generated by a data control field.
    /// </param>
    /// <param name="controlWidth" type="String" mayBeNull="true">
    /// The with of any control generated by a cell that generated by a data control field.
    /// </param>
    /// <param name="readOnly" type="Boolean" mayBeNull="true"/>

    JData.DropDownListField.initializeBase(this, [field, headerText, itemWidth, controlWidth, readOnly]);
    this.set_dataSource(dataSource);
    this.set_displayMember(displayMember);
    this.set_valueMember(valueMember);
}

JData.DropDownListField.prototype = {
    get_cellType: function() {
        return JData.DropDownListCell;
    },

    get_dataSource: function() {
        /// <summary>
        /// An object that represents a data source. The default is null.
        /// </summary>
        /// <returns type="JData.DataSource" mayBeNull="true"/>
        this._dataItems = null;
        return this._dataSource;
    },

    set_dataSource: function(value) {
        /// <summary>
        /// Sets the data source that populates the selections for the combo boxes.
        /// </summary>
        /// <param name="value" type="JData.DataSource"/>
        this._dataSource = value;
    },

    get_displayMember: function() {
        /// <summary>
        /// Gets a string that specifies the property or column from which to retrieve strings for display in the combo boxes.
        /// </summary>
        /// <returns type="String"/>
        return this._displayMember;
    },
    set_displayMember: function(value) {
        /// <summary>
        /// Sets a string that specifies the property or column from which to retrieve strings for display in the combo boxes.
        /// </summary>
        /// <param name="value" type="String"/>
        this._displayMember = value;
    },

    get_valueMember: function() {
        return this._valueMember;
    },
    set_valueMember: function(value) {
        this._valueMember = value;
    },

    _GetDataItems: function(cell, successedCallback, failedCallback) {
        var dataSource = this.get_dataSource();
        if (dataSource == null)
            throw Error.argumentNull('dataSource');

        var items;
        if (Array.isInstanceOfType(dataSource))
            successedCallback(items); //items = dataSource;
        else {
            var args = new JData.DataSourceSelectArguments();
            dataSource.executeSelect(args, successedCallback, failedCallback);
        }
    }
}

JData.DropDownListField.registerClass('JData.DropDownListField', JData.BoundField);



Type.registerNamespace("JData");

//=========================== TableRow ===========================

JData.TableRow = function(element) {
    JData.TableRow.initializeBase(this, new Array(element));
    this.set_rowState(JData.DataControlRowState.Normal);
    this._cells = new Array();
};

JData.TableRow.prototype = {

    get_rowState: function() {
        ///	<returns type="JData.DataControlRowState" />
        return this._rowState;
    },
    set_rowState: function(value) {
        this._rowState = value;
    },

    get_rowType: function() {
        ///	<returns type="JData.DataControlRowType" />
        return this._rowType;
    },
    set_rowType: function(value) {
        /// <param name="value" type="JData.DataControlRowType"/>
        JData.DataControlRowType.isInstanceOfType(value);
        this._rowType = value;
    },

    get_cells: function() {
        return this._cells;
    },

    createCell: function() {
        var rowElement = this.get_element();
        var cellElement = rowElement.insertCell(rowElement.cells.length);
        var cell = $create(JData.TableCell, null, null, null, cellElement);
        Array.add(this.get_cells(), cell);
        return cell;
    },

    dispose: function() {
        for (var i = 0; i < this.get_cells().length; i++) {
            this.get_cells()[i].dispose();
        }
        JData.TableRow.callBaseMethod(this, 'dispose');
    }
};

JData.TableRow.registerClass('JData.TableRow', JData.WebControl);


//=========================== TextPagingBar ===========================

JData.TextPagingBar = function(element) {
    JData.TextPagingBar.initializeBase(this, [element]);
};

JData.TextPagingBar.prototype = {

    handlePage: function(args) {
        var gridView = this.gridView;
        var pageIndex = gridView.get_pageIndex();
        Sys.Debug.assert(pageIndex >= 0);
        var cell = this.parentCell;
        if (this == cell.firstButton) {
            pageIndex = 0;
        }
        else if (this == cell.previousButton) {
            pageIndex = pageIndex - 1;
        }
        else if (this == cell.nextButton) {
            pageIndex = pageIndex + 1;
        }
        else if (this == cell.lastButton) {
            pageIndex = gridView.get_pageCount() - 1;
        }
        gridView._HandlePage(pageIndex);
    },

    createButton: function(text) {
        var button = document.createElement('a');
        button.innerHTML = text;
        button.style.paddingLeft = '4px';
        button.href = 'javascript:';
        Sys.UI.DomEvent.addHandler(button, 'click', this.handlePage);
        this.cell.get_element().appendChild(button);
        button.gridView = this.gridView;
        button.parentCell = this;
        return button;
    },

    initialize: function() {
        Sys.Debug.assert(this.get_parent() != null);
        var pagingBar = this;
        this.gridView = this.get_parent();
        this.cell = this.createCell();
        var pagerSetting = this.gridView.get_pagerSettings();
        var buttonCount = pagerSetting.get_pageButtonCount();
        this.cell.get_element().colSpan = '300';

        this.firstButton = this.createButton(pagerSetting.get_firstPageText());
        this.previousButton = this.createButton(pagerSetting.get_previousPageText());
        this.nextButton = this.createButton(pagerSetting.get_nextPageText());
        this.lastButton = this.createButton(pagerSetting.get_lastPageText());

        var method = function(sender, args) {
            var pageCount = pagingBar.gridView.get_pageCount();
            var pageIndex = sender.get_pageIndex();
            if (pageIndex > 0) {
                Sys.UI.DomElement.setVisible(pagingBar.firstButton, true);
                Sys.UI.DomElement.setVisible(pagingBar.previousButton, true);
            }
            else {
                Sys.UI.DomElement.setVisible(pagingBar.firstButton, false);
                Sys.UI.DomElement.setVisible(pagingBar.previousButton, false);
            }

            if (pageCount != null) {
                if (pageIndex < pagingBar.gridView.get_pageCount() - 1) {
                    Sys.UI.DomElement.setVisible(pagingBar.nextButton, true);
                    Sys.UI.DomElement.setVisible(pagingBar.lastButton, true);
                }
                else {
                    Sys.UI.DomElement.setVisible(pagingBar.nextButton, false);
                    Sys.UI.DomElement.setVisible(pagingBar.lastButton, false);
                }
            }
            else {
                if (pagingBar.gridView.get_rows().length < pagingBar.gridView.get_pageSize())
                    Sys.UI.DomElement.setVisible(pagingBar.nextButton, false);
                else
                    Sys.UI.DomElement.setVisible(pagingBar.nextButton, true);

                Sys.UI.DomElement.setVisible(pagingBar.lastButton, false);
            }

            if (pagingBar.gridView.get_pagerSettings().get_mode() == JData.PagerButtons.NextPrevious) {
                Sys.UI.DomElement.setVisible(pagingBar.firstButton, false);
                Sys.UI.DomElement.setVisible(pagingBar.lastButton, false);
            }
        };
        this.gridView.add_dataBound(method);
    }
};

JData.TextPagingBar.registerClass('JData.TextPagingBar', JData.TableRow);

//=========================== NumberPagingBar ===========================

JData.NumberPagingBar = function(element) {
    JData.NumberPagingBar.initializeBase(this, [element]);
};

JData.NumberPagingBar.prototype = {
    initialize: function() {
        Sys.Debug.assert(this.get_parent() != null);
        this._buttons = new Array();
        var pagingBar = this;
        var pagingBarIndex = 0;
        this.gridView = this.get_parent();
        this.cell = this.createCell();
        var pagerSetting = this.gridView.get_pagerSettings();
        var buttonCount = pagerSetting.get_pageButtonCount();
        this.cell.get_element().colSpan = '300';

        var FIRST_BUTTON = 0
        var PREVIOUS_PAGING_BUTTON = 1;
        var NEXT_PAGING_BUTTON = pagerSetting.get_pageButtonCount() + 2;
        var LAST_BUTTON = pagerSetting.get_pageButtonCount() + 3
        var OTHER_BUTTONS_COUNT = 4;

        var createButtons;
        var handlePage = function(args) {
            var buttonIndex = Array.indexOf(pagingBar._buttons, this);

            var index;
            pagingBarIndex = Math.floor(this.pageIndex / buttonCount);
            this.gridView._HandlePage(this.pageIndex);
        };
        for (var i = 0; i < buttonCount + OTHER_BUTTONS_COUNT; i++) {
            if (pagingBar._buttons[i] != null) {
                pagingBar.cell.get_element().removeChild(pagingBar._buttons[i]);
            }
            var url = document.createElement('a');
            pagingBar.cell.get_element().appendChild(url);
            pagingBar._buttons[i] = url;
            url.style.paddingLeft = '4px';
            url.href = 'javascript:';
            url.gridView = pagingBar.get_parent();
            Sys.UI.DomEvent.addHandler(url, 'click', handlePage);
        }

        refreshButtons = function() {
            for (var i = 0; i < buttonCount + OTHER_BUTTONS_COUNT; i++) {
                var pageCount = pagingBar.gridView.get_pageCount();
                var start = pagingBarIndex * buttonCount;
                var index;
                var url = pagingBar._buttons[i];
                if (i == PREVIOUS_PAGING_BUTTON) {
                    url.innerHTML = '...';
                    url.pageIndex = (pagingBarIndex - 1) * buttonCount;
                }
                else if (i == NEXT_PAGING_BUTTON) {
                    url.innerHTML = '...';
                    url.pageIndex = (pagingBarIndex + 1) * buttonCount;
                }
                else if (i == FIRST_BUTTON) {
                    url.innerHTML = pagingBar.gridView.get_pagerSettings().get_firstPageText();
                    url.pageIndex = 0;
                }
                else if (i == LAST_BUTTON) {
                    url.innerHTML = pagingBar.gridView.get_pagerSettings().get_lastPageText();
                    url.pageIndex = pageCount - 1;
                }
                else {
                    url.innerHTML = start + i - PREVIOUS_PAGING_BUTTON;
                    url.pageIndex = start + i - PREVIOUS_PAGING_BUTTON - 1;
                }
                Sys.UI.DomElement.setVisible(url, true);

                if (pageCount != null && url.pageIndex > pageCount - 1)
                    Sys.UI.DomElement.setVisible(url, false);
            }

            if (pagingBarIndex == 0 || pagingBar.gridView.get_pagerSettings().get_mode() == JData.PagerButtons.Numeric)
                Sys.UI.DomElement.setVisible(pagingBar._buttons[FIRST_BUTTON], false);

            if (pageCount == null || pagingBar.gridView.get_pageIndex() >= pageCount - 1 ||
                pagingBar.gridView.get_pagerSettings().get_mode() == JData.PagerButtons.Numeric)
                Sys.UI.DomElement.setVisible(pagingBar._buttons[LAST_BUTTON], false);

            if (pagingBarIndex == 0)
                Sys.UI.DomElement.setVisible(pagingBar._buttons[PREVIOUS_PAGING_BUTTON], false);
        }
        this.gridView.add_dataBound(refreshButtons);
    }
};

JData.NumberPagingBar.registerClass('JData.NumberPagingBar', JData.TableRow);

Type.registerNamespace("JData");

JData.DataBoundTable = function(element) {

    if (element != null)
        this._element = element;
    else
        throw Error.argumentNull(element);

    JData.DataBoundTable.initializeBase(this, new Array(this._element));

    this._controls = new Array();
    Sys.Debug.assert(this._controls != null);

    this._headerStyle = new JData.TableItemStyle();
    this._rowStyle = new JData.TableItemStyle();
    this._alternatingRowStyle = new JData.TableItemStyle();
    this._emptyDataRowStyle = new JData.TableItemStyle();
    this._columns = new Array();
    this._rows = new Array();


    this.set_cellSpacing('0px');
    this.set_cellPadding('0px');
    this.set_gridLines(JData.GridLines.Both);
    this.set_footerStyle(new JData.TableItemStyle());
    this.set_captionStyle(new JData.TableItemStyle());
    this.set_pagerStyle(new JData.TableItemStyle());
    this.set_editRowStyle(new JData.TableItemStyle());

    //this.set_pageSize(10);
    this._pageIndex = 0;
    this._pageCount = null;
    this._pagerSettings = new JData.PagerSettings();
    this._headerRows = new Array();
    this._footerRows = new Array();
    this.set_emptyDataText('No Records');
    this._validators = new Array();
};

JData.DataBoundTable.prototype = {

    //=============== Events ===============

    add_pageIndexChanging: function(handler) {
        /// <summary>
        /// Occurs when one of the pager buttons is clicked, but before the GridView control handles the paging operation.
        /// </summary>
        this.get_events().addHandler('pageIndexChanging', handler);
    },
    remove_pageIndexChanging: function(handler) {
        ths.get_events().addHandler('pageIndexChanging', handler);
    },

    add_pageIndexChanged: function(handler) {
        /// <summary>
        /// Occurs when one of the pager buttons is clicked, but after the GridView control handles the paging operation.
        /// </summary>
        this.get_events().addHandler('pageIndexChanged', handler);
    },
    remove_pageIndexChanged: function(handler) {
        ths.get_events().addHandler('pageIndexChanged', handler);
    },

    add_rowCreating: function(handler) {
        /// <summary>
        /// Occurs when a row's New button is clicked, but before the GridView DataBoundTable create the row.
        /// </summary>
        this.get_events().addHandler('rowCreating', handler);
    },
    remove_rowCreating: function(handler) {
        this.get_events().removeHandler('rowCreating', handler);
    },

    add_rowCreated: function(handler) {
        /// <summary>
        /// Occurs when a row is created in a DataBoundTable control.
        /// </summary>
        this.get_events().addHandler('rowCreated', handler);
    },
    remove_rowCreated: function(handler) {
        this.get_events().removeHandler('rowCreated', handler);
    },

    add_rowDeleting: function(handler) {
        /// <summary>
        /// Occurs when a row's Delete button is clicked, but before the DataBoundTable control deletes the row.
        /// </summary>
        this.get_events().addHandler('rowDeleting', handler);
    },
    remove_rowDeleting: function(handler) {
        this.get_events().removeHandler('rowDeleting', handler);
    },

    add_rowDeleted: function(handler) {
        /// <summary>
        /// Occurs when a row's Delete button is clicked, but after the DataBoundTable control deletes the row.
        /// </summary>
        this.get_events().addHandler('rowDeleted', handler);
    },
    remove_rowDeleted: function(handler) {
        this.get_events().removeHandler('rowDeleted', handler);
    },

    add_rowUpdating: function(handler) {
        /// <summary>
        /// Occurs when a row's Update button is clicked, but before the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowUpdating', handler);
    },
    remove_rowUpdating: function(handler) {
        this.get_events().removeHandler('rowUpdating', handler);
    },

    add_rowUpdated: function(handler) {
        /// <summary>
        /// Occurs when a row's Update button is clicked, but after the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowUpdated', handler);
    },
    remove_rowUpdated: function(handler) {
        this.get_events().removeHandler('rowUpdated', handler);
    },

    add_rowInserting: function(handler) {
        /// <summary>
        /// Occurs when a row's Insert button is clicked, but before the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowInserting', handler);
    },
    remove_rowInserting: function(handler) {
        this.get_events().removeHandler('rowInserting', handler);
    },

    add_rowInserted: function(handler) {
        /// <summary>
        /// Occurs when a row's Insert button is clicked, but after the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowInserted', handler);
    },
    remove_rowInserted: function(handler) {
        this.get_events().removeHandler('rowInserted', handler);
    },

    add_rowRemoving: function(handler) {
        /// <summary>
        /// Occurs when a row's Delete button is clicked, but before the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowRemoving', handler);
    },
    remove_rowRemoving: function(handler) {
        this.get_events().removeHandler('rowRemoving', handler);
    },

    add_rowRemoved: function(handler) {
        /// <summary>
        /// Occurs when a row's Delete button is clicked, but after the DataBoundTable control updates the row.
        /// </summary>
        this.get_events().addHandler('rowRemoved', handler);
    },
    remove_rowRemoved: function(handler) {
        this.get_events().removeHandler('rowRemoved', handler);
    },

    add_cellBeginEdit: function(handler) {
        /// <summary>
        /// Occurs when edit mode starts for the selected cell.
        /// </summary>
        this.get_events().addHandler('cellBeginEdit', handler);
    },
    remove_cellBeginEdit: function(handler) {
        this.get_events().removeHandler('cellBeginEdit', handler);
    },

    add_cellClick: function(handler) {
        /// <summary>
        /// Occurs when any part of a cell is clicked.
        /// </summary>
        this.get_events().addHandler('cellClick', handler);
    },
    remove_cellClick: function(handler) {
        this.get_events().removeHandler('cellClick', handler);
    },

    add_cellDoubleClick: function(handler) {
        /// <summary>
        /// Occurs when the user double-clicks anywhere in a cell.
        /// </summary>
        this.get_events().addHandler('cellDoubleClick', handler);
    },
    remove_cellDoubleClick: function(handler) {
        this.get_events().removeHandler('cellDoubleClick', handler);
    },

    add_cellEndEdit: function(handler) {
        /// <summary>
        /// Occurs when edit mode stops for the currently selected cell.
        /// </summary>
        this.get_events().addHandler('cellEndEdit', handler);
    },
    remove_cellEndEdit: function(handler) {
        this.get_events().removeHandler('cellEndEdit', handler);
    },

    add_cellValueChanged: function(handler) {
        /// <summary>
        /// Occurs when the value of a cell changes.
        /// </summary>
        this.get_events().addHandler('cellValueChanged', handler);
    },
    remove_cellValueChanged: function(handler) {
        this.get_events().removeHandler('cellValueChanged', handler);
    },

    add_cellValuePushed: function(handler) {
        /// <summary>
        /// Occurs when a cell value has changed and requires storage in the underlying data source.
        /// </summary>
        this.get_events().addHandler('cellValuePushed', handler);
    },
    remove_cellValuePushed: function(handler) {
        this.get_events().removeHandler('cellValuePushed', handler);
    },

    add_cellValidated: function(handler) {
        /// <summary>
        /// Occurs after the cell has finished validated.
        /// </summary>
        this.get_events().addHandler('cellValidated', handler);
    },
    remove_cellValidated: function(handler) {
        this.get_events().removeHandler('cellValidated', handler);
    },

    add_cellValidating: function(handler) {
        /// <summary>
        /// Occurs after the cell has finished validating.
        /// </summary>
        this.get_events().addHandler('cellValidating', handler);
    },
    remove_cellValidating: function(handler) {
        this.get_events().removeHandler('cellValidating', handler);
    },

    add_dataBound: function(handler) {
        /// <summary>
        /// Occurs after a data-binding operation has finished.
        /// </summary>
        this.get_events().addHandler('dataBound', handler);
    },
    remove_dataBound: function(handler) {
        this.get_events().removeHandler('dataBound', handler);
    },

    add_dataSourceChanged: function(handler) {
        /// <summary>
        /// Occurs when the value of the dataSource property changes.
        /// </summary>
        this.get_events().addHandler('dataSourceChanged', handler);
    },
    remove_dataSourceChanged: function(handler) {
        this.get_events().removeHandler('dataSourceChanged', handler);
    },

    //=============== Properties ===============

    get_allowPaging: function() {
        /// <summary>
        /// Gets a value indicating whether the paging feature is enabled.
        /// </summary>
        /// <value type="Boolean"/>
        return this._allowPaging;
    },
    set_allowPaging: function(value) {
        /// <summary>
        /// Sets a value indicating whether the paging feature is enabled.
        /// </summary>
        Sys.Debug.assert(Boolean.isInstanceOfType(value));
        this._allowPaging = value;
    },

    get_pagerSettings: function() {
        /// <summary>
        /// Gets a reference to the PagerSettings object that allows you to set the properties of the pager buttons in a DataBoundTable control.
        /// </summary>
        /// <value type="JData.PagerSettings"/>
        return this._pagerSettings;
    },
    set_pagerSettings: function(value) {
        /// <summary>
        /// Sets a reference to the PagerSettings object that allows you to set the properties of the pager buttons in a DataBoundTable control.
        /// </summary>
        this._pagerSettings = value;
    },

    get_alternatingRowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of alternating data rows in a DataBoundTable control.
        /// </summary>
        ///	<value type="JData.Style" />
        return this._alternatingRowStyle;
    },
    set_alternatingRowStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of alternating data rows in a DataBoundTable control.
        /// </summary>
        this._alternatingRowStyle = value;
    },

    get_backImageUrl: function() {
        /// <summary>
        /// Gets the URL to an image to display in the background of a GridView control.
        /// </summary>
        /// <value type="String"/>
        return this._backImageUrl;
    },
    set_backImageUrl: function(value) {
        /// <summary>
        /// Sets the URL to an image to display in the background of a GridView control.
        /// </summary>
        this.__backImageUrl = value;
    },

    get_borderWidth: function() {
        /// <summary>
        /// Gets the border width of the Web server control.
        /// </summary>
        /// <value type="String"/>
        return this._borderWidth;
    },
    set_borderWidth: function(value) {
        /// <summary>
        /// Sets the border width of the Web server control.
        /// </summary>
        this._borderWidth = value;
    },


    get_caption: function() {
        /// <summary>
        /// Gets the text to render in the caption row in a DataBoundTable control.
        /// </summary>
        /// <value type="String"/>
        return this._caption;
    },
    set_caption: function(value) {
        /// <summary>
        /// Sets the text to render in the caption row in a DataBoundTable control. 
        /// </summary>
        this._caption = value;
    },

    get_captionStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the caption row in a DataBoundTable control.
        /// </summary>
        /// <value type="JData.TableItemStyle"/>
        return this._captionStyle;
    },
    set_captionStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of the caption row in a DataBoundTable control.
        /// </summary>
        this._captionStyle = value;
    },

    get_cellPadding: function() {
        /// <summary>
        ///  Gets the amount of space between the contents of a cell and the cell's border.
        /// </summary>
        /// <value type="String"/>
        return this._cellpadding;
    },
    set_cellPadding: function(value) {
        /// <summary>
        ///  Sets the amount of space between the contents of a cell and the cell's border.
        /// </summary>
        this._cellpadding = value;
    },

    get_cellSpacing: function() {
        /// <summary>
        /// Gets the amount of space between cells.
        /// </summary>
        return this._cellSpacing;
    },
    set_cellSpacing: function(value) {
        /// <summary>
        /// Sets the amount of space between cells.
        /// </summary>
        this._cellSpacing = value;
    },

    get_cssClass: function() {
        /// <summary>
        /// Gets the Cascading Style Sheet (CSS) class rendered by the Web server control on the client.
        /// </summary>
        return this._cssClass;
    },
    set_cssClass: function(value) {
        /// <summary>
        /// Sets the Cascading Style Sheet (CSS) class rendered by the Web server control on the client.
        /// </summary>
        this._cssClass = value;
    },

    get_editRowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the row selected for editing in a DataBoundTable control.
        /// </summary>
        /// <value type="JData.TableItemStyle"/>
        return this._editRowStyle;
    },
    set_editRowStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of the row selected for editing in a DataBoundTable control.
        /// </summary>
        this._editRowStyle = value;
    },

    get_emptyDataRowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the empty data row rendered when a DataBoundTable control is bound to a data source that does not contain any records.
        /// </summary>
        /// <value type="JData.TableItemStyle"/>
        return this._emptyDataRowStyle;
    },
    set_emptyDataRowStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of the empty data row rendered when a DataBoundTable control is bound to a data source that does not contain any records.
        /// </summary>
        if (value == null)
            throw Error.argumentNull('value');

        this._emptyDataRowStyle = value;
    },

    get_emptyDataText: function() {
        /// <summary>
        /// Gets the text to display in the empty data row rendered when a GridView control is bound to a data source that does not contain any records.
        /// </summary>
        /// <value type="String"/>
        return this._emptyDataText;
    },
    set_emptyDataText: function(value) {
        /// <summary>
        /// Sets the text to display in the empty data row rendered when a GridView control is bound to a data source that does not contain any records.
        /// </summary>
        this._emptyDataText = value; ;
    },

    get_footerRows: function() {
        /// <summary>
        /// Gets a Array object that represents the footer rows in a GridView control.
        /// </summary>
        /// <returns type="Array"/>
        return this._footerRows;
    },

    get_footerStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the footer row in a DataBoundTable control.
        /// </summary>
        /// <value type="JData.TableItemStyle"/>
        return this._footerStyle;
    },
    set_footerStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of the footer row in a DataBoundTable control.
        /// </summary>
        this._footerStyle = value;
    },

    get_gridLines: function() {
        /// <summary>
        /// Gets the gridline style for a DataBoundTable control.
        /// </summary>
        /// <value type="JData.GridLines"/>
        return this._gridLines;
    },
    set_gridLines: function(value) {
        /// <summary>
        /// Sets the gridline style for a DataBoundTable control.
        /// </summary>
        /// <param name="value" type="JData.GridLines"/>
        this._gridLines = value;
    },

    get_headerRows: function() {
        /// <summary>
        /// Gets a Array object that represents the header rows in a GridView control.
        /// </summary>
        /// <returns type="Array"/>
        return this._headerRows;
    },

    get_headerStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the header row in a GridView control.
        /// </summary>
        ///	<returns type="JData.TableItemStyle" />
        return this._headerStyle;
    },
    set_headerStyle: function(value) {
        this._headerStyle = value;
    },

    get_pageCount: function() {
        /// <returns type="Number" mayBeNull="true">
        /// Gets the number of pages required to display the records of the data source in a GridView control.
        /// </returns>
        return this._pageCount;
    },

    get_pageIndex: function() {
        /// <returns type="Number">
        /// The zero-based index of the currently displayed page.
        /// </returns>
        return this._pageIndex;
    },
    set_pageIndex: function(number) {
        /// <summary>
        /// Sets the index of the currently displayed page.
        /// </summary>
        this._pageIndex = number;
    },

    get_pagerStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the pager row in a GridView control.
        /// </summary>
        ///	<value type="JData.TableItemStyle" />
        return this._pagerStyle;
    },
    set_pagerStyle: function(value) {
        this._pagerStyle = value;
    },

    get_rows: function() {
        /// <summary>
        /// Gets a collection of TableRow objects that represent the data rows in a DataBoundTable control.
        /// </summary>
        /// <returns type="Array"/>
        Sys.Debug.assert(Array.isInstanceOfType(this._rows));
        return this._rows;
    },

    get_rowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the data rows in a DataBoundTable control.
        /// </summary>
        ///	<value type="JData.TableItemStyle" />
        return this._rowStyle;
    },
    set_rowStyle: function(value) {
        this._rowStyle = value;
    },

    get_showCaption: function() {
        /// <summary>
        /// Gets a value indicating whether the caption row is displayed in a GridView control.
        /// </summary>
        return this.get_caption() != null;
    },

    get_dataSource: function() {
        /// <summary>
        /// Gets the object from which the data-bound control retrieves its list of data items.
        /// </summary>
        ///	<returns type="JData.DataSource" mayBeNull="true"/>
        return this._dataSource;
    },
    set_dataSource: function(dataSource) {
        /// <summary>
        /// Sets the object from which the data-bound control retrieves its list of data items.
        /// </summary>
        ///	<param name="items" type="JData.DataSource"/>
        Sys.Debug.assert(JData.DataSource.isInstanceOfType(dataSource) ||
                         Array.isInstanceOfType(dataSource));

        if (this._dataSource == dataSource)
            return;

        this._dataSource = dataSource;
    },

    //=============== Methods ===============

    initialize: function() {
        JData.DataBoundTable.callBaseMethod(this, 'initialize');
        this._render();
    },

    createHeaderRow: function(index, properties, rowType) {
        /// <param name="index" type="Number" mayBeNull="false"/>
        /// <param name="properties" type="JSON" mayBeNull="true"/>
        /// <param name="rowType" type="Type" mayBeNull="false"/>
        /// <returns type="JData.TableRow"/>
        if (index == null) throw Error.argumentNull('index');
        if (rowType == null) throw Error.argumentNull('rowType');
        if (properties == null)
            properties = {}

        properties.rowType = JData.DataControlRowType.Header;
        return this._CreateRow(index, properties, rowType);
    },

    createRow: function(index, properties, rowType) {
        /// <param name="index" type="Number" mayBeNull="false"/>
        /// <param name="properties" type="JSON" mayBeNull="true"/>
        /// <param name="rowType" type="Type" mayBeNull="false"/>
        /// <returns type="JData.TableRow"/>
        if (index == null) throw Error.argumentNull('index');
        if (rowType == null) throw Error.argumentNull('rowType');
        if (properties == null)
            properties = {};

        properties.rowType = JData.DataControlRowType.DataRow;

        return this._CreateRow(index, properties, rowType);
    },

    createFooterRow: function(index, properties, rowType) {
        /// <param name="index" type="Number" mayBeNull="false"/>
        /// <param name="properties" type="JSON" mayBeNull="true"/>
        /// <param name="rowType" type="Type" mayBeNull="false"/>
        /// <returns type="JData.TableRow"/>
        if (index == null) throw Error.argumentNull('index');
        if (rowType == null) throw Error.argumentNull('rowType');
        if (properties == null)
            properties = {};

        properties.rowType = JData.DataControlRowType.Footer;

        return this._CreateRow(index, properties, rowType);
    },

    removeRow: function(row) {
        this._RemoveRow(row);
    },

    dataBind: function() {
        if (this._rendered == false) {
            this._render();
            return;
        }
        var gridView = this;
        var items;
        var dataSource = this._getClientDataSource();
        if (dataSource == null)
            return;

        var total = -1;

        args = this._getSelectArgument();
        var successCallBack = function(items) {
            var total;
            if (gridView.get_allowPaging()) {
                if (dataSource.canRetrieveTotalRowCount()) {
                    //if(args.get_retrieveTotalRowCount()){
                    total = args.get_totalRowCount();
                    if (total == null)
                        throw Error.argumentNull('args.totalRowCount');
                }
                else if (dataSource.canPage() == false) {
                    total = items.length;
                }

                if (total >= 0) {
                    Sys.Debug.assert(gridView.get_pageSize() > 0);
                    gridView._pageCount = Math.ceil(total / gridView.get_pageSize());
                }
            }
            else {
                gridView._pageCount = 1;
            }
            gridView._CreateRows(items);
            var h = gridView.get_events().getHandler('dataBound');
            if (h) h(gridView, {});
        }
        var failCallBack = function(message) {
            gridView._showError(message);
        };
        if (this.get_allowPaging()) {
            args.set_maximumRows(this.get_pageSize());
            Sys.Debug.assert(this.get_pageIndex() >= 0);
            args.set_startRowIndex(this.get_pageIndex() * this.get_pageSize());
            dataSource.executeSelect(args, successCallBack, failCallBack);
        }
        else {
            args.set_maximumRows(-1);
            dataSource.executeSelect(args, successCallBack, failCallBack);
        }
    },

    //==========================================================================

    _fields: function(value) {
        /// <param name="value" type="Array"/>
        /// <returns type="Array"/>
        if (value == null)
            return this.__fields;

        for (var i = 0; i < value.length; i++) {
            value[i]._Index = i;
            value[i]._set_owner(this);
        }
        this.__fields = value;
    },

    _visibleFields: function() {
        /// <returns type="Array"/>
        var array = new Array();
        for (var i = 0; i < this._fields().length; i++) {
            if (this._fields()[i].get_visible() == true)
                Array.add(array, this._fields()[i]);
        }
        return array;
    },

    //========================================================================

    _pagerType: function() {
        var mode = this.get_pagerSettings().get_mode();
        if (mode == JData.PagerButtons.NextPrevious ||
                    mode == JData.PagerButtons.NextPreviousFirstLast)
            return JData.TextPagingBar;

        if (mode == JData.PagerButtons.Numeric ||
                    mode == JData.PagerButtons.NumericFirstLast)
            return JData.NumberPagingBar;

    },

    _GetRowType: function(index, properties) {
        /// <param name="index" type="Number">
        /// Index of the row.
        /// </param>
        /// <param name="properties" type="JSON">
        /// </param>
        /// <returns type="Type"/>
        throw Error.notImplemented();
    },

    _GetRowStyle: function(tableRow) {
        /// <param name="tableRow" type="JData.GridViewRow">
        /// </param>

        var style = this.get_rowStyle();
        var index = Array.indexOf(this.get_rows(), tableRow);
        if (index / 2 != Math.round(index / 2)) {
            style = this.get_alternatingRowStyle().mergeWith(style);
        }
        return style;
    },

    _getClientDataSource: function() {
        if (this._clientDataSource == null) {
            if (this.get_dataSource() == null)
                return null;

            if (Array.isInstanceOfType(this.get_dataSource())) {
                this._clientDataSource = new JData.ArrayDataSource(this.get_dataSource());
            }
            else if (JData.ArrayDataSource.isInstanceOfType(this.get_dataSource())) {
                this._clientDataSource = this.get_dataSource();
            }
            else {
                if (this.get_allowPaging() && !this.get_dataSource().canPage())
                    this._clientDataSource = new JData.PagingDataSource(this.get_dataSource());
                else
                    this._clientDataSource = this.get_dataSource();
            }
        }
        return this._clientDataSource;
    },

    _showError: function(error, cells) {
        if (error == null)
            error = 'error';
        if (!String.isInstanceOfType(error) && cells != null) {
            for (var i = 0; i < cells.length; i++) {
                var cell = cells[i];
                var msg = error[cell.get_containingField().get_dataField()];
                if (msg != null)
                    cell._showError(msg);
                else
                    cell._clearError();
            }
            return;
        }
        alert(error);
    },

    _clearError: function(cells) {
        for (var i = 0; i < cells.length; i++) {
            var cell = cells[i];
            if (JData.EditableCell.isInstanceOfType(cell))
                cell._clearError();
        }
    },

    _createValidator: function(cell) {
        var validator = new JData.BaseValidator(cell);
        Array.add(this._validators, validator);
        return validator;
    },

    _CreateHeader: function() {
        //create caption row
        var gridView = this;
        if (gridView.get_showCaption()) {
            var properties = { cellText: gridView.get_caption(), rowType: JData.DataControlRowType.Header };
            var row = gridView._CreateRow(0, properties);
            var style = gridView.get_captionStyle();
            for (var i = 0; i < row.get_cells().length; i++) {
                row.get_cells()[i].applyStyle(style);
            }
        }

        if (gridView.get_allowPaging() && gridView.get_pagerSettings().get_visible() &&
            (this.get_pagerSettings().get_position() & JData.PagerPosition.Top) == JData.PagerPosition.Top) {
            var properties = { parent: gridView, rowType: JData.DataControlRowType.Header };
            var pagingBar = gridView._CreateRow(gridView.get_headerRows().length, properties, this._pagerType());
            pagingBar.applyStyle(gridView.get_pagerStyle());
        }

        //gnerate the grid header
        if (gridView.get_showHeader()) {
            var properties = { rowType: JData.DataControlRowType.Header };
            var index = gridView.get_headerRows().length;
            var row = gridView._CreateRow(index, properties);
            var style = gridView.get_headerStyle();
            row.applyStyle(style);
        }
    },

    _CreateFooter: function() {
        //generate the grid footer
        var gridView = this;
        if (gridView.get_showFooter() == true) {
            var properties = {
                parent: gridView,
                rowType: JData.DataControlRowType.Footer
            };
            var row = gridView._CreateRow(gridView.get_footerRows().length, properties);
            row.applyStyle(gridView.get_footerStyle());
        }

        //create paging bar
        if (gridView.get_allowPaging() && gridView.get_pagerSettings().get_visible() &&
            (this.get_pagerSettings().get_position() & JData.PagerPosition.Bottom) == JData.PagerPosition.Bottom) {
            var properties = { parent: gridView, rowType: JData.DataControlRowType.Footer };
            //var rowType = gridView._GetRowType(JData.DataControlRowType.Pager, properties);
            var pagingBar = gridView._CreateRow(gridView.get_footerRows().length, properties, this._pagerType());
            pagingBar.applyStyle(gridView.get_pagerStyle());
        }
    },



    _CreateRow: function(index, properties, rowType) {
        /// <param name="rowType" type="Type" mayBeNull="true"/>

        if (index == null) throw Error.argumentNull('index');
        if (properties == null) throw Error.argumentNull('properties');
        if (properties.rowType == null) throw Error.argumentNull('properties.rowType');

        if (properties.rowType == JData.DataControlRowType.DataRow) {
            var h = this.get_events().getHandler('rowCreating');
            if (h) h(this, { properties: properties });
        }

        var elementIndex;
        var rows;
        switch (properties.rowType) {
            case JData.DataControlRowType.Header:
                elementIndex = index;
                rows = this.get_headerRows();
                break;
            case JData.DataControlRowType.DataRow:
                rows = this.get_rows();
                elementIndex = index + this.get_headerRows().length;
                break;
            case JData.DataControlRowType.Footer:
                rows = this.get_footerRows();
                elementIndex = index + this.get_rows().length + this.get_headerRows().length;
                break;
            default:
                throw Error.notImplemented(properties.rowType);
        }

        if (index < 0 || index > rows.length) throw Error.argumentOutOfRange('index', index);

        if (rowType == null) {
            rowType = this._GetRowType(index, properties);
            Sys.Debug.assert(rowType != null);
        }

        var rowElement = this.get_element().insertRow(elementIndex);
        properties.parent = this;
        var row = $create(rowType, properties, null, null, rowElement);
        Array.insert(rows, index, row);

        var gridView = this;

        if (properties.rowType == JData.DataControlRowType.DataRow) {
            var h = this.get_events().getHandler('rowCreated');
            if (h) h(this, { row: row });
        }
        return row;
    },

    _CreateRows: function(items) {
        var gridView = this;
        while (gridView.get_rows().length > 0) {
            gridView._RemoveRow(gridView.get_rows()[0]);
        }
        for (var i = 0; i < items.length; i++) {
            var row = gridView._CreateDataRow(i, items[i]);
            var style = this._GetRowStyle(row);
            row.applyStyle(style);
        }
    },


    _getSelectArgument: function(value) {
        if (this._getSelectArgumentResult == null) {
            this._getSelectArgumentResult = new JData.DataSourceSelectArguments();
        }

        if (this.get_allowPaging()) {
            var args = this._getSelectArgumentResult;
            args.set_maximumRows(this.get_pageSize());
            args.set_startRowIndex(this.get_pageIndex() * this.get_pageSize());
        }
        return this._getSelectArgumentResult;
    },

    _HandleCancle: function(row) {
        throw Error.notImplemented();
    },

    _HandleDelete: function(row) {
        throw Error.notImplemented();
    },

    _HandleEdit: function(row) {
        throw Error.notImplemented();
    },

    _HandleInsert: function(row) {
        throw Error.notImplemented();
    },

    _HandleNew: function(beforeRow) {
        throw Error.notImplemented();
    },

    _HandlePage: function(pageIndex) {
        throw Error.notImplemented();
    },

    _HandleUpdate: function(cells) {
        //throw Error.notImplemented();
        for (var i = 0; i < cells.length; i++)
            cells[i].pushValue();

        var dataSource = this._getClientDataSource();
        var gridView = this;
        var successedCallback = function() {
            row.changeMode(JData.DataMode.ReadOnly);

            var h = gridView.get_events().getHandler('rowUpdated');
            if (h) h(gridView, { row: row });
        };

        var failedCallback = function(error) {
            for (var key in row.get_dataItem()) {
                row.get_dataItem()[key] = oldItem[key];
            }
            gridView._showError(error, cells);
        };

        dataSource.update(row.get_dataItem(), successedCallback, failedCallback);
    },

    _RemoveRow: function(row) {
        if (row == null)
            throw Error.argumentNull('row');

        if (JData.DataControlRowType.DataRow == row.get_rowType()) {
            var h = this.get_events().getHandler('rowRemoving');
            if (h) h(this, { row: row });
        }

        var rows;
        switch (row.get_rowType()) {
            case JData.DataControlRowType.Header:
                rows = this.get_headerRows();
                break;
            case JData.DataControlRowType.DataRow:
                rows = this.get_rows();
                break;
            case JData.DataControlRowType.Footer:
                rows = this.get_footerRows();
                break;
            //case JData.DataControlRowType.EmptyDataRow:                                                                                                                                                                                                              
            //case JData.DataControlRowType.Pager:                                                                                                                                                                                                              
            default:
                throw Error.notImplemented(row.get_rowType());
        }

        this.get_element().deleteRow(row.get_element().rowIndex);
        Array.remove(rows, row);

        if (JData.DataControlRowType.DataRow == row.get_rowType()) {
            var h = this.get_events().getHandler('rowRemoved');
            if (h) h(this, { row: row });
        }

        row.dispose();
    },

    _CreateDataRow: function(index, dataItem) {
        var properties = {
            parent: this,
            dataItem: dataItem,
            rowType: JData.DataControlRowType.DataRow
        };
        var row = this._CreateRow(index, properties);
        var style = this._GetRowStyle(row);
        row.applyStyle(style);
        return row;
    },



    _createEmptyRow: function(text) {
        if (text == null)
            text = this.get_emptyDataText();

        var gridView = this;
        if (gridView.emptyRow == null) {
            var properties = { rowType: JData.DataControlRowType.Header, text: this.get_emptyDataText() };
            this.emptyRow = this._CreateRow(this.get_headerRows().length, properties, JData.SingleCellRow);
            var style = gridView.get_emptyDataRowStyle();
            this.emptyRow.applyStyle(style);
        }
    },
    _removeEmptyRow: function() {
        var gridView = this;
        if (gridView.emptyRow != null) {
            gridView._RemoveRow(this.emptyRow);
            gridView.emptyRow = null;
        }
    },

    _clearRows: function() {
        var table = this.get_element();
        while (table.rows.length > 0) {
            table.deleteRow(table.rows.length - 1);
        }
    },

    _render: function() {

        this._clearRows();
        var gridView = this;
        switch (gridView.get_gridLines()) {
            case JData.GridLines.Both:
                gridView.get_element().style.borderCollapse = 'collapse';
                gridView.get_element().border = '1';
                break;
            case JData.GridLines.None:
                gridView.get_element().style.borderCollapse = 'collapse';
                gridView.get_element().border = '0';
                break;
            case JData.GridLines.Horizontal:
                gridView.get_element().borderCollapse = 'collapse';
                gridView.get_element().border = '1';
                gridView.get_element().rules = 'rows';
                break;
            case JData.GridLines.Vertical:
                gridView.get_element().style.borderCollapse = 'collapse';
                gridView.get_element().style.border = '1';
                gridView.get_element().rules = 'cols';
                break;
        }
        if (gridView.get_cssClass() != null) {
            gridView.get_element().className = gridView.get_cssClass();
        }

        if (gridView.get_width() != null)
            gridView.get_element().width = gridView.get_width();

        gridView._CreateHeader();

        //Create Empty GridRow
        this._createEmptyRow();

        gridView._CreateFooter();


        this.dataBind();
        this._rendered = true;

    }
};

JData.DataBoundTable.registerClass('JData.DataBoundTable', JData.WebControl);

//============================== JData.PagerSettings ================================

JData.PagerSettings = function() {
    this.set_pageButtonCount(10);
    this.set_position(JData.PagerPosition.Bottom);
    this.set_visible(true);
    this.set_mode(JData.PagerButtons.Numeric);
    this.set_firstPageText("&lt;&lt;");
    this.set_lastPageText("&gt;&gt;");
    this.set_nextPageText("&gt;");
    this.set_previousPageText("&lt;");
};

JData.PagerSettings.prototype = {
    get_firstPageText: function() {
        /// <return type="String">
        /// Gets the text to display for the first-page button.
        /// </return>
        return this._FirstPageText;
    },
    set_firstPageText: function(value) {
        /// <param name="value" type="String">
        /// Sets the text to display for the first-page button.
        /// </param>
        this._FirstPageText = value;
    },

    get_lastPageText: function() {
        /// <summary>
        /// Gets the text to display for the last-page button.
        /// </summary>
        /// <return type="String"/>
        return this._LastPageText;
    },
    set_lastPageText: function(value) {
        /// <summary>
        /// Sets the text to display for the last-page button.
        /// </summary>
        /// <param name="value" type="String"/>
        this._LastPageText = value;
    },

    get_mode: function() {
        /// <summary>
        /// Gets the mode in which to display the pager controls in a control that supports pagination.
        /// </summary>
        /// <return type="JData.PagerButtons" />
        return this._Mode;
    },
    set_mode: function(value) {
        /// <summary>
        /// Sets the mode in which to display the pager controls in a control that supports pagination.
        /// </summary>
        /// <param name="value" type="JData.PagerButtons" />
        this._Mode = value;
    },

    get_nextPageText: function() {
        /// <summary>
        /// Gets the text to display for the next-page button.
        /// </summary>
        return this._NextPageText;
    },
    set_nextPageText: function(value) {
        /// <summary>
        /// Sets the text to display for the next-page button.
        /// </summary>
        this._NextPageText = value;
    },

    get_pageButtonCount: function() {
        /// <summary>
        /// Gets the number of page buttons to display in the pager when the Mode property is set to the Numeric or NumericFirstLast value.
        /// </summary>
        return this._pageButtonCount;
    },
    set_pageButtonCount: function(value) {
        /// <summary>
        /// Sets the number of page buttons to display in the pager when the Mode property is set to the Numeric or NumericFirstLast value.
        /// </summary>
        this._pageButtonCount = value;
    },

    get_position: function() {
        /// <summary>
        /// Gets a value that specifies the location where the pager is displayed.
        /// </summary>
        /// <returns type="JData.PagerPosition"/>
        return this._position;
    },
    set_position: function(value) {
        /// <summary>
        /// Sets a value that specifies the location where the pager is displayed.
        /// </summary>
        /// <param name="value" type="JData.PagerPosition"/>
        this._position = value;
    },

    get_previousPageText: function() {
        /// <summary>
        /// Gets the text to display for the previous page button.
        /// </summary>
        /// <returns type="String" />
        return this._PreviousPageText;
    },
    set_previousPageText: function(value) {
        /// <summary>
        /// Sets the text to display for the previous page button.
        /// </summary>
        /// <param name="value" type="String"/>
        this._PreviousPageText = value;
    },

    get_visible: function() {
        /// <summary>
        /// Gets a value indicating whether the paging controls are displayed in a control that supports pagination.
        /// </summary>
        /// <returns type="Boolean" />
        return this._Visible;
    },
    set_visible: function(value) {
        /// <summary>
        /// Sets a value indicating whether the paging controls are displayed in a control that supports pagination.
        /// </summary>
        /// <param name="value" type="Boolean" />
        this._Visible = value;
    }
};

JData.PagerSettings.registerClass('JData.PagerSettings');

Type.registerNamespace("JData");

//================================== GridView ============================================

JData.GridView = function(element) {

    JData.GridView.initializeBase(this, [element]);

    this.set_showHeader(true);
    this.set_showFooter(false);
    this.set_pageSize(10);
    this._fields([]);
    this._selectedRows = new Array();
    this.set_selectedRowStyle(new JData.TableItemStyle());

    var gridView = this;
    this._onDataSourceInserted = function(sender, args) {
        if (args.item == null)
            throw Error.argumentNull('args.item');

        for (var i = 0; i < gridView.get_rows().length; i++) {
            var row = gridView.get_rows()[i];
            if (row.get_dataItem() == args.item) {
                return;
            }
        }
        gridView._CreateDataRow(gridView.get_rows().length, args.item);
    };
    this._onDataSourceDeleted = function(sender, args) {
        for (var i = 0; i < gridView.get_rows().length; i++) {
            var row = gridView.get_rows()[i];
            if (row.get_dataItem() == args.item) {
                gridView._RemoveRow(row);
                break;
            }
        }
    };
    this._onDataSourceUpdated = function(sender, args) {
        for (var i = 0; i < gridView.get_rows().length; i++) {
            var row = gridView.get_rows()[i];
            if (row.get_dataItem() == args.item) {
                for (var j = 0; j < row.get_cells().length; j++) {
                    var cell = row.get_cells()[j];
                    if (JData.EditableCell.isInstanceOfType(cell))
                        cell.set_value();
                }
                break;
            }
        }
    };
}

JData.GridView.prototype = {

    //=========================== EVENTS ==================================

    add_rowCancelingEdit: function(handler) {
        this.get_events().addHandler('rowCancelingEdit', handler);
    },
    remove_rowCancelingEdit: function(handler) {
        this.get_events().removeHandler('rowCancelingEdit', handler);
    },

    add_rowEditing: function(handler) {
        this.get_events().addHandler('rowEditing', handler);
    },
    remove_rowEditing: function(handler) {
        this.get_events().addHandler('rowEditing', handler);
    },

    add_rowSelected: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but after the GridView control selects the row.
        /// </summary>
        this.get_events().addHandler('rowSelected', handler);
    },
    remove_rowSelected: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but after the GridView control selects the row.
        /// </summary>
        this.get_events().removeHandler('rowSelected', handler);
    },

    add_rowSelecting: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but before the GridView control selects the row.
        /// </summary>
        this.get_events().addHandler('rowSelecting', handler);
    },
    remove_rowSelecting: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but before the GridView control selects the row.
        /// </summary>
        this.get_events().removeHandler('rowSelecting', handler);
    },

    add_rowUnselected: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but after the GridView control selects the row.
        /// </summary>
        this.get_events().addHandler('rowUnselected', handler);
    },
    remove_rowUnselected: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but after the GridView control selects the row.
        /// </summary>
        this.get_events().removeHandler('rowUnselected', handler);
    },

    add_rowUnselecting: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but before the GridView control selects the row.
        /// </summary>
        this.get_events().addHandler('rowUnselecting', handler);
    },
    remove_rowUnselecting: function(handler) {
        /// <summary>
        /// Occurs when a row's Select button is clicked, but before the GridView control selects the row.
        /// </summary>
        this.get_events().removeHandler('rowUnselecting', handler);
    },

    add_sorted: function(handler) {
        this.get_events().addHandler('sorted', handler);
    },
    remove_sorted: function(handler) {
        this.get_events().removeHandler('sorted', handler);
    },

    add_sorting: function(handler) {
        this.get_events().addHandler('sorting', handler);
    },
    remove_sorting: function(handler) {
        this.get_events().removeHandler('sorting', handler);
    },

    //=========================== PROPERTIES ==================================

    get_pageSize: function() {
        /// <summary>
        /// Gets the number of records to display on a page in a GridView control.
        /// </summary>
        /// <returns type="Number"/>
        return this._pageSize;
    },

    set_pageSize: function(number) {
        /// <summary>
        /// Sets the number of records to display on a page in a GridView control.
        /// </summary>
        /// <param name="number" type="Number"/>
        this._pageSize = number;
    },

    get_selectedRowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the selected row in a GridView control.
        /// </summary>
        /// <returns type="JData.TableItemStyle"/>
        return this._selectedRowStyle;
    },
    set_selectedRowStyle: function(value) {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of the selected row in a GridView control.
        /// </summary>
        /// <param name="value" type="JData.TableItemStyle"/>
        this._selectedRowStyle = value;
    },

    get_selectedRows: function() {
        return this._selectedRows;
    },

    get_showFooter: function() {
        /// <returns type="Boolean"/>
        return this._showFooter;
    },
    set_showFooter: function(value) {
        /// <param name="value" type="Boolean"/>
        this._showFooter = value;
    },

    get_showHeader: function() {
        /// <returns type="Boolean"/>
        return this._showHeader;
    },
    set_showHeader: function(value) {
        /// <param name="value" type="Boolean"/>
        this._showHeader = value;
    },

    set_columns: function(value) {
        /// <param name="value" type="Array"/>
        this._fields(value);
    },
    get_columns: function() {
        /// <returns type="Array"/>
        return this._fields();
    },

    getVisibleColumns: function() {
        /// <returns type="Array"/>
        var array = new Array();
        for (var i = 0; i < this._fields().length; i++) {
            if (this._fields()[i].get_visible() == true)
                Array.add(array, this._fields()[i]);
        }
        return array;
    },

    get_dataSource: function() {
        ///	<returns type="JData.DataSource" mayBeNull="true"/>
        return this._dataSource;
    },
    set_dataSource: function(dataSource) {
        ///	<param name="items" type="JData.DataSource"/>
        Sys.Debug.assert(JData.DataSource.isInstanceOfType(dataSource) ||
                         Array.isInstanceOfType(dataSource));

        if (this._dataSource == dataSource)
            return;

        this._dataSource = dataSource;
        this._clientDataSource = null;
        var h = this.get_events().getHandler('dataSourceChanged');
        if (h) h(this, { dataSource: dataSource });

        if (JData.DataSource.isInstanceOfType(dataSource)) {
            dataSource.add_inserted(this._onDataSourceInserted);
            dataSource.add_deleted(this._onDataSourceDeleted);
            dataSource.add_updated(this._onDataSourceUpdated);
        }
    },

    _GetRowType: function(index, properties) {
        /// <param name="index" type="Number">
        /// Index of the row.
        /// </param>
        /// <param name="properties" type="JSON">
        /// </param>
        /// <returns type="Type"/>
        if (index == null) throw Error.argumentNull('index');
        if (properties == null) throw Error.argumentNull('properties');
        if (properties.rowType == null) throw Error.argumentNull('properties.rowType');
        var gridView = this;
        switch (properties.rowType) {

            case JData.DataControlRowType.DataRow:
                return JData.GridViewRow;

            case JData.DataControlRowType.Footer:
                return JData.GridViewFooterRow;
            case JData.DataControlRowType.Header:
                if (index == 0 && this.get_showCaption())
                    return JData.SingleCellRow;
                return JData.GridViewHeaderRow;
            case JData.DataControlRowType.Pager:
                var mode = gridView.get_pagerSettings().get_mode();
                if (mode == JData.PagerButtons.NextPrevious ||
                    mode == JData.PagerButtons.NextPreviousFirstLast)
                    return JData.TextPagingBar;

                if (mode == JData.PagerButtons.Numeric ||
                    mode == JData.PagerButtons.NumericFirstLast)
                    return JData.NumberPagingBar;

                break;
            case JData.DataControlRowType.EmptyDataRow:
                return JData.EmptyGridViewRow;
            case JData.DataControlRowType.Separator:
                break;
        }
        throw Error.notImplemented();
    },

    _GetRowStyle: function(tableRow) {
        /// <param name="tableRow" type="JData.GridViewRow">
        /// </param>

        //var style = JData.GridView.callBaseMethod(this, '_GetRowStyle', [tableRow]);
        var style = this.get_rowStyle();
        var index = Array.indexOf(this.get_rows(), tableRow);
        if (index / 2 != Math.round(index / 2)) {
            style = this.get_alternatingRowStyle().mergeWith(style);
        }
        //return style;
        if (tableRow.$selected == true)
            style = style.mergeWith(this.get_selectedRowStyle());

        if (tableRow.$editing == true)
            style = style.mergeWith(this.get_editRowStyle());

        return style;
    },

    updateRowsStyle: function(from, end) {
        /// <param name="from" type="Number"/>
        /// <param name="end" type="Number" mayBeNull="true"/>

        var index = from;
        var j = 0;
        for (var i = index; i < this.get_rows().length; i++) {
            var row = this.get_rows()[i];
            if (row.get_visible() == false)
                continue;

            var style = this._GetRowStyle(row);
            row.applyStyle(style);
            j++;
        }
    },

    _HandleCancle: function(row) {
        var h = this.get_events().getHandler('rowCancelingEdit');
        if (h) h(this, { row: row });

        if (row.get_currentMode() == JData.DataMode.Insert) {
            this._RemoveRow(row);
        }
        else {
            row.changeMode(JData.DataMode.ReadOnly);
            row.$editing = false;
            style = this._GetRowStyle(row);
            row.applyStyle(style);
        }
        this._clearError(row.get_cells());
    },

    _HandleDelete: function(row) {

        Sys.Debug.assert(row.get_rowType() == JData.DataControlRowType.DataRow);
        var h = this.get_events().getHandler('rowDeleting');
        if (h) h(this, { row: row });

        var dataSource = this._getClientDataSource();

        var gridView = this;
        var success = function() {
            gridView._RemoveRow(row);
            var h = gridView.get_events().getHandler('rowDeleted');
            if (h) h(gridView, { row: row });
        }

        var fail = function(message) {
            gridView._showError(message)
        };

        var result = dataSource.executeDelete(row.get_dataItem(), success, fail);
    },

    _HandleEdit: function(row) {
        if (row.get_currentMode() != JData.DataMode.ReadOnly)
            return;

        row.changeMode(JData.DataMode.Edit);
        row.$editing = true;
        style = this._GetRowStyle(row);
        row.applyStyle(style);
    },

    _HandleInsert: function(row) {
        if (row.get_currentMode() != JData.DataMode.Insert)
            return;

        var h = this.get_events().getHandler('rowInserting');
        if (h) h(this, { row: row });

        var dataSource = this._getClientDataSource();

        var cells = new Array();
        var readOnlyCells = new Array();
        var newItem = row.get_dataItem();
        for (var i = 0; i < row.get_cells().length; i++) {
            var cell = row.get_cells()[i];
            if (JData.EditableCell.isInstanceOfType(cell) == false)
                continue;

            if (cell.get_containingField().get_readOnly())
                Array.add(readOnlyCells, cell);
            else
                Array.add(cells, cell);
        }

        for (var i = 0; i < cells.length; i++) {
            cells[i].pushValue();
        }


        var gridView = this;
        var successedCallback = function() {
            var h = gridView.get_events().getHandler('rowInserted');
            if (h) h(gridView, { row: row });
            row.changeMode(JData.DataMode.ReadOnly);
            for (var i = 0; i < readOnlyCells.length; i++) {
                readOnlyCells[i].set_value();
            }
            for (var i = 0; i < cells.length; i++) {
                cells[i].set_value();
            }
        };

        var failedCallback = function(message) {
            gridView._showError(message);
        };


        dataSource.insert(newItem, successedCallback, failedCallback);
    },

    _HandleNew: function(beforeRow) {
        var state = JData.DataControlRowState.Normal | JData.DataControlRowState.Insert;
        var dataItem = {};
        for (var i = 0; i < this.get_columns().length; i++) {
            var column = this.get_columns()[i];
            if (JData.BoundField.isInstanceOfType(column)) {
                var defaultValue = column.get_defaultValue();
                if (defaultValue != null) {
                    dataItem[column.get_dataField()] = defaultValue;
                }
            }
        }
        var properties = { parent: this, rowState: state, rowType: JData.DataControlRowType.DataRow, dataItem: dataItem };
        var index = 0;
        if (beforeRow != null)
            index = Array.indexOf(this.get_rows(), beforeRow) + 1;
        var row = this._CreateRow(index, properties);
        row.changeMode(JData.DataMode.Insert);
    },

    _HandlePage: function(pageIndex) {
        if (this.get_pageIndex() == pageIndex)
            return;

        var h = this.get_events().getHandler('pageIndexChanging');
        if (h) {
            h(this, Sys.EventArgs.Empty);
        }

        Sys.Debug.assert(pageIndex >= 0, 'pageIndex should >= 0');
        this.set_pageIndex(pageIndex);

        this.dataBind();

        var gridView = this;
        var h = this.get_events().getHandler('pageIndexChanged');
        if (h) {
            var method = function(sender, args) {
                h(this, Sys.EventArgs.Empty);
                gridView.remove_dataBound(method);
            }
            gridView.add_dataBound(method);
        }
    },

    _HandleSelect: function(row) {
        var selected = row.$selected == undefined ? false : row.$selected;

        var h = selected ? this.get_events().getHandler('rowUnselecting') : this.get_events().getHandler('rowSelecting');
        if (h) h(this, { row: row });

        var style;
        if (Array.contains(this._selectedRows, row)) {
            Array.remove(this._selectedRows, row);
            row.$selected = false;
            //style = this._GetRowStyle(row);
        }
        else {
            Array.add(this._selectedRows, row);
            row.$selected = true;
            //style = this.get_selectedRowStyle();
        }
        selected = row.$selected;
        style = this._GetRowStyle(row);
        row.applyStyle(style);

        h = selected ? this.get_events().getHandler('rowSelected') : this.get_events().getHandler('rowUnselected');
        if (h) h(this, { row: row });
    },

    _HandleSort: function(sortExpression, sortDirection) {
        /// <param name="sortExpression" type="string">
        /// </param>
        /// <param name="sortDirection" type="string">
        /// use asc or desc
        /// </param>
        var h = this.get_events().getHandler('sorting');
        if (h) h(this, {});

        var args = this._getSelectArgument();
        if (sortDirection == 'desc')
            args.set_sortExpression(sortExpression + ' desc');
        else
            args.set_sortExpression(sortExpression + ' asc');

        this.dataBind();

        var h = this.get_events().getHandler('sorted');
        if (h) h(gridView, {});

    },

    _HandleUpdate: function(row) {
        if (row.get_currentMode() != JData.DataMode.Edit)
            return;

        var h = this.get_events().getHandler('rowUpdating');
        if (h) h(this, { row: row });

        var cells = new Array();
        var oldItem = {};
        for (var key in row.get_dataItem()) {
            oldItem[key] = row.get_dataItem()[key];
        }

        var flag = true;
        for (var i = 0; i < row.get_cells().length; i++) {
            var cell = row.get_cells()[i];
            if (JData.EditableCell.isInstanceOfType(cell) && !cell.get_containingField().get_readOnly()) {
                if (cell.validate() == false)
                    flag = false;

                Array.add(cells, cell);
            }
        }

        if (flag == false)
            return;

        for (var i = 0; i < cells.length; i++)
            cells[i].pushValue();

        var dataSource = this._getClientDataSource();
        var gridView = this;
        var successedCallback = function() {
            row.changeMode(JData.DataMode.ReadOnly);

            row.$editing = false;
            style = gridView._GetRowStyle(row);
            row.applyStyle(style);

            var h = gridView.get_events().getHandler('rowUpdated');
            if (h) h(gridView, { row: row });
        };

        var failedCallback = function(error) {
            for (var key in row.get_dataItem()) {
                row.get_dataItem()[key] = oldItem[key];
            }
            gridView._showError(error, cells);
        };

        dataSource.update(row.get_dataItem(), successedCallback, failedCallback);
    },

    _render: function() {
        var gridView = this;
        gridView.add_rowRemoved(function(sender, args) {
            if (gridView.get_rows().length == 0) {
                gridView._createEmptyRow();
            }
        });
        gridView.add_rowCreated(function(sender, args) {
            if (gridView.get_rows().length > 0)
                gridView._removeEmptyRow();
        });

        JData.GridView.callBaseMethod(this, '_render', null);
    },

    initialize: function() {
        JData.GridView.callBaseMethod(this, 'initialize');

    }

}

JData.GridView.registerClass('JData.GridView', JData.DataBoundTable);

//================================== GridViewRow ============================================

JData.GridViewRow = function(element) {
    JData.GridViewRow.initializeBase(this, new Array(element));
    this._dataItem = {};
    this.set_rowState(JData.DataControlRowState.Normal);
    this._cells = new Array();
};

JData.GridViewRow.prototype = {

    get_rowState: function() {
        ///	<returns type="JData.DataControlRowState" />
        return this._rowState;
    },
    set_rowState: function(value) {
        /// <param name="value" type="JData.DataControlRowState"/>
        this._rowState = value;
    },

    get_rowType: function() {
        ///	<returns type="JData.DataControlRowType" />
        return this._rowType;
    },
    set_rowType: function(value) {
        /// <param name="value" type="JData.DataControlRowType"/>
        JData.DataControlRowType.isInstanceOfType(value);
        this._rowType = value;
    },

    get_cells: function() {
        /// <returns type="Array"/>
        return this._cells;
    },

    get_rowIndex: function() {

        Sys.Debug.assert(this.get_rowType() == JData.DataControlRowType.DataRow);
        var result;
        var sourceIndex = this.get_element().rowIndex;
        if (sourceIndex < 0)
            throw Error.create('The row is removed.');

        result = sourceIndex - this.get_parent().get_headerRows().length;
        return result;
    },

    remove: function() {
        this.get_parent().removeRow(this);
    },

    //===================== Properties =============================

    get_dataItem: function() {
        return this._dataItem;
    },
    set_dataItem: function(value) {
        var obj1 = {};
        var obj2 = {};

        var allFields = new Array();
        if (value != null) {
            for (var col in value)
                Array.add(allFields, col);
            obj1 = value;
        }

        if (this.get_dataItem() != null) {
            for (var col in this.get_dataItem()) {
                if (Array.contains(allFields, col) == false)
                    Array.add(allFields, col);
            }
            obj2 = this.get_dataItem();
        }

        var fields = new Array();
        for (var i = 0; i < allFields.length; i++) {
            var col = allFields[i];
            if (obj1[col] != obj2[col]) {
                Array.add(fields, col);
            }
        }

        if (fields.length > 0) {
            this._dataItem = value;
            var h = this.get_events().getHandler('valueChanged');
            var args = new Sys.EventArgs();
            args.fields = fields;
            if (h) h(this, args);
        }
    },

    isEdit: function() {
        return (this.get_rowState() & JData.DataControlRowState.Edit) == JData.DataControlRowState.Edit;
    },

    get_currentMode: function() {
        return this._currentMode;
    },

    changeMode: function(mode) {
        /// <param name="mode" type="JData.DataMode"/>

        if (mode == this.get_currentMode())
            return;

        var h = this.get_events().getHandler('modeChanging');
        if (h) h(this, { mode: mode });

        for (var i = 0; i < this.get_cells().length; i++) {
            var cell = this.get_cells()[i];
            if (JData.EditableCell.isInstanceOfType(cell) == false ||
                cell.get_containingField().get_readOnly())
                continue;

            if (mode != JData.DetailsViewMode.ReadOnly)
                cell.beginEdit();
            else
                cell.endEdit();
        }
        this._currentMode = mode;

        var h = this.get_events().getHandler('modeChanged');
        if (h) h(this, { mode: mode });
    },

    //===================== EVENTS =============================

    add_modeChanging: function(handler) {
        this.get_events().addHandler('modeChanging', handler);
    },
    remove_modeChanging: function(handler) {
        this.get_events().removeHandler('modeChanging', handler);
    },

    add_modeChanged: function(handler) {
        this.get_events().addHandler('modeChanged', handler);
    },
    remove_modeChanged: function(handler) {
        this.get_events().removeHandler('modeChanged', handler);
    },

    //==========================================================

    _createCells: function() {
        var gridView = this.get_parent();
        var columns = gridView.getVisibleColumns();
        for (var j = 0; j < columns.length; j++) {
            var col = columns[j];

            //var htmlCell = this.get_element().insertCell(this.get_element().cells.length)
            //var cell = col._CreateCell(htmlCell);
            var cell = col._CreateCell(this);
            if (cell != null) {
                cell.set_parent(this);
                Array.add(this.get_cells(), cell);
            }
        }
    },

    initialize: function() {
        var rowState = this.get_rowState();
        this._currentMode = JData.DataMode.ReadOnly;
        this._createCells();
    }
};

JData.GridViewRow.registerClass('JData.GridViewRow', JData.TableRow);

//================================ GridViewHeaderRow ================================

JData.GridViewHeaderRow = function(element) {
    JData.GridViewHeaderRow.initializeBase(this, new Array(element));
    this._setDirect('asc');
}

JData.GridViewHeaderRow.prototype = {
    _getDirect: function() {
        return this._direct;
    },
    _setDirect: function(string) {
        this._direct = string;
    },

    _createCells: function() {
        var gridView = this.get_parent();
        var row = this;
        var columns = gridView.getVisibleColumns();
        for (var j = 0; j < columns.length; j++) {
            var column = columns[j];
            var htmlRow = this.get_element();
            var cellElement = htmlRow.insertCell(htmlRow.cells.length);
            var cell = column._CreateHeaderCell(cellElement);
            if (cell != null)
                Array.add(this.get_cells(), cell);
        }
    },
    initialize: function() {
        this._createCells();
    }
}

JData.GridViewHeaderRow.registerClass('JData.GridViewHeaderRow', JData.TableRow);

//================================ GridViewFooterRow ================================

JData.GridViewFooterRow = function(element) {
    JData.GridViewFooterRow.initializeBase(this, new Array(element));
}

JData.GridViewFooterRow.prototype = {
    _createCells: function() {
        var gridView = this.get_parent();
        var gridView = this.get_parent();
        var columns = this.get_parent().getVisibleColumns();
        for (var j = 0; j < columns.length; j++) {
            var cell = this.createCell(columns[j]);
            cell.set_text(columns[j].get_footerText());
        }
    },
    initialize: function() {
        this._createCells();
    }
}

JData.GridViewFooterRow.registerClass('JData.GridViewFooterRow', JData.TableRow);

//=========================== SingleCellRow ===========================

JData.SingleCellRow = function(element) {
    JData.SingleCellRow.initializeBase(this, new Array(element));
};

JData.SingleCellRow.prototype = {
    get_cellText: function() {
        return this._cellText;
    },
    set_cellText: function(value) {
        this._cellText = value;
    },

    get_text: function() {
        return this.get_cellText();
    },
    set_text: function(value) {
        this.set_cellText(value);
    },

    initialize: function() {
        var cell = this.createCell();
        cell.set_text(this.get_cellText());
        if (this.get_parent().getVisibleColumns != null)
            var length = this.get_parent().getVisibleColumns().length;
        else
            var length = '300';

        if (length > 0)
            cell.get_element().colSpan = length; //$(cell.get_element()).attr('colSpan', length);
    }
};

JData.SingleCellRow.registerClass('JData.SingleCellRow', JData.GridViewRow);

//=========================== EmptyGridViewRow ===========================

JData.EmptyGridViewRow = function(element) {
    if (element == null)
        throw Error.argumentNull('element');

    JData.EmptyGridViewRow.initializeBase(this, new Array(element));

    this.set_text('Loading...');
}

JData.EmptyGridViewRow.prototype = {

}

JData.EmptyGridViewRow.registerClass('JData.EmptyGridViewRow', JData.SingleCellRow);

//====================================================================================











Type.registerNamespace("JData");

JData.DetailsView = function(element) {
    JData.DetailsView.initializeBase(this, new Array(element));

    this.set_fieldHeaderStyle(new JData.TableItemStyle());
    this.set_defaultMode(JData.DataMode.ReadOnly);
    this._mode = JData.DetailsViewMode.ReadOnly;
    this._commandRowStyle = new JData.TableItemStyle();
};

JData.DetailsView.prototype = {

    get_commandRowStyle: function() {
        /// <summary>
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of a command row in a DetailsView control.
        /// </summary>
        /// <returns type="JData.TableItemStyle"/>
        return this._commandRowStyle;
    },
    set_commandRowStyle: function(value) {
        /// <summary>
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of a command row in a DetailsView control.
        /// </summary>
        /// <param name="value" type="JData.TableItemStyle"/>
        this._commandRowStyle = value;
    },

    get_dataItem: function() {
        /// <summary>
        /// Gets the data item bound to the DetailsView control.
        /// </summary>
        /// <returns type="Object"/>
        return this._dataItem;
    },

    get_fieldHeaderStyle: function() {
        /// <returns type="JData.TableItemStyle"/>
        return this._fieldHeaderStyle;
    },
    set_fieldHeaderStyle: function(style) {
        /// <param name="value" type="JData.TableItemStyle"/>
        this._fieldHeaderStyle = style;
    },

    get_fields: function() {
        /// <return type="Array"/>
        return this._fields();
    },
    set_fields: function(value) {
        /// <param name="value" type="Array"/>
        this._fields(value);
    },

    get_footerText: function() {
        /// <summary>
        /// Gets the text to display in the footer row of a DetailsView control.
        /// </summary>
        /// <returns type="String"/>
        return this._footerText;
    },
    set_footerText: function(value) {
        /// <summary>
        /// Sets the text to display in the footer row of a DetailsView control.
        /// </summary>
        /// <param name="value" type="String"/>
        this._footerText = value;
    },

    get_headerText: function() {
        /// <summary>
        /// Gets the text to display in the header row of a DetailsView control.
        /// </summary>
        /// <returns type="String"/>
        return this._headerText;
    },
    set_headerText: function(value) {
        /// <summary>
        /// Sets the text to display in the header row of a DetailsView control.
        /// </summary>
        /// <param name="value" type="String"/>
        this._headerText = value;
    },

    get_pageSize: function() {
        return 1;
    },

    get_showHeader: function() {
        return this.get_headerText() != null;
    },

    get_showFooter: function() {
        return this.get_footerText() != null;
    },

    get_currentMode: function() {
        /// <returns type="JData.DetailsViewMode"/>
        return this._mode;
    },

    get_defaultMode: function() {
        /// <returns type="JData.DetailsViewMode"/>
        return this._defaultMode;
    },

    set_defaultMode: function(value) {
        /// <param name="value" type="JData.DetailsViewMode">
        /// readOnly, edit, insert
        /// </param>
        this._defaultMode = value;
    },

    //==================== Events ======================

    add_modeChanged: function(handler) {
        this.get_events().addHandler('modeChanged', handler);
    },
    remove_modeChanged: function(handler) {
        this.get_events().removeHandler('modeChanged', handler);
    },

    //==================== Methods ======================
    dataBind: function() {
        var dataSource = this._getClientDataSource();
        if (dataSource == null && this.get_defaultMode() == JData.DetailsViewMode.Insert) {
            this._HandleNew();
            return;
        }
        JData.DetailsView.callBaseMethod(this, 'dataBind');
    },

    changeMode: function(value) {
        /// <param name="value" type="JData.DetailsViewMode"/>
        //if(this.get_defaultMode() == JData.DetailsViewMode.Insert)
        if (this.get_currentMode() == value && this.get_defaultMode() != JData.DetailsViewMode.Insert)
            return;

        var h = this.get_events().getHandler('modeChanging');
        if (h) h(this, { mode: value });

        switch (value) {
            case JData.DetailsViewMode.Edit:
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    if (JData.DetailsViewCommandRow.isInstanceOfType(row))
                        continue;

                    row.get_cells()[1].beginEdit();
                }
                break;
            case JData.DetailsViewMode.Insert:
                //this._dataItem = {};
                this._CreateRows([{}]);
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    if (JData.DetailsViewCommandRow.isInstanceOfType(row))
                        continue;
                    row.get_cells()[1].beginEdit();
                }
                break;
            case JData.DetailsViewMode.ReadOnly:
                Sys.Debug.assert(this.get_currentMode() != JData.DetailsViewMode.ReadOnly)
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    if (JData.DetailsViewCommandRow.isInstanceOfType(row))
                        continue;
                    row.get_cells()[1].endEdit();
                }
                break;
        }
        this._mode = value;

        var h = this.get_events().getHandler('modeChanged');
        if (h) h(this, { mode: value });
    },

    _GetRowType: function(index, properties) {
        /// <param name="index" type="Number">
        /// Index of the row.
        /// </param>
        /// <param name="properties" type="JSON">
        /// </param>
        /// <returns type="Type"/>
        if (index == null) throw Error.argumentNull('index');
        if (properties == null) throw Error.argumentNull('properties');
        if (properties.rowType == null) throw Error.argumentNull('properties.rowType');
        var gridView = this;
        switch (properties.rowType) {

            case JData.DataControlRowType.DataRow:
                return JData.DetailsViewRow;

            case JData.DataControlRowType.Footer:
                properties.cellText = this.get_footerText();
                return JData.SingleCellRow;

            case JData.DataControlRowType.Header:
                if (index == 0 && this.get_showCaption())
                    return JData.SingleCellRow;
                properties.cellText = this.get_headerText();
                return JData.SingleCellRow;

            case JData.DataControlRowType.Pager:
                var mode = gridView.get_pagerSettings().get_mode();
                if (mode == JData.PagerButtons.NextPrevious ||
                    mode == JData.PagerButtons.NextPreviousFirstLast)
                    return JData.TextPagingBar;

                if (mode == JData.PagerButtons.Numeric ||
                    mode == JData.PagerButtons.NumericFirstLast)
                    return JData.NumberPagingBar;

            case JData.DataControlRowType.EmptyDataRow:
                return JData.EmptyGridViewRow;
            case JData.DataControlRowType.Separator:
                break;
        }
        throw Error.notImplemented();
    },

    _CreateRows: function(items) {
        var gridView = this;
        while (gridView.get_rows().length > 0) {
            gridView._RemoveRow(gridView.get_rows()[0]);
        }
        if (items.length > 0)
            gridView._removeEmptyRow();
        else {
            gridView._createEmptyRow();
            return;
        }

        var fields = this._visibleFields();
        var index = 0;
        this._dataItem = items[0];
        for (var i = 0; i < fields.length; i++) {
            if (JData.BoundField.isInstanceOfType(fields[i])) {
                var properties = {
                    parent: this,
                    dataItem: this.get_dataItem(),
                    rowType: JData.DataControlRowType.DataRow,
                    field: fields[i]
                };
                var row = this._CreateRow(index, properties);
                row.applyStyle(this._GetRowStyle(row));
                index = index + 1;
                row.get_cells()[0].applyStyle(this.get_fieldHeaderStyle());
            }
            else {
                var properties = {
                    parent: this,
                    //dataItem: this.get_dataItem(),
                    rowType: JData.DataControlRowType.DataRow,
                    field: fields[i]
                };
                var row = this._CreateRow(index, properties, JData.DetailsViewCommandRow);
                row.applyStyle(this.get_commandRowStyle());
            }

        }
        this._mode = JData.DetailsViewMode.ReadOnly;
    },

    _HandleCancle: function() {
        if (this.get_currentMode() == JData.DataMode.Insert) {
            this._HandlePage(this.get_pageIndex());
        }
        else {
            this.changeMode(this.get_defaultMode());
        }
    },

    _HandleDelete: function() {
        var h = this.get_events().getHandler('rowDeleting');
        if (h) h(this, {});

        var dataSource = this._getClientDataSource();
        var detailsView = this;
        var success = function() {
            var h = detailsView.get_events().getHandler('rowDeleted');
            if (h) h(detailsView, {});
        }

        var fail = function(message) {
            detailsView._showError(message)
        };

        var result = dataSource.executeDelete(this.get_dataItem(), success, fail);
        if (this.get_pageIndex() >= this.get_pageCount() - 1) {
            this._HandlePage(0);
        }
        else
            this._HandlePage(this.get_pageIndex());
    },

    _HandlePage: function(pageIndex) {
        Sys.Debug.assert(pageIndex >= 0, 'pageIndex should >= 0');
        this.changeMode(this.get_defaultMode());
        var gridView = this;
        var h = this.get_events().getHandler('pageIndexChanged');
        if (h) {
            var method = function(sender, args) {
                h(this, Sys.EventArgs.Empty);
                gridView.remove_dataBound(method);
            }
            gridView.add_dataBound(method);
        }
        this.set_pageIndex(pageIndex);
        this.dataBind();
    },

    _HandleEdit: function() {
        this.changeMode(JData.DetailsViewMode.Edit);
    },

    _HandleInsert: function() {
        var h = this.get_events().getHandler('rowInserting');
        if (h) h(this, { row: row });

        var detailView = this;
        var dataSource = this._getClientDataSource();

        var cells = new Array();
        var readOnlyCells = new Array();
        var newItem = this.get_dataItem();

        for (var i = 0; i < this.get_rows().length; i++) {
            var row = this.get_rows()[i];
            var cell = row.get_cells()[1];
            if (JData.EditableCell.isInstanceOfType(cell) == false)
                continue;

            if (cell.get_containingField().get_readOnly())
                Array.add(readOnlyCells, cell);
            else
                Array.add(cells, cell);
        }

        for (var i = 0; i < cells.length; i++) {
            cells[i].pushValue();
        }

        var successedCallback = function() {
            detailView.changeMode(detailView.get_defaultMode());
            if (detailView.get_defaultMode() == JData.DetailsViewMode.ReadOnly) {
                for (var i = 0; i < readOnlyCells.length; i++)
                    readOnlyCells[i].set_value();
            }

            var h = detailView.get_events().getHandler('rowInserted');
            if (h) h(detailView, {});
        };

        var failedCallback = function(message) {
            detailView._showError(message);
        };

        dataSource.insert(this.get_dataItem(), successedCallback, failedCallback);

    },

    _HandleNew: function() {
        this.changeMode(JData.DetailsViewMode.Insert);
    },

    _HandleUpdate: function() {
        if (this.get_currentMode() != JData.DataMode.Edit)
            return;

        var h = this.get_events().getHandler('rowUpdating');
        if (h) h(this, {});

        var cells = new Array();
        var oldItem = {};
        for (var key in this.get_dataItem()) {
            oldItem[key] = this.get_dataItem()[key];
        }

        var flag = true;
        for (var i = 0; i < this.get_rows().length; i++) {
            var row = this.get_rows()[i];
            var cell = row.get_cells()[1];
            if (JData.EditableCell.isInstanceOfType(cell) && !cell.get_containingField().get_readOnly()) {
                if (cell.validate(this.get_dataItem()) == false)
                    flag = false;
                Array.add(cells, cell);
            }
        }
        if (flag == false)
            return;

        for (var i = 0; i < cells.length; i++)
            cells[i].pushValue();

        var dataSource = this._getClientDataSource();
        var detailsView = this;
        var successedCallback = function() {
            detailsView.changeMode(detailsView.get_defaultMode());

            var h = detailsView.get_events().getHandler('rowUpdated');
            if (h) h(detailsView, {});
        };

        var failedCallback = function(message) {
            for (var key in detailsView.get_dataItem()) {
                detailsView.get_dataItem()[key] = oldItem[key];
            }
            detailsView._showError(message);
        };

        dataSource.update(this.get_dataItem(), successedCallback, failedCallback);

    },

    initialize: function() {
        JData.DetailsView.callBaseMethod(this, 'initialize');
        var details = this;
        details.add_dataBound(function(source, args) {
            details.changeMode(details.get_defaultMode());
        })
    }

}

JData.DetailsView.registerClass('JData.DetailsView', JData.DataBoundTable);

//================================ DetailsViewRow ================================

JData.DetailsViewRow = function(element) {

    if (element == null)
        throw Error.argumentNull();

    JData.DetailsViewRow.initializeBase(this, new Array(element));
};

JData.DetailsViewRow.prototype = {
    initialize: function() {
        Sys.Debug.assert(this.get_field() != null);

        var element = this.get_element();
        var field = this.get_field();
        Sys.Debug.assert(JData.BoundField.isInstanceOfType(field));
        var cell = $create(JData.DataControlFieldCell, { parent: this, containingField: this.get_field() }, null, null, element.insertCell(0));
        Array.add(this.get_cells(), cell);
        cell.set_text(this.get_field().get_headerText());

        var cellElement = this.get_element().insertCell(this.get_element().cells.length);
        cell = field._CreateCell(cellElement); //$create(this.get_field().get_cellType(), { parent: this, containingField: this.get_field() }, null, null, element.insertCell(1));
        Array.add(this.get_cells(), cell);

    },

    get_cells: function() {
        if (this._cells == null)
            this._cells = new Array();

        return this._cells;
    },

    get_field: function() {
        return this._field;
    },
    set_field: function(value) {
        this._field = value;
    },

    get_dataItem: function() {
        return this._dataItem;
    },
    set_dataItem: function(value) {
        this._dataItem = value;
    },

    get_rowIndex: function() {
        return Array.indexOf(this.get_parent().get_rows(), this);
    },

    //==================== Events ======================

    add_valueChanged: function(handler) {
        this.get_events().addHandler('valueChanged', handler);
    },
    remove_valueChanged: function(handler) {
        this.get_events().removeHandler('valueChanged', handler);
    }
};

JData.DetailsViewRow.registerClass('JData.DetailsViewRow', JData.TableRow);

//===============================================================================

JData.DetailsViewHeaderRow = function(element) {

    if (element == null)
        throw Error.argumentNull(element);

    JData.DetailsViewHeaderRow.initializeBase(this, new Array(element));

    var cellElement = this.get_element().insertCell(0);
    //$(cellElement).attr('colspan', '2');
    cellElement.colSpan = '2';
    var cell = $create(JData.DataControlFieldCell, { parent: this }, null, null, cellElement);
    Array.add(this.get_cells(), cell);
}

JData.DetailsViewHeaderRow.prototype = {
    initialize: function() {

    }
}

JData.DetailsViewHeaderRow.registerClass('JData.DetailsViewHeaderRow', JData.TableRow);

//===============================================================================


JData.DetailsViewFooterRow = function(element) {
    JData.DetailsViewFooterRow.initializeBase(this, new Array(element));

    var cellElement = this.get_element().insertCell(0);
    cellElement.colSpan = '2'; //$(cellElement).attr('colspan', '2');
    var cell = $create(JData.DataControlFieldCell, { parent: this }, null, null, cellElement);
    Array.add(this.get_cells(), cell);
}

JData.DetailsViewFooterRow.prototype = {

}

JData.DetailsViewFooterRow.registerClass('JData.DetailsViewFooterRow', JData.TableRow);


//================================== DetailsViewRow ==================================

JData.DetailsViewCommandRow = function(element) {
    JData.DetailsViewCommandRow.initializeBase(this, new Array(element));
};

JData.DetailsViewCommandRow.prototype = {

    //==================== Events ======================

    add_modeChanged: function(handler) {
        this.get_parent().add_modeChanged(handler);
    },

    add_modeChanging: function(handler) {
        this.get_parent().add_modeChanging(handler);
    },

    //==================== Properties ======================

    get_field: function() {
        return this._field
    },
    set_field: function(value) {
        this._field = value;
    },

    get_currentMode: function() {
        return this.get_parent().get_currentMode();
    },

    //==================== Methods ======================

    initialize: function() {
        var cellElement = this.get_element().insertCell(0);
        cellElement.colSpan = '2';
        var cell = this.get_field()._CreateCell(cellElement);
        cell.set_parent(this);
        Array.add(this.get_cells(), cell);
        var row = this;
        this.get_parent().add_pageIndexChanged(function() {
            var h = row.get_events().getHandler('valueChanged');
            if (h) h(row, { dataItem: row.get_dataItem() });
        });
    }
};

JData.DetailsViewCommandRow.registerClass('JData.DetailsViewCommandRow', JData.TableRow);

//====================================================================================




Type.registerNamespace("JData");

//============================== FormView ==============================

JData.FormView = function(element) {
    JData.FormView.initializeBase(this, [element]);
    Sys.Debug.assert(element.tagName == 'TABLE');

    this.set_fieldHeaderStyle(new JData.TableItemStyle());
    this.set_defaultMode(JData.DataMode.ReadOnly);
    this._commandRowStyle = new JData.TableItemStyle();
    this.set_commandPosition(JData.CommandPosition.Bottom);
}

JData.FormView.prototype = {

    //===================== Properties =============================

    get_commandField: function() {
        /// <returns type="JData.CommandFields"/>
        return this._commandFields;
    },
    set_commandField: function(value) {
        /// <param name="value" type="JData.CommandField"/>
        this._commandFields = value;
    },

    get_commandPosition: function() {
        /// <returns type="JData.CommandPosition"/>
        return this._commandPosition;
    },
    set_commandPosition: function(value) {
        /// <param name="value" type="JData.CommandPosition"/>
        this._commandPosition = value;
    },

    get_commandRowStyle: function() {
        /// <returns type="JData.TableItemStyle">
        /// Gets a reference to the TableItemStyle object that allows you to set the appearance of a command row in a DetailsView control.
        /// </returns>
        return this._commandRowStyle;
    },
    set_commandRowStyle: function(value) {
        /// <param name="value" type="JData.TableItemStyle">
        /// Sets a reference to the TableItemStyle object that allows you to set the appearance of a command row in a DetailsView control.
        /// </param>
        this._commandRowStyle = value;
    },

    get_dataItem: function() {
        return this._dataItem;
    },

    get_fieldHeaderStyle: function() {
        /// <returns type="JData.TableItemStyle"/>
        return this._fieldHeaderStyle;
    },
    set_fieldHeaderStyle: function(style) {
        /// <param name="value" type="JData.TableItemStyle"/>
        this._fieldHeaderStyle = style;
    },

    get_fields: function() {
        /// <return type="Array"/>
        return this._fields();
    },
    set_fields: function(value) {
        /// <param name="value" type="Array"/>
        this._fields(value);
    },

    get_footerText: function() {
        /// <returns type="String">
        /// Gets the text to display in the footer row of a DetailsView control.
        /// </returns>
        return this._footerText;
    },
    set_footerText: function(value) {
        /// <param name="value" type="String">
        /// Sets the text to display in the footer row of a DetailsView control.
        /// </param>
        this._footerText = value;
    },

    get_headerText: function() {
        /// <returns type="String">
        /// Gets the text to display in the header row of a DetailsView control.
        /// </returns>
        return this._headerText;
    },
    set_headerText: function(value) {
        /// <param name="value" type="String">
        /// Sets the text to display in the header row of a DetailsView control.
        /// </param>
        this._headerText = value;
    },

    get_pageSize: function() {
        return 1;
    },

    get_showHeader: function() {
        return this.get_headerText() != null;
    },

    get_showFooter: function() {
        return this.get_footerText() != null;
    },

    get_currentMode: function() {
        /// <returns type="JData.DataMode"/>
        if (this._mode == null)
            return this.get_defaultMode();
        return this._mode;
    },

    get_defaultMode: function() {
        /// <returns type="JData.DataMode"/>
        return this._defaultMode;
    },

    set_defaultMode: function(value) {
        /// <param name="value" type="JData.DataMode"/>
        this._defaultMode = value;
    },

    //======================= METHODS =======================

    changeMode: function(value) {
        /// <param name="value" type="JData.DataMode"/>
        if (this.get_currentMode() == value)
            return;

        var h = this.get_events().getHandler('modeChanging');
        if (h) h(this, { mode: value });

        switch (value) {
            case JData.DataMode.Edit:
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    var cells = row.get_cells();
                    for (var j = 0; j < cells.length; j++) {
                        var cell = cells[j];
                        if (cell.beginEdit != null && cell.get_containingField().get_readOnly() == false)
                            cell.beginEdit();
                    }
                }
                break;
            case JData.DataMode.Insert:
                this._CreateRows([{}]);
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    var cells = row.get_cells();
                    for (var j = 0; j < cells.length; j++) {
                        var cell = cells[j];
                        if (cell.beginEdit != null && cell.get_containingField().get_readOnly() == false)
                            cell.beginEdit();
                    }
                }
                break;
            case JData.DataMode.ReadOnly:
                Sys.Debug.assert(this.get_currentMode() != JData.DataMode.ReadOnly)
                this._dataItem = this._orgDataItem;
                for (var i = 0; i < this.get_rows().length; i++) {
                    var row = this.get_rows()[i];
                    var cells = row.get_cells();
                    for (var j = 0; j < cells.length; j++) {
                        var cell = cells[j];
                        if (cell.endEdit != null)
                            cell.endEdit();
                    }
                }
                break;
        }
        this._mode = value;

        var h = this.get_events().getHandler('modeChanged');
        if (h) h(this, { mode: value });
    },

    _HandleCancle: function() {
        if (this.get_currentMode() == JData.DataMode.Insert) {
            this._HandlePage(this.get_pageIndex());
        }
        else {
            this.changeMode(JData.DataMode.ReadOnly);
        }
    },

    _HandleDelete: function() {

        var dataSource = this._getClientDataSource();
        var gridView = this;
        var success = function() {
            var h = gridView.get_events().getHandler('rowDeleted');
            if (h) h(gridView, { row: row });
        }

        var fail = function(message) {
            gridView._showError(message)
        };

        var result = dataSource.executeDelete(this.get_dataItem(), success, fail);
        if (this.get_pageIndex() >= this.get_pageCount() - 1) {
            this._HandlePage(0);
        }
        else
            this._HandlePage(this.get_pageIndex());
    },

    _HandleEdit: function(row) {
        this.changeMode(JData.DataMode.Edit);
    },

    _HandleInsert: function() {
        var formView = this;
        var dataSource = this._getClientDataSource();
        dataSource.insert(this._dataItem,
        function() {
            for (var i = 0; i < formView.get_rows().length; i++) {
                var cells = formView.get_rows()[i].get_cells();
                for (var j = 0; j < cells.length; j++) {
                    var cell = cells[j];
                    if (cell.pushValue != null && !cell.get_containingField().get_readOnly()) {
                        cell.pushValue();
                    }
                }
            }
            formView.changeMode(JData.DataMode.ReadOnly);
            for (var i = 0; i < formView.get_rows().length; i++) {
                var cells = formView.get_rows()[i].get_cells();
                for (var j = 0; j < cells.length; j++) {
                    var cell = cells[j];
                    if (cell._displayValue != null && cell.get_containingField().get_readOnly()) {
                        cell._displayValue();
                    }
                }

            }
        },
        function(message) {
            detailView._showError(message);
        });
    },

    _HandleNew: function() {
        this.changeMode(JData.DetailsViewMode.Insert);
    },

    _HandlePage: function(pageIndex) {
        Sys.Debug.assert(pageIndex >= 0, 'pageIndex should >= 0');
        this.changeMode(JData.DetailsViewMode.ReadOnly);
        var gridView = this;
        var h = this.get_events().getHandler('pageIndexChanged');
        if (h) {
            var method = function(sender, args) {
                h(this, Sys.EventArgs.Empty);
                gridView.remove_dataBound(method);
            }
            gridView.add_dataBound(method);
        }
        this.set_pageIndex(pageIndex);
        this.dataBind();
    },

    _HandleUpdate: function() {
        if (this.get_currentMode() != JData.DataMode.Edit)
            return;

        var h = this.get_events().getHandler('rowUpdating');
        if (h) h(this, {});

        var cells = new Array();
        var oldItem = {};
        for (var key in this.get_dataItem()) {
            oldItem[key] = this.get_dataItem()[key];
        }

        var flag = true;
        for (var i = 0; i < this.get_rows().length; i++) {
            var row = this.get_rows()[i];
            for (var j = 0; j < row.get_cells().length; j++) {
                var cell = row.get_cells()[j];
                if (JData.EditableCell.isInstanceOfType(cell) && !cell.get_containingField().get_readOnly()) {
                    if (cell.validate(this.get_dataItem()) == false)
                        flag = false;
                    Array.add(cells, cell);
                }
            }
        }
        if (flag == false)
            return;

        for (var i = 0; i < cells.length; i++)
            cells[i].pushValue();

        var dataSource = this._getClientDataSource();
        var formView = this;
        var successedCallback = function() {
            formView.changeMode(JData.DataMode.ReadOnly);

            var h = formView.get_events().getHandler('rowUpdated');
            if (h) h(formView, {});
        };

        var failedCallback = function(message) {
            for (var key in formView.get_dataItem()) {
                formView.get_dataItem()[key] = oldItem[key];
            }
            //alert(error.get_message());
            formView._showError(message);
        };

        dataSource.update(row.get_dataItem(),  successedCallback, failedCallback);

    },

    _GetRowType: function(index, properties) {
        /// <param name="index" type="Number">
        /// Index of the row.
        /// </param>
        /// <param name="properties" type="JSON">
        /// </param>
        /// <returns type="Type"/>
        if (index == null) throw Error.argumentNull('index');
        if (properties == null) throw Error.argumentNull('properties');
        if (properties.rowType == null) throw Error.argumentNull('properties.rowType');
        var gridView = this;
        switch (properties.rowType) {

            case JData.DataControlRowType.DataRow:
                return JData.FormViewRow;

            case JData.DataControlRowType.Footer:
                properties.cellText = this.get_footerText();
                return JData.SingleCellRow;

            case JData.DataControlRowType.Header:
                if (index == 0 && this.get_showCaption())
                    return JData.SingleCellRow;
                properties.cellText = this.get_headerText();
                return JData.SingleCellRow;

            case JData.DataControlRowType.Pager:
                var mode = gridView.get_pagerSettings().get_mode();
                if (mode == JData.PagerButtons.NextPrevious ||
                    mode == JData.PagerButtons.NextPreviousFirstLast)
                    return JData.TextPagingBar;

                if (mode == JData.PagerButtons.Numeric ||
                    mode == JData.PagerButtons.NumericFirstLast)
                    return JData.NumberPagingBar;

            case JData.DataControlRowType.EmptyDataRow:
                return JData.EmptyGridViewRow;
            case JData.DataControlRowType.Separator:
                break;
        }
        throw Error.notImplemented();
    },

    _CreateRows: function(items) {
        if (items.length > 0)
            this._removeEmptyRow();
        else {
            this._createEmptyRow();
            return;
        }
        this._dataItem = items[0];
        for (var i = 0; i < this.get_rows().length; i++) {
            var row = this.get_rows()[i];
            row.set_visible(true);
            row.set_dataItem(this.get_dataItem());
            for (var j = 0; j < row.get_cells().length; j++) {
                var cell = row.get_cells()[j];
                if (cell._displayValue != null)
                    cell._displayValue();
            }
        }
    },

    _clearRows: function() {
        //Create the rows
        var table = this.get_element();
        for (var i = 0; i < table.rows.length; i++) {
            var row = new JData.FormViewRow(table.rows[i]);
            row.initialize();
            Array.add(this.get_rows(), row);
            row.set_visible(false);
            var style = this._GetRowStyle(row);
            row.applyStyle(style);
        }
    },

    initialize: function() {
        JData.FormView.callBaseMethod(this, 'initialize');

    },

    dispose: function() {
        JData.FormView.callBaseMethod(this, 'dispose');
    }
}
JData.FormView.registerClass('JData.FormView', JData.DataBoundTable);


//============================== FormViewRow ==============================

JData.FormViewRow = function(element) {
    JData.FormViewRow.initializeBase(this, [element]);

    this.set_rowType(JData.DataControlRowType.DataRow);
};
JData.FormViewRow.prototype = {

    get_dataItem: function() {
        return this._dataItem;
    },
    set_dataItem: function(value) {
        this._dataItem = value;
    },

    get_currentMode: function() {
        return this.get_parent().get_currentMode();
    },

    //======================= Methods =======================


    //===================== EVENTS =============================

    add_modeChanging: function(handler) {
        this.get_parent().get_events().addHandler('modeChanging', handler);
    },
    remove_modeChanging: function(handler) {
        this.get_parent().get_events().removeHandler('modeChanging', handler);
    },

    add_modeChanged: function(handler) {
        this.get_parent().get_events().addHandler('modeChanged', handler);
    },
    remove_modeChanged: function(handler) {
        this.get_parent().get_events().removeHandler('modeChanged', handler);
    },

    add_beginEdit: function(handler) {
        this.get_events().addHandler('beginEdit', handler);
    },
    remove_beginEdit: function(handler) {
        this.get_events().addHandler('beginEdit', handler);
    },

    add_cancleEdit: function(handler) {
        this.get_events().addHandler('cancleEdit', handler);
    },
    remove_cancleEdit: function(handler) {
        this.get_events().removeHandler('cancleEdit', handler);
    },

    add_commitEdit: function(handler) {
        this.get_events().addHandler('commitEidt', handler);
    },
    remove_commitEdit: function(handler) {
        this.get_events().removeHandler('commitEdit', handler);
    },

    add_endEdit: function(handler) {
        this.get_events().addHandler('endEdit', handler);
    },
    remove_endEdit: function(handler) {
        this.get_events().remove('endEdit', handler);
    },

    add_valueChanged: function(handler) {
        this.get_events().addHandler('valueChanged', handler);
    },
    remove_valueChanged: function(handler) {
        this.get_events().removeHandler('valueChanged', handler);
    },

    //========================================================

    _createCells: function() {
        Array.clear(this.get_cells());
        var gridView = this.get_parent();
        var columns = gridView.get_fields();
        for (var j = 0; j < this.get_element().cells.length; j++) {
            var col; // = columns[j];
            var htmlCell = this.get_element().cells[j];
            var str = new String(htmlCell.innerHTML).trim();
            if (str.startsWith('{:') && str.endsWith('}')) {
                var field = str.substr(2, str.length - 3);
                for (var i = 0; i < columns.length; i++) {
                    if (field == 'CommandField') {
                        if (JData.CommandField.isInstanceOfType(columns[i])) {
                            col = columns[i];
                            var style = this.get_parent().get_commandRowStyle()
                            this.applyStyle(style);
                            break;
                        }
                    }
                    else {
                        if (columns[i].get_dataField() == field) {
                            col = columns[i];
                            break;
                        }
                    }
                }
                if (col == null)
                    throw Error.create("Could not the '" + field + "' field. ");
                htmlCell.innerHTML = '';
                var cell = col._CreateCell(htmlCell);
                Array.add(this.get_cells(), cell);
            }
        }
    },

    //==========================================================

    initialize: function() {
        JData.FormViewRow.callBaseMethod(this, 'initialize');
        this._createCells();
    }
},

JData.FormViewRow.registerClass('JData.FormViewRow', JData.TableRow);


Type.registerNamespace('JData');

JData.BaseValidator = function() {

    this.set_errorMessage('Error Message.');
};

JData.BaseValidator.prototype = {

    get_errorMessage: function() {
        return this._errorMessage;
    },
    set_errorMessage: function(value) {
        this._errorMessage = value;
    },

    validate: function(value) {
        return false;
    }
};

JData.BaseValidator.registerClass('JData.BaseValidator');

//============================================= RequiredFieldValidator ===============================================

JData.RequiredFieldValidator = function() {

    JData.RequiredFieldValidator.initializeBase(this);

    this.set_message('This field is required.');
};

JData.RequiredFieldValidator.prototype = {
    validate: function(value) {
        if (value == null)
            return false;

        if (Object.getType(value) == String && value.trim().length == 0)
            return false;

        return true;
    }
};

JData.RequiredFieldValidator.registerClass('JData.RequiredFieldValidator', JData.BaseValidator);

//============================================= RequiredFieldValidator ===============================================

JData.RangeValidator = function() {
    JData.RangeValidator.initializeBase(this);
};

JData.RangeValidator.prototype = {

    get_maximumValue: function() {
        /// <returns type="Object">
        /// Get the maximum value of the validation range.
        /// </returns>
        return this._maximumValue;
    },
    set_maximumValue: function(value) {
        /// <param name="value">
        /// Set the maximum value of the validation range.
        /// </param>
        this._maximumValue = value;
    },

    get_minimumValue: function() {
        /// <returns type="Object">
        /// Get the minimum value of the validation range.
        /// </returns>
        return this._minimumValue;
    },
    set_minimumValue: function(value) {
        /// <param name="value">
        /// Set the minimum value of the validation range.
        /// </pram>
        this._minimumValue = value;
    },

    validate: function(value) {
        if (this.get_minimumValue() != null && value < this.get_minimumValue()) {
            var message = 'Please enter a value greater than or equal to ' + this.get_minimumValue() + '.';
            this.set_errorMessage(message);
            return false;
        }

        if (this.get_maximumValue() != null && value > this.get_maximumValue()) {
            var message = 'Please enter a value less than or equal to ' + this.get_maximumValue() + '.';
            this.set_errorMessage(message);
            return false;
        }

        return true;
    }

}

JData.RangeValidator.registerClass('JData.RangeValidator', JData.BaseValidator);

//============================================= RegularExpressionValidator ===============================================

JData.RegularExpressionValidator = function() {
};
if (typeof (Sys) !== 'undefined') Sys.Application.notifyScriptLoaded();

