﻿
Type.registerNamespace("WebApplication");

WebApplication.MAX_DEPTH = 4;

WebApplication.OrderMetaType = function(depth) {
	/// <field name="OrderID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="CustomerID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="EmployeeID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="OrderDate" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="RequiredDate" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShippedDate" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipVia" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Freight" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipAddress" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipCity" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipRegion" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipPostalCode" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ShipCountry" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="OrderDetails" type="WebApplication.OrderDetailMetaType" integer="false" static="false"/>
	/// <field name="Employee" type="WebApplication.EmployeeMetaType" integer="false" static="false"/>
	/// <field name="Customer" type="WebApplication.CustomerMetaType" integer="false" static="false"/>

	WebApplication.OrderMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.OrderID = new JData.MetaMember();
	this.OrderID.name('OrderID');
	this.OrderID.parent(this);
	this.OrderID.type('System.Int32')
	
	this.CustomerID = new JData.MetaMember();
	this.CustomerID.name('CustomerID');
	this.CustomerID.parent(this);
	this.CustomerID.type('System.String')
	
	this.EmployeeID = new JData.MetaMember();
	this.EmployeeID.name('EmployeeID');
	this.EmployeeID.parent(this);
	this.EmployeeID.type('System.Int32')
	
	this.OrderDate = new JData.MetaMember();
	this.OrderDate.name('OrderDate');
	this.OrderDate.parent(this);
	this.OrderDate.type('System.DateTime')
	
	this.RequiredDate = new JData.MetaMember();
	this.RequiredDate.name('RequiredDate');
	this.RequiredDate.parent(this);
	this.RequiredDate.type('System.DateTime')
	
	this.ShippedDate = new JData.MetaMember();
	this.ShippedDate.name('ShippedDate');
	this.ShippedDate.parent(this);
	this.ShippedDate.type('System.DateTime')
	
	this.ShipVia = new JData.MetaMember();
	this.ShipVia.name('ShipVia');
	this.ShipVia.parent(this);
	this.ShipVia.type('System.Int32')
	
	this.Freight = new JData.MetaMember();
	this.Freight.name('Freight');
	this.Freight.parent(this);
	this.Freight.type('System.Single')
	
	this.ShipName = new JData.MetaMember();
	this.ShipName.name('ShipName');
	this.ShipName.parent(this);
	this.ShipName.type('System.String')
	
	this.ShipAddress = new JData.MetaMember();
	this.ShipAddress.name('ShipAddress');
	this.ShipAddress.parent(this);
	this.ShipAddress.type('System.String')
	
	this.ShipCity = new JData.MetaMember();
	this.ShipCity.name('ShipCity');
	this.ShipCity.parent(this);
	this.ShipCity.type('System.String')
	
	this.ShipRegion = new JData.MetaMember();
	this.ShipRegion.name('ShipRegion');
	this.ShipRegion.parent(this);
	this.ShipRegion.type('System.String')
	
	this.ShipPostalCode = new JData.MetaMember();
	this.ShipPostalCode.name('ShipPostalCode');
	this.ShipPostalCode.parent(this);
	this.ShipPostalCode.type('System.String')
	
	this.ShipCountry = new JData.MetaMember();
	this.ShipCountry.name('ShipCountry');
	this.ShipCountry.parent(this);
	this.ShipCountry.type('System.String')
	
	this.Employee = new WebApplication.EmployeeMetaType(depth + 1);
	this.Employee.name('Employee');
	this.Employee.parent(this);
	this.Employee.type('Employee')
	
	this.Customer = new WebApplication.CustomerMetaType(depth + 1);
	this.Customer.name('Customer');
	this.Customer.parent(this);
	this.Customer.type('Customer')
	
}

WebApplication.OrderDetailMetaType = function(depth) {
	/// <field name="OrderID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ProductID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="UnitPrice" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Quantity" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Discount" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Order" type="WebApplication.OrderMetaType" integer="false" static="false"/>
	/// <field name="Product" type="WebApplication.ProductMetaType" integer="false" static="false"/>

	WebApplication.OrderDetailMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.OrderID = new JData.MetaMember();
	this.OrderID.name('OrderID');
	this.OrderID.parent(this);
	this.OrderID.type('System.Int32')
	
	this.ProductID = new JData.MetaMember();
	this.ProductID.name('ProductID');
	this.ProductID.parent(this);
	this.ProductID.type('System.Int32')
	
	this.UnitPrice = new JData.MetaMember();
	this.UnitPrice.name('UnitPrice');
	this.UnitPrice.parent(this);
	this.UnitPrice.type('System.Single')
	
	this.Quantity = new JData.MetaMember();
	this.Quantity.name('Quantity');
	this.Quantity.parent(this);
	this.Quantity.type('System.Int16')
	
	this.Discount = new JData.MetaMember();
	this.Discount.name('Discount');
	this.Discount.parent(this);
	this.Discount.type('System.Single')
	
	this.Order = new WebApplication.OrderMetaType(depth + 1);
	this.Order.name('Order');
	this.Order.parent(this);
	this.Order.type('Order')
	
	this.Product = new WebApplication.ProductMetaType(depth + 1);
	this.Product.name('Product');
	this.Product.parent(this);
	this.Product.type('Product')
	
}

WebApplication.ProductMetaType = function(depth) {
	/// <field name="ProductID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ProductName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="SupplierID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="CategoryID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="QuantityPerUnit" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="UnitPrice" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="UnitsInStock" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="UnitsOnOrder" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ReorderLevel" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Discontinued" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="OrderDetails" type="WebApplication.OrderDetailMetaType" integer="false" static="false"/>
	/// <field name="Category" type="WebApplication.CategoryMetaType" integer="false" static="false"/>

	WebApplication.ProductMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.ProductID = new JData.MetaMember();
	this.ProductID.name('ProductID');
	this.ProductID.parent(this);
	this.ProductID.type('System.Int32')
	
	this.ProductName = new JData.MetaMember();
	this.ProductName.name('ProductName');
	this.ProductName.parent(this);
	this.ProductName.type('System.String')
	
	this.SupplierID = new JData.MetaMember();
	this.SupplierID.name('SupplierID');
	this.SupplierID.parent(this);
	this.SupplierID.type('System.Int32')
	
	this.CategoryID = new JData.MetaMember();
	this.CategoryID.name('CategoryID');
	this.CategoryID.parent(this);
	this.CategoryID.type('System.Int32')
	
	this.QuantityPerUnit = new JData.MetaMember();
	this.QuantityPerUnit.name('QuantityPerUnit');
	this.QuantityPerUnit.parent(this);
	this.QuantityPerUnit.type('System.String')
	
	this.UnitPrice = new JData.MetaMember();
	this.UnitPrice.name('UnitPrice');
	this.UnitPrice.parent(this);
	this.UnitPrice.type('System.Single')
	
	this.UnitsInStock = new JData.MetaMember();
	this.UnitsInStock.name('UnitsInStock');
	this.UnitsInStock.parent(this);
	this.UnitsInStock.type('System.Int16')
	
	this.UnitsOnOrder = new JData.MetaMember();
	this.UnitsOnOrder.name('UnitsOnOrder');
	this.UnitsOnOrder.parent(this);
	this.UnitsOnOrder.type('System.Int16')
	
	this.ReorderLevel = new JData.MetaMember();
	this.ReorderLevel.name('ReorderLevel');
	this.ReorderLevel.parent(this);
	this.ReorderLevel.type('System.Int16')
	
	this.Discontinued = new JData.MetaMember();
	this.Discontinued.name('Discontinued');
	this.Discontinued.parent(this);
	this.Discontinued.type('System.Boolean')
	
	this.Category = new WebApplication.CategoryMetaType(depth + 1);
	this.Category.name('Category');
	this.Category.parent(this);
	this.Category.type('Category')
	
}

WebApplication.CategoryMetaType = function(depth) {
	/// <field name="CategoryID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="CategoryName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Description" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Picture" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Products" type="WebApplication.ProductMetaType" integer="false" static="false"/>

	WebApplication.CategoryMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.CategoryID = new JData.MetaMember();
	this.CategoryID.name('CategoryID');
	this.CategoryID.parent(this);
	this.CategoryID.type('System.Int32')
	
	this.CategoryName = new JData.MetaMember();
	this.CategoryName.name('CategoryName');
	this.CategoryName.parent(this);
	this.CategoryName.type('System.String')
	
	this.Description = new JData.MetaMember();
	this.Description.name('Description');
	this.Description.parent(this);
	this.Description.type('System.String')
	
	this.Picture = new JData.MetaMember();
	this.Picture.name('Picture');
	this.Picture.parent(this);
	this.Picture.type('System.Byte[]')
	
}

WebApplication.EmployeeMetaType = function(depth) {
	/// <field name="EmployeeID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="LastName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="FirstName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Title" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="TitleOfCourtesy" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="BirthDate" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="HireDate" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Address" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="City" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Region" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="PostalCode" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Country" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="HomePhone" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Extension" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Photo" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Notes" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ReportsTo" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="PhotoPath" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Employees" type="WebApplication.EmployeeMetaType" integer="false" static="false"/>
	/// <field name="Orders" type="WebApplication.OrderMetaType" integer="false" static="false"/>
	/// <field name="Employee1" type="WebApplication.EmployeeMetaType" integer="false" static="false"/>

	WebApplication.EmployeeMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.EmployeeID = new JData.MetaMember();
	this.EmployeeID.name('EmployeeID');
	this.EmployeeID.parent(this);
	this.EmployeeID.type('System.Int32')
	
	this.LastName = new JData.MetaMember();
	this.LastName.name('LastName');
	this.LastName.parent(this);
	this.LastName.type('System.String')
	
	this.FirstName = new JData.MetaMember();
	this.FirstName.name('FirstName');
	this.FirstName.parent(this);
	this.FirstName.type('System.String')
	
	this.Title = new JData.MetaMember();
	this.Title.name('Title');
	this.Title.parent(this);
	this.Title.type('System.String')
	
	this.TitleOfCourtesy = new JData.MetaMember();
	this.TitleOfCourtesy.name('TitleOfCourtesy');
	this.TitleOfCourtesy.parent(this);
	this.TitleOfCourtesy.type('System.String')
	
	this.BirthDate = new JData.MetaMember();
	this.BirthDate.name('BirthDate');
	this.BirthDate.parent(this);
	this.BirthDate.type('System.DateTime')
	
	this.HireDate = new JData.MetaMember();
	this.HireDate.name('HireDate');
	this.HireDate.parent(this);
	this.HireDate.type('System.DateTime')
	
	this.Address = new JData.MetaMember();
	this.Address.name('Address');
	this.Address.parent(this);
	this.Address.type('System.String')
	
	this.City = new JData.MetaMember();
	this.City.name('City');
	this.City.parent(this);
	this.City.type('System.String')
	
	this.Region = new JData.MetaMember();
	this.Region.name('Region');
	this.Region.parent(this);
	this.Region.type('System.String')
	
	this.PostalCode = new JData.MetaMember();
	this.PostalCode.name('PostalCode');
	this.PostalCode.parent(this);
	this.PostalCode.type('System.String')
	
	this.Country = new JData.MetaMember();
	this.Country.name('Country');
	this.Country.parent(this);
	this.Country.type('System.String')
	
	this.HomePhone = new JData.MetaMember();
	this.HomePhone.name('HomePhone');
	this.HomePhone.parent(this);
	this.HomePhone.type('System.String')
	
	this.Extension = new JData.MetaMember();
	this.Extension.name('Extension');
	this.Extension.parent(this);
	this.Extension.type('System.String')
	
	this.Photo = new JData.MetaMember();
	this.Photo.name('Photo');
	this.Photo.parent(this);
	this.Photo.type('System.Byte[]')
	
	this.Notes = new JData.MetaMember();
	this.Notes.name('Notes');
	this.Notes.parent(this);
	this.Notes.type('System.String')
	
	this.ReportsTo = new JData.MetaMember();
	this.ReportsTo.name('ReportsTo');
	this.ReportsTo.parent(this);
	this.ReportsTo.type('System.Int32')
	
	this.PhotoPath = new JData.MetaMember();
	this.PhotoPath.name('PhotoPath');
	this.PhotoPath.parent(this);
	this.PhotoPath.type('System.String')
	
	this.Employee1 = new WebApplication.EmployeeMetaType(depth + 1);
	this.Employee1.name('Employee1');
	this.Employee1.parent(this);
	this.Employee1.type('Employee')
	
}

WebApplication.CustomerMetaType = function(depth) {
	/// <field name="CustomerID" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="CompanyName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ContactName" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="ContactTitle" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Address" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="City" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Region" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="PostalCode" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Country" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Phone" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Fax" type="JData.MetaMember" integer="false" static="false"/>"
	/// <field name="Orders" type="WebApplication.OrderMetaType" integer="false" static="false"/>

	WebApplication.CustomerMetaType.initializeBase(this);

	if( depth == null) 
		depth = 0;
		
	if( depth >= WebApplication.MAX_DEPTH ) return;
	
	this.CustomerID = new JData.MetaMember();
	this.CustomerID.name('CustomerID');
	this.CustomerID.parent(this);
	this.CustomerID.type('System.String')
	
	this.CompanyName = new JData.MetaMember();
	this.CompanyName.name('CompanyName');
	this.CompanyName.parent(this);
	this.CompanyName.type('System.String')
	
	this.ContactName = new JData.MetaMember();
	this.ContactName.name('ContactName');
	this.ContactName.parent(this);
	this.ContactName.type('System.String')
	
	this.ContactTitle = new JData.MetaMember();
	this.ContactTitle.name('ContactTitle');
	this.ContactTitle.parent(this);
	this.ContactTitle.type('System.String')
	
	this.Address = new JData.MetaMember();
	this.Address.name('Address');
	this.Address.parent(this);
	this.Address.type('System.String')
	
	this.City = new JData.MetaMember();
	this.City.name('City');
	this.City.parent(this);
	this.City.type('System.String')
	
	this.Region = new JData.MetaMember();
	this.Region.name('Region');
	this.Region.parent(this);
	this.Region.type('System.String')
	
	this.PostalCode = new JData.MetaMember();
	this.PostalCode.name('PostalCode');
	this.PostalCode.parent(this);
	this.PostalCode.type('System.String')
	
	this.Country = new JData.MetaMember();
	this.Country.name('Country');
	this.Country.parent(this);
	this.Country.type('System.String')
	
	this.Phone = new JData.MetaMember();
	this.Phone.name('Phone');
	this.Phone.parent(this);
	this.Phone.type('System.String')
	
	this.Fax = new JData.MetaMember();
	this.Fax.name('Fax');
	this.Fax.parent(this);
	this.Fax.type('System.String')
	
}

WebApplication.OrderMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	},
	Employee : function() {
		/// <returns type="WebApplication.EmployeeMetaType"/>
		if(this._Employee == null){
			this._Employee = new WebApplication.EmployeeMetaType();
			this._Employee.name('Employee');
			this._Employee.parent(this);
			this._Employee.type('Employee');
		}
		return this._Employee
	}
	,
	Customer : function() {
		/// <returns type="WebApplication.CustomerMetaType"/>
		if(this._Customer == null){
			this._Customer = new WebApplication.CustomerMetaType();
			this._Customer.name('Customer');
			this._Customer.parent(this);
			this._Customer.type('Customer');
		}
		return this._Customer
	}
};

WebApplication.OrderMetaType.registerClass('WebApplication.OrderMetaType', JData.MetaType);

//=================================================================================

WebApplication.OrderDetailMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	},
	Order : function() {
		/// <returns type="WebApplication.OrderMetaType"/>
		if(this._Order == null){
			this._Order = new WebApplication.OrderMetaType();
			this._Order.name('Order');
			this._Order.parent(this);
			this._Order.type('Order');
		}
		return this._Order
	}
	,
	Product : function() {
		/// <returns type="WebApplication.ProductMetaType"/>
		if(this._Product == null){
			this._Product = new WebApplication.ProductMetaType();
			this._Product.name('Product');
			this._Product.parent(this);
			this._Product.type('Product');
		}
		return this._Product
	}
};

WebApplication.OrderDetailMetaType.registerClass('WebApplication.OrderDetailMetaType', JData.MetaType);

//=================================================================================

WebApplication.ProductMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	},
	Category : function() {
		/// <returns type="WebApplication.CategoryMetaType"/>
		if(this._Category == null){
			this._Category = new WebApplication.CategoryMetaType();
			this._Category.name('Category');
			this._Category.parent(this);
			this._Category.type('Category');
		}
		return this._Category
	}
};

WebApplication.ProductMetaType.registerClass('WebApplication.ProductMetaType', JData.MetaType);

//=================================================================================

WebApplication.CategoryMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	}};

WebApplication.CategoryMetaType.registerClass('WebApplication.CategoryMetaType', JData.MetaType);

//=================================================================================

WebApplication.EmployeeMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	},
	Employee1 : function() {
		/// <returns type="WebApplication.EmployeeMetaType"/>
		if(this._Employee1 == null){
			this._Employee1 = new WebApplication.EmployeeMetaType();
			this._Employee1.name('Employee1');
			this._Employee1.parent(this);
			this._Employee1.type('Employee');
		}
		return this._Employee1
	}
};

WebApplication.EmployeeMetaType.registerClass('WebApplication.EmployeeMetaType', JData.MetaType);

//=================================================================================

WebApplication.CustomerMetaType.prototype = {
	toString: function() {
	    var arr = new Array();
	    var p = this.parent();
	    while(p != null){
			if(p.name() != null)
				arr[arr.length] = p.name();
			p = p.parent();
	    }
	    arr[arr.length] = this.name();
	    return arr.join('.');
	}};

WebApplication.CustomerMetaType.registerClass('WebApplication.CustomerMetaType', JData.MetaType);

//=================================================================================

