﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Services;
using JData.Services;

namespace WebApplication
{
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    public class NorthwindServiceBase : DataContextService<NorthwindDatabase>
    {
    
        [WebMethod]
        public virtual QueryResult GetOrders(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<Order>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateOrder(Dictionary<string, object> item)
        {
            return base.Update<Order>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteOrder(Dictionary<string, object> item)
        {
            return base.Delete<Order>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertOrder(Dictionary<string, object> item)
        {
            var result = base.Insert<Order>(item);
            
            return result;
        }        
    
        [WebMethod]
        public virtual QueryResult GetOrderDetails(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<OrderDetail>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateOrderDetail(Dictionary<string, object> item)
        {
            return base.Update<OrderDetail>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteOrderDetail(Dictionary<string, object> item)
        {
            return base.Delete<OrderDetail>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertOrderDetail(Dictionary<string, object> item)
        {
            var result = base.Insert<OrderDetail>(item);
            
            return result;
        }        
    
        [WebMethod]
        public virtual QueryResult GetProducts(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<Product>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateProduct(Dictionary<string, object> item)
        {
            return base.Update<Product>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteProduct(Dictionary<string, object> item)
        {
            return base.Delete<Product>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertProduct(Dictionary<string, object> item)
        {
            var result = base.Insert<Product>(item);
            
			if(result.AffectedRowCount > 0)
			{
				result.Members = new { 
					ProductID = item["ProductID"] 
				};
			}
            return result;
        }        
    
        [WebMethod]
        public virtual QueryResult GetCategories(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<Category>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateCategory(Dictionary<string, object> item)
        {
            return base.Update<Category>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteCategory(Dictionary<string, object> item)
        {
            return base.Delete<Category>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertCategory(Dictionary<string, object> item)
        {
            var result = base.Insert<Category>(item);
            
			if(result.AffectedRowCount > 0)
			{
				result.Members = new { 
					CategoryID = item["CategoryID"] 
				};
			}
            return result;
        }        
    
        [WebMethod]
        public virtual QueryResult GetEmployees(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<Employee>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateEmployee(Dictionary<string, object> item)
        {
            return base.Update<Employee>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteEmployee(Dictionary<string, object> item)
        {
            return base.Delete<Employee>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertEmployee(Dictionary<string, object> item)
        {
            var result = base.Insert<Employee>(item);
            
			if(result.AffectedRowCount > 0)
			{
				result.Members = new { 
					EmployeeID = item["EmployeeID"] 
				};
			}
            return result;
        }        
    
        [WebMethod]
        public virtual QueryResult GetCustomers(int skip, int take, string sorting, string filter, string selector,
														  bool retrieveTotalRowCount, int totalRowCount)
        {
            return base.Query<Customer>(skip, take, sorting, filter, selector, retrieveTotalRowCount, totalRowCount);
        }
        
        [WebMethod]
        public virtual ExecuteResult UpdateCustomer(Dictionary<string, object> item)
        {
            return base.Update<Customer>(item);
        }
        
        [WebMethod]
        public virtual ExecuteResult DeleteCustomer(Dictionary<string, object> item)
        {
            return base.Delete<Customer>(item);
        }        
        
        [WebMethod]
        public virtual ExecuteResult InsertCustomer(Dictionary<string, object> item)
        {
            var result = base.Insert<Customer>(item);
            
            return result;
        }        

	}
}